/*****************************************************************************
*                               Faked directory                              *
******************************************************************************
  Written by : Gunny      
  Version    : 1.09
  Last update: 10.11.1999
*****************************************************************************/

/*
slouzi k otevreni souboru 'sbaleneho' do '.diru'
fakelen vraci delku naposledy fakeopenuteho podsouboru =)

Sezere jak FakeDir (kratke nazvy), tak novejsi FakeToo (nazvy do 32 znaku).
*/
#include <stdio.h>
#include <io.h>
#include <string.h>

#include "types8.h"
#include "exceptions.h"
#include "fakedir.h"

static long fakelength;
static long fakeposition;

FILE *fakeopen(const char *fakename, const char *filename, const char *mode)
{
   FILE *dir;
   char item[42]; // buffer na nacitani hlavicek souboru
   long *pos;     // pointer na pozici (do item)
   long *len;     // pointer na delku  (do item)
   int  reclen;   // delka zaznamu
   int  count = 0;    // pocet zaznamu ve fakediru
   
   if ((dir = fopen(filename,mode)) != NULL)
      return dir;

   char *fname = strrchr(filename,'\\');
   if (fname == NULL)
   {
      fname = (char *) filename;
   }
   else
      fname++;

   // tak jdeme na to!
   fakeposition = 0;
   // otevru fakedir
   dir = fopen(fakename,"rb");
   if (dir)
   {
      // jaky je to tedy soubor?
      if (fread(item,7,1,dir))
      {
         if (item[0]=='F' && item[1]=='a' && item[2]=='k' && item[3]=='e')
         { // je to fakedir, mozno postupovat dale k vychodu
            if (item[4]=='T')
            {
               // je to FakeToo
               pos = (long*)(&item[33]);
               len = (long*)(&item[37]);
               reclen = 41;
            }
            else
            {
               // zrejme stary FakeDir (nebo FakeLumi?)
               pos = (long*)(&item[13]);
               len = (long*)(&item[17]);
               reclen = 21;
            }
            
            // kolik je zaznamu?
            if (!fread(&count,2,1,dir))
            {
               count = 0;
            }           
            
            fseek(dir,10,SEEK_SET);
            // zenu se po jednotlivych hlavickach
            for (int i=0; i<count; i++)
            {
               if (!fread(item,reclen,1,dir))
               { // eof!
                  i = count;
               }
               if (stricmp(item,fname)==0)
               { // to je muj soubor!
                  fakelength = *len;
                  fakeposition = *pos;
                  i = count;
               }
            }
         }
      }
      fclose(dir);
   }
     
   // tad uz jenom vratim, co jsem zjistil
   if (fakeposition)
   {
      dir = fopen(fakename,mode);
      if (fseek(dir,fakeposition,SEEK_SET))
      { // seek nevysel! eof! nekdo ukousnul konec souboru!
         fclose(dir);
         dir = NULL;
      }
   }
   else dir = NULL;
   
   return dir;
}

long fakelen()
{
   return fakelength;
}
