/*************************************************************************
//                              Score labels                              
//*************************************************************************
//  Written by : Rory & Gunny
//*************************************************************************
	Changes:

   2010-10-04	/ zdn graviace a rozplvn
	2010-02-07	/ rozkopno na pouvn vertexbufferu
	1.0.1  - snaha o prvni plnou verzi
	0.99.3 - uprava na sektorove clearovani

*/

#include <string.h>
#include "consts.h"
#include "types8.h"
#include "exceptions.h"
#include "utils.h"
#include "dx8graph.h"
#include "font8.h"
#include "gs_game.h"
#include "application.h"
#include "score.h"


//===========================================================================
ScoreList::ScoreList(Font8 *ifont)
{
	font = ifont;
	count = 0;
	lpVertexBuffer = NULL;
	dx8.lpd3dDevice->CreateVertexBuffer(SCLIST_MAXCOUNT*SCLABEL_LEN*6*sizeof(BVERTEX), 0, (D3DFVF_BVERTEX), D3DPOOL_MANAGED ,&lpVertexBuffer); //6 vertexu na jeden znak
}

//===========================================================================
ScoreList::~ScoreList()
{
	if (lpVertexBuffer!=NULL) lpVertexBuffer->Release();
}

//===========================================================================
void ScoreList::Add(int x, int y, DWORD icolor, int sc_value)
{
	if (count == SCLIST_MAXCOUNT) 
		return;

	list[count].x = x;
	list[count].y = y;
	list[count].bigy = y;
	list[count].bigy <<= 14;
	list[count].color = icolor;
	list[count].alpha = 1024;

   int charcnt;
   char s[5];  

   if (sc_value == 0)
      return;

   // vypocet poctu cislic
   __asm 
   {
      xor edx,edx
      mov eax, sc_value
      mov ebx,10
      mov ecx,0
   }
Loop1:
   __asm 
   {
      div ebx
      inc ecx
      xor edx,edx
      or eax,eax
      jnz Loop1
   
      mov charcnt, ecx
   }

   if (charcnt > SCLABEL_LEN)
      charcnt = SCLABEL_LEN;

   numtos(sc_value,charcnt,s);
	strncpy(list[count].svalue, s, SCLABEL_LEN);
	count++;
}

//===========================================================================
void ScoreList::RemoveAll()
// nic nealokuju, staci zrusit pocitadlo
{
	count = 0;
}

//===========================================================================
void ScoreList::Paint()
// vykresli vsechny existujici scorelabels
{
   for (int i=0; i<count; i++)
   {
		// alpha je max 1024 tj. 10 bitu
		DWORD alp = list[i].alpha;
		alp = (alp << 22) | 0x00ffffff;
		font->Print(dx8.CoordX(list[i].x),dx8.CoordY(list[i].y),list[i].svalue,list[i].color & alp,ALIGN_CENTER,255, 
			(int)(dx8.coefy*(26-(list[i].alpha/56)))); //44-(list[i].alpha/40) // alfa je max 1024, takze 44 a 40 davaji rozsah od 18 po 44
   }
}

//===========================================================================
void ScoreList::Move()
//posachuje a pripadne vyhodi
{
   for (int i=0; i<count; i++)
   {
		// snizime pruhlednost/zivotnost
		list[i].alpha -= 2;

		// cas od casu posuneme
		list[i].bigy -= list[i].alpha * 4;
		list[i].y = list[i].bigy >> 14;

		// jeste je videt?
      if (list[i].alpha <=0)
      // vybledlo - zrusit
      {
         count--;
         list[i]=list[count];
         i--;
      }
   }
}
