/***************************************************************************
                              Sheet structure                              
***************************************************************************
  Written by : Vojvo & Gunny
  Language   : VisuC6 + DX8
***************************************************************************
 changes
 2010-09-26 / pedvn barvy
 2008-06-23 / u ivot numtos pedlno voliteln na dv msta
 2008-06-23 / istka kvli DX8 (zmizelo _changed a pibylo strlives...)
 1.0.1  - snaha o prvni plnou verzi
 0.10.1 - pridan scorefont pro scorelabely, klasicky se pouziva na 
          zivot za 20000 (caused bug)
        - score chraneno maximalni hodnotou
 0.7.1 - upraveny changed z 0/1 na 0-2, kvuli obnove na obou bufferech
       - z tehoz duvodu rozdeleno na score_changed a energy_changed
*/

#include "gs_game.h"
#include "score.h"
#include "sheet.h"

#define SCORE2LIFE 20000

//==========================================================================
void PSheet::AddPoints(DWORD amount, DWORD x, DWORD y)
{
   amount *= koef;
   score += amount;
   if (score > 99999999L)
      score = 99999999L;
   if (x < 0)
      x = 0;
   if (x != 9999)
   {
      //add_score_label(x,y,amount,fonts[2]);
		score_labels->Add(x,y,colormask, amount);
   }
   
   DWORD new2life = score / SCORE2LIFE;
   if (new2life > old2life)
   {
      /* score boundary for life reward */
      if (player1->sheet.AddLives((BYTE)(new2life-old2life)))
      {
         message.Set("ivot za 20000", colormask);
      }
      old2life = new2life;
   }
   numtos(score,8,strscore);
   
	return;
}

//==========================================================================
int PSheet::AddLives(BYTE num)
{
   if (lives >= MAX_LIVES)
   {
      return 0;
   }
   int oldlives = lives;
   lives+=num;
   if ((oldlives == 0) && (lives > 0))
   {
      if (player1->state & NOTTAKEN)
      {
         player1->state &= ~DEAD;
         player1->zoom = 0; // asi by se to korektn mlo oetit sp jinde, ale co u...
         //ARRAY_ADD(monsters,monsters_ctrl,player1);
      }
      else if (player2->state & NOTTAKEN)
      {
         player2->state &= ~DEAD;
         player2->zoom = 0;
         //ARRAY_ADD(monsters,monsters_ctrl,player2);
      }
   }
	UpdateView();
	
   return lives;
}

//==========================================================================
void PSheet::UpdateView()
{
   //numtos(lives,1,strlives);
	int i = 0;
	if ((lives / 10) > 0)
	{
		strlives[i] = '0'+(lives / 10) % 10;
		i++;
	}
	strlives[i] = '0'+(lives % 10);
	i++;
	strlives[i] = 0;
}
