#ifndef APPLICATION_H_BUBWINY
#define APPLICATION_H_BUBWINY

#include <ddraw.h>
#include "consts.h"
#include "types8.h"
#include "gs_gamestage.h"
#include "gs_game.h"
#include "gs_menu.h"

class Application {
   static const char *szAppName;
   static const char *szWCName;

   HWND m_hWnd;
   HINSTANCE m_hInstance;
   RECT m_rcDispArea;
   bool m_bDDActive;
   bool m_bInitialized;
   char m_szDataDir[128];
   int state;
   GameStage *stage;
   Game *game;
   Menu *menu;
   bool destroyed;
   long vol;
 
public:
   Application();
	
   bool initInstance(HINSTANCE hInstance, LPSTR lpCmdLine, int nCmdShow, 
      WNDPROC lpWndProc);
   void destroyInstance();
   void update();
   void unload();

   HWND getMainWindow() { return m_hWnd; };
   void stateChange(int reason = REASON_DEFAULT);
   void readRegistry();
   void writeRegistry();

   void onActivateApp(HWND hWnd, WPARAM wParam, LPARAM lParam);
   void onSetCursor(HWND hWnd, WPARAM wParam, LPARAM lParam);
   void onKeyDown(HWND hWnd, WPARAM wParam, LPARAM lParam);

   ~Application() { destroyInstance(); };

   friend class Menu;
   friend class Game;
   friend void CheckValidKeys();
};

extern Application *app;

#endif
