#include <windows.h>
#include <vfw.h>
#include "application.h"


/* dopredne deklarace */
long FAR PASCAL WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

/* globalni promenne */
MSG msg;

//-------------------------------------------------------------------------
// WinMain
//-------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
   app = new Application();
   app->readRegistry();
   if (!app->initInstance(hInstance,lpCmdLine,nCmdShow,WindowProc))
      return FALSE;

	// handle messages
	while(TRUE)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
      {
			if (!GetMessage(&msg,NULL,0,0))
				break;
			TranslateMessage(&msg);
         DispatchMessage(&msg);
      }
      else 
      {
         app->update();
      }
   }
   
   DestroyWindow(app->getMainWindow());
   
   app->writeRegistry();

   delete app;
   DEBUG_MESSAGE("App deleted.\n");
	
   return TRUE;
}

//----------------------------------------------------------------------------
//  WindowProc
//----------------------------------------------------------------------------
long FAR PASCAL WindowProc(HWND hWnd,UINT  uMsg,WPARAM  wParam,LPARAM  lParam)
{
   switch (uMsg)
   {
   case WM_ACTIVATEAPP:
      app->onActivateApp(hWnd,wParam,lParam);
      return 0L;
   case WM_KEYDOWN:
      app->onKeyDown(hWnd,wParam,lParam);
      return 0L;
   case WM_SETCURSOR:
      app->onSetCursor(hWnd,wParam,lParam);
      return TRUE; 
   case WM_DESTROY:
      PostQuitMessage(0);
      return 0L;
   case MCIWNDM_NOTIFYMODE:
//      app->onAVIMode(hWnd,wParam,lParam);
      return 0L;
   }
                
   return DefWindowProc(hWnd,uMsg,wParam,lParam);
}               

