/*
   DX8Graph
   Gunny of Eriador
   funkce pro prci s 2D akcelerovanou grafikou v DX8
   (napsno s vyuitm ukzkovch program George Geczyho)
   (a samozejm nkter pase jsou inspirovan dx7 od Vojva)

  stav:
   tak, jak je, by mla bt funkn, ale asi bude teba jet nco pipsat a upravit

  todo:
   ovit, kde se pouv d3d_dwBMask - nestailo by d3d_wBMask? 
   - zatim pretypovano, DWORD je pro pripadne pouziti pro 24 nebo 32

   2006-06-25  / picnum se ++ dvakrt, take se shot ukldal ob jedno slo
   2006-06-22  / opraveno hledn jmna pro screenshot
					/ BltBack m navc D3DCOLOR
   2006-06-21  / pro zjednoduen voln pihozen BltBack (nen pln ideln)
   15. 3. 2003 / upraveno filtrovn vga mod do modesxx
    4. 3. 2003 / modelist rozdlen na modes16 a modes32
   24. 2. 2003 / pouziteln grafick reimy si ukldm do modelistu
   23. 2. 2003 / na define pribylo ukladani reportu o grafickych rezimech
   26. 1. 2003 / pedlno pidlovn jmen screenshotm
   18. 1. 2003 / D3DPRESENTFLAG_LOCKABLE_BACKBUFFER kvli screenshotu
   12.11. 2002 / rozepsan screenshot
    4. 5. 2002 / CheckFormats me ukldat do souboru report (co se d pout)
   13. 1. 2002 / init si nastavuje daje o jednotlichch kanlech a bitovch maskch
   12. 1. 2002 / mrn upraven init (pidan extern promnn)
   30. 9. 2001 / pidan kostra kdu pro Reset()
   27. 9. 2001 / pekopan pro reinicializaci po lostdevice (asi)  
    8. 9. 2001 / pidan mode a "tabulka" pouitelnch formt textur
   22. 7. 2001 / rozepsan prvn verze
*/

#include "stdio.h"
#include "dx8graph.h"

#include "exceptions.h"
#include "types8.h"
#include "utils.h"


DX8Graph dx8;

HRESULT ddResult = 0;

int d3d_ibpp;
BYTE d3d_bABits;
BYTE d3d_bRBits;
BYTE d3d_bGBits;
BYTE d3d_bBBits;
DWORD d3d_dwAMask;
DWORD d3d_dwRMask;
DWORD d3d_dwGMask;
DWORD d3d_dwBMask;
DWORD d3d_dwColorKey;


//----------------------------------------------------------------------------
// Init() : Initializes Direct3D
//----------------------------------------------------------------------------
HRESULT DX8Graph::Init(HWND hWnd, DWORD width, DWORD height, D3DFORMAT format, DWORD refreshrate, bool windowed)
{
   // Create the D3D object, which is needed to create the D3DDevice.
   if( ( lpD3D = Direct3DCreate8( D3D_SDK_VERSION ) ) == NULL )
      return E_FAIL;
   
   // Parameters for the D3DDevice. Most parameters are zero'd out.
   ZeroMemory( &d3dpp, sizeof(d3dpp) );
   d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
   d3dpp.Flags = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;

	// at mm trochu prehled, tak zjistim, co je nastavene ted
	// Get the current desktop display mode
	if( FAILED(lpD3D->GetAdapterDisplayMode( D3DADAPTER_DEFAULT,&d3ddm )))
		return E_FAIL;
	
   // jsou predane nejake rozumne parametry?
   // jestli ne, tak se zkusi default rezim plochy
   if (width==0 || height==0 || format==D3DFMT_UNKNOWN)
   {
      d3dpp.BackBufferWidth = d3ddm.Width;
      d3dpp.BackBufferHeight = d3ddm.Height;
      d3dpp.BackBufferFormat = d3ddm.Format;
   }
   else
   {
      d3dpp.BackBufferWidth = width;
      d3dpp.BackBufferHeight = height;
      d3dpp.BackBufferFormat = format;
      //
		d3ddm.Width = width;
		d3ddm.Height = height;
      d3ddm.Format = format;
		//d3ddm.RefreshRate mam zjistene z getadapterdisplay
   }

   if (windowed != TRUE)
   {
      d3dpp.FullScreen_RefreshRateInHz = refreshrate;
   }
   else
   {
      d3dpp.Windowed = TRUE;
   }
   
   // Create the Direct3D device, using the default adapter (most systems 
   // only have one, unless they have multiple graphics hardware cards
   // installed). See SDK for more details on other options here.
   if( FAILED(lpD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,D3DCREATE_SOFTWARE_VERTEXPROCESSING,&d3dpp, &lpd3dDevice ) ) )
   {
      lpd3dDevice = NULL;
      return E_FAIL;
   }
   
   // Device state would normally be set here
   
   // vytvorim si objekt na praci se sprajty
   if ( FAILED(D3DXCreateSprite(lpd3dDevice,&(lpd3dxSprite))) )
      return E_FAIL;

   // nastavim si "zkratky" uzitecnych parametru rezimu
   if (d3dpp.BackBufferFormat == D3DFMT_R8G8B8)
   { // melo by ukladat po bajtech BGR
      d3d_ibpp = 24;
      d3d_bABits = 0;
      d3d_bRBits = 8;
      d3d_bGBits = 8;
      d3d_bBBits = 8;
      d3d_dwAMask = 0;
      d3d_dwRMask = 0xff0000;
      d3d_dwGMask = 0xff00;
      d3d_dwBMask = 0xff;
      d3d_dwColorKey = COLOR_KEY888;
   }   
   else if (d3dpp.BackBufferFormat == D3DFMT_A8R8G8B8)
   {
      d3d_ibpp = 32;
      d3d_bABits = 8;
      d3d_bRBits = 8;
      d3d_bGBits = 8;
      d3d_bBBits = 8;
      d3d_dwAMask = 0xff000000;
      d3d_dwRMask = 0xff0000;
      d3d_dwGMask = 0xff00;
      d3d_dwBMask = 0xff;
      d3d_dwColorKey = COLOR_KEY888;
   }
   else if (d3dpp.BackBufferFormat == D3DFMT_X8R8G8B8)
   {
      d3d_ibpp = 32;
      d3d_bABits = 0;
      d3d_bRBits = 8;
      d3d_bGBits = 8;
      d3d_bBBits = 8;
      d3d_dwAMask = 0;
      d3d_dwRMask = 0xff0000;
      d3d_dwGMask = 0xff00;
      d3d_dwBMask = 0xff;
      d3d_dwColorKey = COLOR_KEY888;
   }
   else if (d3dpp.BackBufferFormat == D3DFMT_A1R5G5B5)
   {
      d3d_ibpp = 15;
      d3d_bABits = 1;
      d3d_bRBits = 5;
      d3d_bGBits = 5;
      d3d_bBBits = 5;
      d3d_dwAMask = 0x8000;
      d3d_dwRMask = 0x7c00;
      d3d_dwGMask = 0x03e0;
      d3d_dwBMask = 0x001f;
      d3d_dwColorKey = COLOR_KEY555;
   }
   else if (d3dpp.BackBufferFormat == D3DFMT_R5G6B5)
   {
      d3d_ibpp = 16;
      d3d_bABits = 0;
      d3d_bRBits = 5;
      d3d_bGBits = 6;
      d3d_bBBits = 5;
      d3d_dwAMask = 0;
      d3d_dwRMask = 0xf800;
      d3d_dwGMask = 0x07e0;
      d3d_dwBMask = 0x001f;
      d3d_dwColorKey = COLOR_KEY565;
   }

   // zjistim, jake formaty textur jsou pouzitelne 
   CheckFormats();

   //*** tohle by mozna mohlo prijit az jako volitelna polozka
   // je to treba jen v pripade, ze user bude chtit menit rozliseni
   GetModeList();

	// nastavim si promenne s velikostmi obrazovky
	sizex = d3dpp.BackBufferWidth;
	sizey = d3dpp.BackBufferHeight;
	centerx = sizex / 2;
	centery = sizey / 2;

	coefx = (float)sizex / 640;
	if ((float)sizex/(float)sizey >= 1.6)
	{
		wide = 1;
		coefy = (float)sizey / 400;
	}
	else
		coefy = (float)sizey / 480;

	if (!wide)
	{
	   mcoefx = coefx;
	   mcoefy = coefy;
	}
	else
	{
	   mcoefx = coefx * 0.83; // 400/480;
	   mcoefy = coefy * 0.83;
	}

	tilesize = (DWORD)(20 * coefx);

   return S_OK;
}

//----------------------------------------------------------------------------
// coordx - funkce na pepoet z klasickch bublinovch souadnic na promnn
//----------------------------------------------------------------------------
long DX8Graph::CoordX(long in)
{
	double tmp = in;
	tmp *= coefx;
	return (long)tmp;
}

//----------------------------------------------------------------------------
// coordy - funkce na pepoet z klasickch bublinovch souadnic na promnn
//----------------------------------------------------------------------------
long DX8Graph::CoordY(long in)
{
	double tmp = in;
	if (wide) tmp -= 40;
	tmp *= coefy;
	return (long)tmp;
}

//----------------------------------------------------------------------------
// coord - funkce na pepoet z klasickch bublinovch souadnic na promnn
//----------------------------------------------------------------------------
RECT DX8Graph::Coord(RECT in)
{
	RECT out;
	out.left = CoordX(in.left);
	out.right = CoordX(in.right);
	out.top = CoordY(in.top);
	out.bottom = CoordY(in.bottom);
	return out;
}

//----------------------------------------------------------------------------
// Cleanup() : Releases all previously initialized objects
//----------------------------------------------------------------------------
void DX8Graph::Close()
{
   SAFE_RELEASE(lpd3dxSprite);
   //if (lpd3dxSprite)      lpd3dxSprite->Release();

   //DeleteDeviceObjects();
	// nema cenu volat - maze se tam texturemamager, ktery uz je stejn fuc

   SAFE_RELEASE(lpd3dDevice); 
   /*
   if (lpd3dDevice) 
   {
      lpd3dDevice->Release();
      lpd3dDevice=NULL;
   }
   */
   
   SAFE_RELEASE(lpD3D); 
   /*
   if (lpD3D)
   {
      lpD3D->Release();
      lpD3D=NULL;
   }
   */
   
   
}

/*----------------------------------------------------------------------------
   Reset
   release + restore
----------------------------------------------------------------------------*/
void DX8Graph::Reset()
{
   ReleaseDeviceObjects();
   lpd3dDevice->Reset(&d3dpp);
   RestoreDeviceObjects();
}


/*----------------------------------------------------------------------------
   RestoreDeviceObject
   obnov vci, kter byly znien bhem invalidate
----------------------------------------------------------------------------*/
HRESULT DX8Graph::RestoreDeviceObjects()
{
   //HRESULT hr;
   if ( FAILED(D3DXCreateSprite(lpd3dDevice,&(lpd3dxSprite))) )
      return E_FAIL;
   // managed textury neni treba resit
   // texturemanager->RestoreAll();
   return S_OK;
}


/*----------------------------------------------------------------------------
   ReleaseDeviceObject
   zlikviduje vci v pamti, aby se dal udlat reset 
----------------------------------------------------------------------------*/
HRESULT DX8Graph::ReleaseDeviceObjects()
{
   //HRESULT hr;
   // managed textury neni treba resit
   // texturemanager->ReleaseAll();
   SAFE_RELEASE(lpd3dxSprite);
   return S_OK;
}


/*----------------------------------------------------------------------------
   DeleteDeviceObject
   vymae vechny veci (az na konci vseho)
----------------------------------------------------------------------------*/
HRESULT DX8Graph::DeleteDeviceObjects()
{
   //HRESULT hr;
	//*** pro by se to vbec mlo volat, kdy se texturemanager zru v destruktoru?
   if (texturemanager)
		texturemanager->DeleteAll();
   return S_OK;
}


//----------------------------------------------------------------------------
// CheckFormats() : Nastavuje priznaky, ktere formaty jsou pouzitelne
//----------------------------------------------------------------------------
void DX8Graph::CheckFormats()
{
   HRESULT hr;
   
   // D3DFMT_A8R8G8B8
   hr = lpD3D->CheckDeviceFormat (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, 
                                 d3ddm.Format,0, D3DRTYPE_TEXTURE, D3DFMT_A8R8G8B8);
   fmt_status[FMT_A8R8G8B8] = SUCCEEDED(hr);

   // D3DFMT_R8G8B8
   hr = lpD3D->CheckDeviceFormat (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, 
                                 d3ddm.Format,0, D3DRTYPE_TEXTURE, D3DFMT_R8G8B8);
   fmt_status[FMT_R8G8B8] = SUCCEEDED(hr);

   // D3DFMT_A1R5G5B5
   hr = lpD3D->CheckDeviceFormat (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, 
                                 d3ddm.Format,0, D3DRTYPE_TEXTURE, D3DFMT_A1R5G5B5);
   fmt_status[FMT_A1R5G5B5] = SUCCEEDED(hr);

   // D3DFMT_A4R4G4B4
   hr = lpD3D->CheckDeviceFormat (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, 
                                 d3ddm.Format,0, D3DRTYPE_TEXTURE, D3DFMT_A4R4G4B4);
   fmt_status[FMT_A4R4G4B4] = SUCCEEDED(hr);

   // D3DFMT_R5G6B5
   hr = lpD3D->CheckDeviceFormat (D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, 
                                 d3ddm.Format,0, D3DRTYPE_TEXTURE, D3DFMT_R5G6B5);
   fmt_status[FMT_R5G6B5] = SUCCEEDED(hr);

   /*
   FILE *f;
   f=fopen("formats.txt","at");
   fprintf(f,"\n***\n");
   fprintf(f,"FMT_A8R8G8B8 %i\n",fmt_status[FMT_A8R8G8B8]);
   fprintf(f,"FMT_R8G8B8   %i\n",fmt_status[FMT_R8G8B8]);
   fprintf(f,"FMT_A1R5G5B5 %i\n",fmt_status[FMT_A1R5G5B5]);
   fprintf(f,"FMT_A4R4G4B4 %i\n",fmt_status[FMT_A4R4G4B4]);
   fprintf(f,"FMT_R5G6B5   %i\n",fmt_status[FMT_R5G6B5]);
   fclose(f);
   */

}


//----------------------------------------------------------------------------
// BltSprite() : A replacement of the DirectDraw Blt() function for Direct3D8
// Supports DDBLTFX_MIRRORLEFTRIGHT and DDBLTFX_MIRRORUPDOWN
// If pDestRect is NULL, copies it to the same co-ord as src
// If pSrcRect is NULL, copies the entire texture
//----------------------------------------------------------------------------
HRESULT DX8Graph::BltSprite(RECT *pDestRect, Texture pSrcTexture, 
                  RECT *pSrcRect, DWORD dwFlags,  D3DCOLOR modulate)
{
   D3DXVECTOR2 scaling(1,1), rcenter(0,0), trans(0,0);
   
   // Set the parameters - translation (screen location)
   if (pDestRect) {
      trans.x = (float) pDestRect->left;
      trans.y = (float) pDestRect->top;
   } 
   // Scaling - If Source & Destination are different size rects, then scale
   if (pDestRect && pSrcRect) {
      scaling.x = ((float) (pDestRect->right - pDestRect->left)) / 
         ((float) (pSrcRect->right - pSrcRect->left));
      scaling.y = ((float) (pDestRect->bottom - pDestRect->top)) / 
         ((float) (pSrcRect->bottom - pSrcRect->top));
   }
   /*
   // Handle the flags - need to change scaling & adjust translation
   if (pSrcRect && dwFlags) {
   if (dwFlags&DDBLTFX_MIRRORLEFTRIGHT) { 
   scaling.x = -scaling.x; 
   trans.x += (float) (pDestRect->right - pDestRect->left); 
   }
   if (dwFlags&DDBLTFX_MIRRORUPDOWN) { 
   scaling.y = -scaling.y; 
   trans.y += (float) (pDestRect->bottom - pDestRect->top); 
   }
   }
   */
   
   // And here we go:
   return (lpd3dxSprite->Draw(pSrcTexture, pSrcRect, &scaling, 
      &rcenter, 0, &trans, modulate ));
   
}

//----------------------------------------------------------------------------
// BltSpriteEx() : A replacement of the DirectDraw Blt() function for Direct3D8
// Supports DDBLTFX_MIRRORLEFTRIGHT and DDBLTFX_MIRRORUPDOWN,
// modulate is color/alpha modifier
// rotation is value of rotation in RADIANS, counter-clockwise
// prcenter is the rotation centre point of the obj, or NULL
// If pDestRect is NULL, copies it to the same co-ord as src
// If pSrcRect is NULL, copies the entire texture
//----------------------------------------------------------------------------
HRESULT DX8Graph::BltSpriteEx( RECT *pDestRect, Texture pSrcTexture, 
                    RECT *pSrcRect, DWORD dwFlags, D3DCOLOR modulate, 
                    float rotation, POINT *prcenter)
{
   D3DXVECTOR2 scaling(1,1), rcenter(0,0), trans(0,0); 
   
   // Set the parameters - translation (screen location)
   if (pDestRect) {
      trans.x = (float) pDestRect->left;
      trans.y = (float) pDestRect->top;
   } 
   // Rotation Center
   if (prcenter) {
      rcenter.x = (float) prcenter->x;
      rcenter.y = (float) prcenter->y;
   } else if (pSrcRect) {
      // Set Rotation Center to be object center if none provided
      rcenter.x = (float) (pSrcRect->right - pSrcRect->left) / 2;
      rcenter.y = (float) (pSrcRect->bottom - pSrcRect->top) / 2;
   }
   // Scaling - If Source & Destination are different size rects, then scale
   if (pDestRect && pSrcRect) {
      scaling.x = ((float) (pDestRect->right - pDestRect->left)) / 
         ((float) (pSrcRect->right - pSrcRect->left));
      scaling.y = ((float) (pDestRect->bottom - pDestRect->top)) / 
         ((float) (pSrcRect->bottom - pSrcRect->top));
   }
   // Handle the flags - need to change scaling & adjust translation
   /*
   if (pSrcRect && dwFlags) {
   if (dwFlags&DDBLTFX_MIRRORLEFTRIGHT) { 
   scaling.x = -scaling.x; 
   trans.x += (float) (pDestRect->right - pDestRect->left); 
   }
   if (dwFlags&DDBLTFX_MIRRORUPDOWN) { 
   scaling.y = -scaling.y; 
   trans.y += (float) (pDestRect->bottom - pDestRect->top); 
   }
   }
   */
   
   // And here we go:
   return lpd3dxSprite->Draw( pSrcTexture, pSrcRect, &scaling, 
      &rcenter, rotation, &trans, modulate );
   
}


//----------------------------------------------------------------------------
// BltMotionBlur() - pomocn funkce
//----------------------------------------------------------------------------
HRESULT DX8Graph::BltMotionBlur(RECT *pNewRect, RECT *pOldRect, Texture pSrcTexture, 
                  RECT *pSrcRect, DWORD dwFlags,  D3DCOLOR modulate)
{
	// pokus o motion blur

	HRESULT res;
	RECT blur;

	
	long moved = sqrt((pNewRect->left-pOldRect->left)*(pNewRect->left-pOldRect->left) + (pNewRect->top-pOldRect->top)*(pNewRect->top-pOldRect->top));

	if ((moved<40) && (moved>1))
	{
		// posun je dost velky, ale neni to nejak teleport

		// omezme jemnost rozmazn
		if (moved>8) moved = 8;

		/*
		// vypis na obrazovku
		char rep[10] = "00";
		char vr = (char)moved;
		rep[1] += vr%10;
		rep[0] += vr/10;
		fonts[1]->Print(r.left,r.top-10,rep,0xffffffff,ALIGN_CENTER, 255, dx8.tilesize / 2);
		*/
		
		int steps = moved;
		DWORD alpha;

		for (int i=1; i<=steps; i++)
		{
			blur.left = (pNewRect->left * i + pOldRect->left * (steps-i))/steps;
			blur.right = (pNewRect->right * i + pOldRect->right * (steps-i))/steps;
			blur.top = (pNewRect->top * i + pOldRect->top * (steps-i))/steps;
			blur.bottom = (pNewRect->bottom * i + pOldRect->bottom * (steps-i))/steps;
			
			// alfa - o nco silnj, ne by teoreticky mla bt (0xff/steps)
			//alpha = 0x1a0 / steps; 
			alpha = 0xff / (steps - 1); 
			// prostedn snmek sekvence je zeslen
			if (i == (steps/2+1)) 
				alpha += 0x60;
			else
				alpha += 0x20;
			if (alpha > 0xff) alpha = 0xff;

			// modulace zadanou alfou
			alpha = alpha * ((modulate&0xff000000)>>24)>>8;

			res = dx8.BltSprite(&blur, pSrcTexture, pSrcRect, 0, (modulate&0x00ffffff)|(alpha<<24));
		}
	}
	else
		// dn nebo moc velky presun, take kreslme normln
		res = dx8.BltSprite(pNewRect, pSrcTexture, pSrcRect, 0, modulate);
	
	return res;
}

/*----------------------------------------------------------------------------
   BltBack - plcne texturu pes celou obrazovku
----------------------------------------------------------------------------*/
HRESULT DX8Graph::BltBack(Texture tex, D3DCOLOR modulate)
{
   RECT r,s;
	r.top = 0;
	r.left = 0;
	r.right = (texturemanager->GetHeader(tex))->dwWidth;
	r.bottom = (texturemanager->GetHeader(tex))->dwHeight;
   s.left = 0;
   s.top = 0;
   s.right = dx8.d3dpp.BackBufferWidth;
   s.bottom = dx8.d3dpp.BackBufferHeight;
   return dx8.BltSprite(&s,tex,&r,0,modulate);
}

/*----------------------------------------------------------------------------
   LockSurface - zamkne surface

----------------------------------------------------------------------------*/
void DX8Graph::LockSurface(Surface surf, D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD flags)
{
   // mozna by bylo dobre ze startu vynulovat pLockedRect?
   // ZeroMemory(pLockedRect,sizeof(D3DLOCKED_RECT));

   ddResult = surf->LockRect(pLockedRect, pRect, flags);

   if (ddResult != D3D_OK)
      throw new DDException("lock: LockSurface() failed");

}

/*----------------------------------------------------------------------------
   LockTexture - zamkne texturu
   flags: D3DLOCK_NO_DIRTY_UPDATE | D3DLOCK_NOSYSLOCK | D3DLOCK_READONLY 
----------------------------------------------------------------------------*/
void DX8Graph::LockTexture(Texture tex, D3DLOCKED_RECT* pLockedRect, CONST RECT* pRect, DWORD flags)
{
   // mozna by bylo dobre ze startu vynulovat pLockedRect?
   // ZeroMemory(pLockedRect,sizeof(D3DLOCKED_RECT));

   ddResult = tex->LockRect(0, pLockedRect, pRect, flags);

   if (ddResult != D3D_OK)
      throw new DDException("lock: LockTexture() failed");

}


/*-----------------------------------------------------------------------------
   vytvori Bitmap a zkopiruje do nej rendertarget
-----------------------------------------------------------------------------*/
void DX8Graph::Screenshot()
{
   Surface           rendertarget;
   D3DLOCKED_RECT    lockedRect;
   D3DSURFACE_DESC   desc;
   //DDSURFACEDESC2  ddsd2;
   BYTE              *bmp;
   HBITMAP           hbm;
   DWORD             bmp_offset, s_offset;
   BYTE              *surfdata;
   long              s_pitch;
   DWORD             s_width, s_height;
   char              filename[16];


	// Najdu si voln jmno pro soubor
   WIN32_FIND_DATA w32fd;
   HANDLE hSearch = INVALID_HANDLE_VALUE;
   ZeroMemory(&w32fd,sizeof(w32fd));
	do	{
		picnum++;
		sprintf(filename,"shot%04d.bmp",picnum);
		hSearch = FindFirstFile(filename,&w32fd);
	} while (hSearch != INVALID_HANDLE_VALUE);

   //ddResult = GetRenderTarget(IDirect3DSurface8** ppRenderTarget);
   ddResult = lpd3dDevice->GetRenderTarget(&rendertarget);
   if (ddResult != D3D_OK)
      throw new DDException("Screenshot: GetRenderTarget() failed");

   // rozmery - to je surface descriptor
   ddResult = rendertarget->GetDesc(&desc);
   if (ddResult != D3D_OK)
      throw new DDException("Screenshot: GetDesc() failed");

   // lock - tedy pokud pujde...?!
   ddResult = rendertarget->LockRect(&lockedRect, NULL, D3DLOCK_READONLY);
   if (ddResult != D3D_OK)
      throw new DDException("lock: LockTexture() failed");

   // je treba nastavit nejake ty promenne
   s_pitch = lockedRect.Pitch;
   surfdata = (BYTE *)lockedRect.pBits;

   s_width = desc.Width;
   s_height = desc.Height;

   // Allocate memory for bitmap bits
   DWORD width = (s_width % 2) == 1 ? s_width+1 : s_width;
   bmp = new BYTE[width*s_height*3];
   if (bmp == NULL)
   {
      rendertarget->UnlockRect();
      return;
   }

   // SURFACE 2 BITMAP
   WORD              rgb;
   BYTE              r,g,b;
	
   for (DWORD y=0; y < s_height; y++)
   {
      s_offset = (s_height-y-1)*s_pitch;
      for(DWORD x=0; x < width; x++)
      {
         bmp_offset = y*width*3+x*3;
         
         if (x >= s_width)
         {
            bmp[bmp_offset] = 0;
            bmp[bmp_offset+1] = 0;
            bmp[bmp_offset+2] = 0;
            break;
         }
         
         if (desc.Format == D3DFMT_R5G6B5 || desc.Format == D3DFMT_A1R5G5B5)
         {
            rgb = *((WORD *)(surfdata+s_offset));                 
            b = (BYTE)(((rgb&d3d_dwBMask) << 3)+((rgb&d3d_dwBMask) >> 2));
            g = (BYTE)(((rgb&d3d_dwGMask) >> (d3d_bGBits-3))+((rgb&d3d_dwGMask) >> (2*d3d_bGBits-3)));
            r = (BYTE)(((rgb&d3d_dwRMask) >> (2+d3d_bGBits))+((rgb&d3d_dwRMask) >> (d3d_bGBits+7)));;
            s_offset += 2;
         }
         else
         {
            // D3DFMT_R8G8B8               
            b = surfdata[s_offset++];
            g = surfdata[s_offset++];
            r = surfdata[s_offset++];
            // D3DFMT_A8R8G8B8
            if (desc.Format == D3DFMT_A8R8G8B8 || desc.Format == D3DFMT_X8R8G8B8)
            {
               s_offset++;
            }
         }
            
         bmp[bmp_offset] = b;
         bmp[bmp_offset+1] = g;
         bmp[bmp_offset+2] = r;
      }
   }
   
   //''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
   
   // Don't forget to unlock the surface
   rendertarget->UnlockRect();
   rendertarget->Release();
   
   hbm = CreateBitmap(width,s_height,1,24,(const void *)bmp);
   if (hbm == NULL)
   {
      delete [] bmp;
      return;
   }
   
   PBITMAPINFO pbmi;
   pbmi = (PBITMAPINFO) LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER));
   
   pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 
   pbmi->bmiHeader.biWidth = width; 
   pbmi->bmiHeader.biHeight = s_height; 
   pbmi->bmiHeader.biPlanes = 1; 
   pbmi->bmiHeader.biBitCount = 24; 
   
   /* If the bitmap is not compressed, set the BI_RGB flag. */ 
   pbmi->bmiHeader.biCompression = BI_RGB; 
   
   /* 
   * Compute the number of bytes in the array of color 
   * indices and store the result in biSizeImage. 
   */ 
   
   pbmi->bmiHeader.biSizeImage = (pbmi->bmiHeader.biWidth + 7) /8 
      * pbmi->bmiHeader.biHeight 
      * 24; 
      /* 
      * Set biClrImportant to 0, indicating that all of the 
      * device colors are important. 
   */ 
   pbmi->bmiHeader.biClrImportant = 0; 
   
   HANDLE hf;                  /* file handle */ 
   BITMAPFILEHEADER hdr;       /* bitmap file-header */ 
   PBITMAPINFOHEADER pbih;     /* bitmap info-header */ 
   DWORD dwTotal;              /* total count of bytes */ 
   DWORD cb;                   /* incremental count of bytes */ 
   BYTE *hp;                   /* byte pointer */ 
   
   DWORD dwTmp; 
   
   
   pbih = (PBITMAPINFOHEADER) pbmi; 
   
   /* Create the .BMP file. */ 
   
   hf = CreateFile(filename, 
      GENERIC_READ | GENERIC_WRITE, 
      (DWORD) 0, 
      (LPSECURITY_ATTRIBUTES) NULL, 
      CREATE_ALWAYS, 
      FILE_ATTRIBUTE_NORMAL, 
      (HANDLE) NULL); 
   
   if (hf == INVALID_HANDLE_VALUE) 
   {
      delete [] bmp;
      return;
   }
   
   hdr.bfType = 0x4d42;        /* 0x42 = "B" 0x4d = "M" */ 
   
   /* Compute the size of the entire file. */ 
   hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) + 
      pbih->biSize + pbih->biSizeImage); 
   
   hdr.bfReserved1 = 0; 
   hdr.bfReserved2 = 0; 
   
   /* Compute the offset to the array of color indices. */ 
   
   hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + 
      pbih->biSize;
   
   /* Copy the BITMAPFILEHEADER into the .BMP file. */ 
   
   if (!WriteFile(hf, (LPVOID) &hdr, sizeof(BITMAPFILEHEADER), 
      (LPDWORD) &dwTmp, (LPOVERLAPPED) NULL)) 
   {
      CloseHandle(hf);
      delete [] bmp;
      return;
   }
   
   /* Copy the BITMAPINFOHEADER and RGBQUAD array into the file. */ 
   
   if (!WriteFile(hf, (LPVOID) pbih, sizeof(BITMAPINFOHEADER), 
      (LPDWORD) &dwTmp, (LPOVERLAPPED) NULL)) 
   {
      CloseHandle(hf);
      delete [] bmp;
      return;
   }
   
   
   /* Copy the array of color indices into the .BMP file. */ 
   dwTotal = cb = pbih->biSizeImage; 
   hp = bmp; 
   while (cb > 32)  { 
      if (!WriteFile(hf, (LPSTR) hp, (int) 32, 
         (LPDWORD) &dwTmp, (LPOVERLAPPED) NULL)) 
      {
         CloseHandle(hf);
         delete [] bmp;
         return;
      }
      cb-= 32; 
      hp += 32; 
   } 
   if (!WriteFile(hf, (LPSTR) hp, (int) cb, 
      (LPDWORD) &dwTmp, (LPOVERLAPPED) NULL)) 
   {
      CloseHandle(hf);
      delete [] bmp;
      return;
   }
   
   /* Free memory. */
   delete [] bmp;

   /* Close the .BMP file. */    
   CloseHandle(hf);
}

/*-----------------------------------------------------------------------------
   nacte do struktury informace o podporovanych rozlisenich
-----------------------------------------------------------------------------*/
//#define SAVEMODES
int DX8Graph::GetModeList()
{
   D3DDISPLAYMODE tmpinfo;
   int count = lpD3D->GetAdapterModeCount(D3DADAPTER_DEFAULT );
   modecount = 0;
   modecount16 = 0;
   modecount32 = 0;

#ifdef SAVEMODES
   FILE * ff;
   ff = fopen("modelist.txt","wt");
#endif

   for (int i=0; i<count; i++)
   {
      lpD3D->EnumAdapterModes(D3DADAPTER_DEFAULT, i, &tmpinfo);
#ifdef SAVEMODES
      fprintf(ff,"x:%u\ty:%u\tf:%u\tbpp:%u ",tmpinfo.Width,tmpinfo.Height,tmpinfo.RefreshRate, tmpinfo.Format);
      if (tmpinfo.Format == D3DFMT_X8R8G8B8) fprintf(ff,"X8R8G8B8\n");
      else if (tmpinfo.Format == D3DFMT_R5G6B5) fprintf(ff,"R5G6B5\n");
      else if (tmpinfo.Format == D3DFMT_X1R5G5B5) fprintf(ff,"X1R5G5B5\n");
      else fprintf(ff,"???\n");
#endif
      // hodi se mi jenom nektere
      // od 640 nahoru a pomer stran 4:3
		// *** a od 60Hz nahoru
      if (tmpinfo.Width > 620 && tmpinfo.Width*3 == tmpinfo.Height*4 && (tmpinfo.RefreshRate == 0 || tmpinfo.RefreshRate == d3ddm.RefreshRate)) 
      {
         // 32 bit - D3DFMT_X8R8G8B8, do naplneni zasob =)
         if (tmpinfo.Format == D3DFMT_X8R8G8B8 && modecount32<MAXMODE)
         {
            (modes32[modecount32]) = tmpinfo;
            modecount32++;
            modecount++;
         }
         // 16 bit - D3DFMT_R5G6B5
         else if (tmpinfo.Format == D3DFMT_R5G6B5 && modecount16<MAXMODE)
         {
            (modes16[modecount16]) = tmpinfo;
            modecount16++;
            modecount++;
         }
      }
   }

#ifdef SAVEMODES
   fprintf(ff,"total:  %i\n",count);
   fprintf(ff,"usable: %i\n",modecount);
   fclose(ff);
#endif

   return modecount;
}
