/*
 *--------------------------------------------------------------------
 *
 * exceptions
 *
 * Vyjimky, ke kterym muze dojit za behu programu
 *
 * verze   0.0.2 - 14.05.1999
 * autori  Rory
 *
 *--------------------------------------------------------------------
 * zmeny
 *
 * 0.0.3 - pridana vyjimka 'IsLostException'
 * 0.0.2 - pridana vyjimka 'DIException' pro directInput
 * 0.0.1 - prvni verze
 *--------------------------------------------------------------------
 */

#ifndef EXCEPTIONS_H_BUBWINY
#define EXCEPTIONS_H_BUBWINY

#include <windows.h>
#include <winerror.h>

extern char exc_string[256];

class Exception {
public:
	char *msg;

	Exception(char *msg)
	{
		this->msg = msg;
	}
};

class BubException : public Exception {
public:
	BubException(char *msg) : Exception(msg) {};
};

class DDException : public Exception {
public:
    long ddResult;

	DDException(char *msg) : Exception(msg) {};
	DDException(char *msg, long ddResult) : Exception(msg)
	{
		this->ddResult = ddResult;
	}
};

class IsLostException : public DDException {
public:
   IsLostException(char *msg) : DDException(msg,MAKE_HRESULT(1,0x876,450)) {};
};

class DIException : public Exception {
public:
    long diResult;

	DIException(char *msg) : Exception(msg) {};
	DIException(char *msg, long diResult) : Exception(msg)
	{
		this->diResult = diResult;
	}
};

#endif