/*
  Font8
  by Gunny & Vojvo (kind of)
      
  Zajiuje prci se specilnmi bitmapovmi fonty.
  Font loaduje z Rxx, kter obsahuje zkladn informace o fontu.
  (Pedevm maximln rozmry znaku.)
  ..\..\utils\bmp2r24 qfontbw.bmp -c16 -h16 -w12 -a32
  c - poet znak na dku, h - vka znaku, w - ka znaku
  a - prvni znak (posledni se dopocita podle c a h/imgh
  Znaky mohou mt promnlivou ku, jako znaka okraje znaku se pouv
  cyan (00ffff) (nebo vyuvaj celkou max. ku znaku).
  Font pouv intern cache - ppadn texty si nejprve piprav do pracovn
  textury a z n se pak cel kus textu vykresl.

  pokud se pi tisku nenastavi spacing mezi znaky, pouva se default hodnota z objektu
  (ta se d zmnit)

  stav:
   pouziteln pro bn provoz

  todo:
   . doeit limity dlky stringu a podobn? (kde vlastn?)

	 2. 6. 2002 / prvn kusy pseudokdu, jak eit cachovn
   12. 6. 2002 / zan se to dvat dohromady
	22. 6. 2002 / spacing se pesunul mezi parametry Printu
	23. 6. 2002 / font8cache je skoro v kup
	 6. 7. 2002 / drobn pravy
	24. 7. 2002 / dopsan Print
	25. 7. 2002 / pomrn dopsan Load (zjitn ek znak)
	30. 7. 2002 / naato generate pes CopyRect
	10. 8. 2002 / generate hotovo, ale netestovno
	13. 8. 2002 / cosi se vypisuje, ale nesed ky znak
	15. 8. 2002 / opraveno potn ek znak a bug v cachi
	16. 8. 2002 / print  rozdlen na na prepare a print
	26. 1. 2003 / opraven bug v pixlen (chyblo -first)
                 opraveny rozmry znak pi koprovn (bylo navc -1)
	23. 2. 2003 / opraven zvorkov bug v potn ky znak pi force16
	24. 2. 2003 / opraven bug v pixlen (po poslednm znaku nen spacing)
    2. 3. 2003 / vyeen restore fontu (mon se to jet trochu uprav)
    3. 3. 2003 / upraveno kvli zmn v texturemanagerovi (viz 2.3.)
    4. 3. 2003 / opraven init cache (prepot si zptn limity)
   2008-06-22  / zarovnvn a centrovn bylo pln blb 
	2008-06-23  / zarovnn doprava bylo furt blb =)
	2008-06-25  / vnitn promnn default spacing
	2009-12-24	/ pridano prepocitani last podle velikosti gfx
	2009-12-25	/ opraveny init promenlive sirky (nenastavil se char_width[last])
	2010-10-04	/ altsize pi vykreslovn
  

-------------------------------------------------------------------------*/
 

//#include <stdio.h>
//#include <math.h>
//#include "globals.h"
#include "dx8graph.h"
#include "types8.h"
#include "exceptions.h"
#include "font8.h"
#include "tex8manager.h"
#include "utils.h"



Font8 *fonts[FONT8_MAXFONT];


//#########################################################################
//  Font8Cache
//#########################################################################

//-------------------------------------------------------------------------
// vytvari texturu pro cacheovani
// mel by se volat po nacteni fontu, bez cache neni mozne font pouzivat
//-------------------------------------------------------------------------
HRESULT Font8Cache::Init(Font8 * _owner, const char * _name, int _size, int _length)
{
   HRESULT res = D3D_OK;
   owner = _owner;
   if (owner==NULL) return D3D_OK;  //*** to snad ne...?!
   
   //_name = "CACHE_"+filename;
   strcpy(name,"CACHE_");
   strncat(name,_name,FONT8_MAXNAME);

   // nastavim rozmery textury v pixelech
   // predpokladam klasicky spacing == 1
   width = powerof2(_length * (1 + owner->width));
   height = powerof2(_size * (1 + owner->height));

   // textura ted muze byt vetsi, nez bylo pozadovano
   // ale bylo by skoda mista nevyuzit, tak upravime limity
   // pocet znaku
   length = width / (1 + owner->width);
   if (length > CACHE_MAX_LEN) length = CACHE_MAX_LEN;
   // pocet polozek v cachi
   size = height / (1 + owner->height);
   if (size > CACHE_MAX_SIZE) size = CACHE_MAX_SIZE;


   // uz jen vyrobit texturu
   res = InitTexture();
   return res;
}

//-------------------------------------------------------------------------
// zaridi vyrobeni cachovaci textury
//-------------------------------------------------------------------------
HRESULT Font8Cache::InitTexture()
{
   HRESULT res = D3D_OK;
   // vyrobim si potrebnou texturu (ve stejnem formatu jako je font)
   // nejdriv ho samozrejme potrebuju zjistit
   D3DSURFACE_DESC desc;
   if (owner->data->GetLevelDesc(0,&desc) == D3D_OK)
   {
      // povedlo se
      dx8.texturemanager->Create(&data, width, height, name, desc.Format); // create nastavi automaticky TX_COMPUTED
   }

   // vymazu pomocne udaje
   for (int i=0; i<size; i++)
   {
      *(txt[i]) = 0;
      spacing[i] = 0;
      recently[i] = 0;
   }
   return res;
}

//-------------------------------------------------------------------------
// vyhledava v cachi odpovidajici polozku
// vraci cislo "radku" nebo -1 (kdyz nenajde)
//-------------------------------------------------------------------------
int Font8Cache::Find(const char * _txt, BYTE _spc)
{
   int res = -1;
   int i = 0;
   while (i<size)
   {
      //if (_spc==spacing[i] && !strncmp(_txt, txt[i],strlen(_txt)))
      if (_spc==spacing[i] && !strcmp(_txt, txt[i]))
      {
         // tu ho mame - takze se pouzije a je treba ho "ozivit"
         recently[i] = CACHED_RECENTLY;
         res = i;
      }
      // prubezne snizuju nepouzitost ostatnich polozek
      else if (recently[i]>0) recently[i]--;
      i++;
   }
   return res;
}


//-------------------------------------------------------------------------
// vyhledava v cachi nejmin pouzitou polozku
//-------------------------------------------------------------------------
int Font8Cache::FindLeastUsed()
{
   int res = -1;
   int usable_value = CACHED_RECENTLY+1;
   for (int i=0; i<size; i++)
   {
      if (recently[i]<usable_value)
      {
         res = i;
         usable_value = recently[i];
      }
   }
   return res;
}


//#########################################################################
//  Font8
//#########################################################################

// Nacita bitmap a pripravi font pro pouziti
// size - pocet polozek v cachi
// len - max delka retezce ve znacich
void Font8::Load(char * filename, int size, int len)
{
   // hlavne se musi nacist bitmapa, ze jo...
   dx8.texturemanager->Load(&data, filename, glMiscFake);
   //*** a pokud se nic nenacetlo? exception anyone?
   if (data==NULL) return;

   // nastavime si zakladni udaje o fontu
   RFileHeader * rheader = dx8.texturemanager->GetHeader(data);
   width = rheader->dwCelWidth;
   height = rheader->dwCelHeight;
   rowsize = rheader->byCelRow;
   //*** um... coze? je to vubec treba, kdyz pouzivam jenom rowsize?
   //yshift = (BYTE)(log10((float)rheader->byCelRow)/log10(2.0f)+0.5f);
   //xand = rheader->byCelRow - 1;
   first = rheader->byFontFirst;
	last = rheader->dwHeight/height;
	last *= rowsize;
	last += first - 1;
   if (last > FONT8_MAXCHAR) last = FONT8_MAXCHAR;
	

   // je treba predpocitat sirku vsech znaku fontu
   // font bude vzdycky s alfa kanale, 
   // takze v uvahu pripadaji jen formaty 4444 a 8888

   // nejake ty pracovni promenne
   Surface surf;                // pro primy pristup
   D3DSURFACE_DESC d3dsd;
   D3DLOCKED_RECT locked;
   BYTE *lpSurface;
   long pitch;
   //DWORD dwWidth, dwHeight;   // rozmery z hlavicky
   //DWORD x,y,width,height,    // rozmery textury
   DWORD offset;
   int cWidth;

   // sahnu si na surface
   ddResult = data->GetSurfaceLevel(0, &surf);
   if (ddResult != D3D_OK)
   {
      throw new DDException("LoadRFile: GetSurfaceLevel() chyba!",ddResult);
   }

     // zamceni surface
   dx8.LockSurface(surf, &locked, NULL, 0);
   lpSurface = (BYTE *)locked.pBits;
   pitch = locked.Pitch;

   // zjisteni formatu surfacu
   surf->GetDesc(&d3dsd);
   /* zbytecne?
   width = d3dsd.Width;
   height = d3dsd.Height;
   format = d3dsd.Format;
   */

   int i;
   if (d3dsd.Format == D3DFMT_A4R4G4B4)
   {
      // colormask = 0x0fff;  // doufm
      // bordercolor = 0xf0f;
      // step = 2;
      for (i=first; i<=last; i++)
      {
         //offset = ((i-first)>>yshift)*height*pitch + ((i-first)&xand)*width*2;
         offset = ((i-first)/rowsize)*height*pitch + ((i-first)%rowsize)*width*2;
         cWidth = 0;
         while (cWidth < width)
         {
            if ((*((WORD *)(lpSurface+offset))&0x0fff) == 0xff)
               break;
            cWidth++;
            offset += 2;
         }
         char_width[i] = cWidth;
      }
   }
   else if (d3dsd.Format == D3DFMT_A8R8G8B8)
   {
      // colormask = 0x00ffffff;  // doufm
      // bordercolor = 0xff00ff;
      // step = 4;
      for (i=first; i<=last; i++)
      {
         //offset = ((i-first)>>yshift)*height*pitch + ((i-first)&xand)*width*4;
         offset = ((i-first)/rowsize)*height*pitch + ((i-first)%rowsize)*width*4;
         cWidth = 0;
         while (cWidth < width)
         {
            if ((*((DWORD *)(lpSurface+offset))&0x00ffffff) == 0x0000ffff)
            {
               break;
            }
            cWidth++;
            offset += 4;
         }
         char_width[i] = cWidth;
      }
   }
   else
   {
      // nesmyslny format! marna lasky snaha
      surf -> Release();
      throw new DDException("LoadRFile: Spatny format fontu!",ddResult);

   }
   
   // odemknu!
   surf->UnlockRect();

   // zlikviduju referenci zvysenou kvuli surfacu
   surf -> Release();
   
   // ted jen inicializovat cache
   cache.Init(this, filename, size, len);
   
   // pokud jsme se dostali az sem, tak je to ok
   ready = true;
}

//-------------------------------------------------------------------------
// pripravuje retezec v cachi pro vypis (pokud je potreba)
//-------------------------------------------------------------------------
int Font8::Prepare(RECT * r, const char * what, BYTE spacing)
{
   // je uz font v poradku nacteny?
   if (ready == false) return 0;
   // ok, muzeme se do toho pustit
	if (spacing == 255) spacing = default_spacing;
   int i = 0;
   int usable = CACHE_MAX_SIZE;
   int usable_value = CACHED_RECENTLY;
   
   // zkontroluju, jestli je cache ok
   if (cache.data == NULL)
   {
      // neni, takze zinicializuju
      cache.InitTexture();
   }
   else
   {
      // je, takze to v ni uz muze byt
      usable = cache.Find(what,spacing);
   }

   // tak co? nasli?
   if (usable == -1)
   {
      // nenasli! je treba text si vygenerovat
      #ifdef CLASSIC_DEBUG
      OutputDebugString("Font:: has to generate a new line: ");
      OutputDebugString(what);
      OutputDebugString("\n");
      #endif      
      // nejdriv musim najit vhodne misto
      usable = cache.FindLeastUsed();
      // fajn, flek na umisteni by byl
      
      //createtext(Texture * tex, RECT * r, char * line)
      //RECT r; - no, vlastne asi ne
      Generate(cache.data, 0, usable*height, what, spacing);

      // pokud to klaplo, tak upravim evidenci pouziti
      cache.recently[usable] = CACHED_RECENTLY;
      // ... a upravim udaje o obsahu cache
      strncpy(cache.txt[usable], what, cache.length);
      cache.pixlen[usable] = PixLen(what, spacing);
      cache.spacing[usable] = spacing;
   }

   // kdepak to mam pripraveno?
   r->top = usable*height;
   r->bottom = r->top + height; // -1?
   r->left = 0;
   r->right = cache.pixlen[usable];

   return (cache.pixlen[usable]);
}

//-------------------------------------------------------------------------
// zarizuje kompletni vypsani textu na renderscreen
//-------------------------------------------------------------------------
void Font8::Print(DWORD x, DWORD y, const char * what, DWORD color, int align, BYTE spacing, DWORD altheight)
{
   // je uz font v poradku nacteny?
   if (ready == false) return;
	if (spacing == 255) spacing = default_spacing;

   RECT r,s; // r - from, s - to
   int pxlen = Prepare(&r, what, spacing);
   
   //*** pripadne by se mohlo predelat na drawprimitive
   // kam s tim? - je treba resit zarovnani!
	DWORD realheight = height;
	// prepocitava se velikost?
	if (altheight) 
	{
		realheight = altheight;
		pxlen = (pxlen * altheight) / height;
	}

   s.top = y;
   s.bottom = s.top + realheight;
   s.left = x;
   if (align == ALIGN_CENTER)
   {
      s.left -= pxlen/2;
   }
   else if (align == ALIGN_RIGHT)
   {
      s.left -= pxlen;
   }
   s.right = s.left + pxlen;
   // vykreslim a mam hotovo
   dx8.BltSpriteEx(&s,cache.data,&r,0,color);
}


//-------------------------------------------------------------------------
// skld z psmenek text do dal textury
//-------------------------------------------------------------------------
HRESULT Font8::Generate(Texture tex, DWORD x, DWORD y, const char * what, BYTE spacing)
{
   HRESULT res = D3D_OK;
	if (spacing == 255) spacing = default_spacing;

   // max len je 128 - neni to trochu moc?
   // mozna by se to mohlo delat po osmicich
   RECT rfrom[CACHE_MAX_LEN*2];
   POINT rto[CACHE_MAX_LEN*2];

   int count = 0;
   unsigned char c;
   // kde lezi znak
   DWORD cx, cy;
   // kam se postupne skladaji
   DWORD xpos = x;
   for (unsigned int i=0; i<strlen(what); i++)
   {
      c = what[i];
      if (c < first || c > last)
      {
         /*
      	surf->Release();
         throw new DDException("VariableFont::puts: invalid character!",ddResult);
         */
         c = first;
      }

      // vlastni znak
      // horni roh puvodni pismenko
      cx = ((c-first)%rowsize)* width;
      cy = ((c-first)/rowsize)* height;

      rfrom[count].top = cy;
      rfrom[count].bottom = cy + height;
      rfrom[count].left = cx;
      rfrom[count].right = cx + char_width[c];

      //
      rto[count].y = y;
      rto[count].x = xpos;
      xpos += char_width[c];
      count++;

      // co mezera za znakem?
      if (i<(strlen(what)-1) && spacing > 0)
      {
         // neni to posledni znak a nejake mezery je treba
         // musim to nasmerovat na volne misto
         // (to by pry mel byt prvni znak - space)
         cx = 0;
         cy = 0;
         rfrom[count].top = cy;
         rfrom[count].bottom = cy + height;
         rfrom[count].left = cx;
         rfrom[count].right = cx + spacing;
         
         // proste pridam volnou plochu
         rto[count].y = y;
         rto[count].x = xpos;
         xpos += spacing;
         count++;
      }
   }

   // vsechno hotovo - jen to spustit
   Surface surffrom = NULL;
   Surface surfto = NULL;
   try 
   {
      // sahnu si na surface
      res = data->GetSurfaceLevel(0, &surffrom);
      if (res != D3D_OK)
      {
         throw new DDException("Font8::Generate: GetSurfaceLevel() chyba!",res);
      }
      res = cache.data->GetSurfaceLevel(0, &surfto);
      if (res != D3D_OK)
      {
         throw new DDException("Font8::Generate: GetSurfaceLevel() chyba!",res);
      }
      
      // hromadne kopirovani
      res = dx8.lpd3dDevice->CopyRects(surffrom,rfrom,count,surfto,rto); // count
      if (res != D3D_OK)
      {
			//char fmsg[64] = "";
			//sprintf(fmsg,"Font8(%i,%i,%i,%i)::Generate: CopyRects() chyba!",first,last,width,height);
			//throw new DDException(fmsg,res);
         throw new DDException("Font8::Generate: CopyRects() chyba!",res);
      }

      // uklidim po sobe
      if (surffrom != NULL) surffrom->Release();
      if (surfto != NULL) surfto->Release();
   }

   catch (Exception *exc)
   {
      if (surffrom != NULL) surffrom->Release();
      if (surfto != NULL) surfto->Release();
      
		// rozsireny vypis chyby
      if (exc->msg != exc_string)
         strcpy(exc_string,exc->msg);
      strcat(exc_string," in getPutString(");
      strcat(exc_string,what);
      strcat(exc_string,")");
      exc->msg = exc_string;

      throw exc;
    }

   return res;
}


//-------------------------------------------------------------------------
// counts the length of string in pixels
//-------------------------------------------------------------------------
DWORD Font8::PixLen(const char *_text, BYTE spacing)
{
   DWORD len = 0;
   BYTE c;
   BYTE w;
	if (spacing == 255) spacing = default_spacing;
	
	try
	{
		while (*_text != NULL)
		{
			c = (BYTE) *_text;
			if (c < first || c > last)
			{
				throw new DDException("Font8::PixLen: invalid character!",ddResult);
			}
			w = char_width[c];
			len += w;
			_text++;
			if (*_text != NULL) len += spacing;
		}
	}
	catch (Exception *exc)
	{
		if (exc->msg != exc_string)
			strcpy(exc_string,exc->msg);
		strcat(exc_string," in pixlen(");
		strcat(exc_string,_text);
		strcat(exc_string,")");
		exc->msg = exc_string;
		throw exc;
	}
	return len;
}



