#ifndef FRAMESV_H
#define FRAMESV_H

#include "types8.h"

#define EOC                     255
#define SAFE_FRAME              64
#define MAX_CHAINS              10
#define CHAIN_LEN               64
#define DIR_L                   0
#define DIR_R                   1

class FrameChain {
public:
   int loopindex;
   BYTE chain[CHAIN_LEN];
   
   FrameChain() { loopindex = 0; chain[0] = EOC; }
   void set(char *chain);
};

struct Frames {
   FrameChain lchains[MAX_CHAINS];
   FrameChain rchains[MAX_CHAINS];
};

class FrameController {
public:
   Frames *frames;
   FrameChain *chains;
   
   BYTE direction;
   BYTE chainid;
   BYTE frameid;
   BYTE index;
   bool looped;
   
   FrameController() { 
      looped = false;
      chainid = 0;
      frameid = 0;
      index = 0;
      frames = NULL;
      chains = NULL;
   }
   
   void jumpNext(int steps = 1);
   void setChain(BYTE id);
   void setDirection(BYTE dir);
};

#endif