//*************************************************************************
//                              Game class
//*************************************************************************
//  Written by : Vojvo (& Gunny)
//*************************************************************************
/*
   changes:
    2008-06-28 / asomra zvld i redalert
    2008-06-23 / darken nem vliv na tmavost lit
    2008-06-20 / DX8 pomrn funguje
*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "dx8graph.h"
#include "tex8manager.h"

#include "exceptions.h"
#include "keyboard.h"
#include "rfile32.h"
#include "font8.h"
#include "gonio.h"
#include "map.h"
#include "fakedir.h"
#include "sheet.h"
#include "application.h"
#include "utils.h"
#include "wsound.h"
#include "pass.h"
#include "topper.h"
#include "score.h"
#include "gs_game.h"

#define BUB_UNIT     14   // (MAX_SBUBS div 3) + 1

/*,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
globalni promenne, ktere jsou dostupne i spritum
''''''''''''''''''''''''''''''''''''''''''''''''''''*/

// --- mapy ---
Map         map;
WindMap     windmap;

// --- grafika ---

Texture     tiles_gfx;
Texture		keys_gfx;
Texture     sym_bubgfx;
Texture     timer10_gfx;
Texture     duration_gfx;
Texture     hourglass_gfx;
Texture     timealert_gfx;


// --- sprites ---
DECLARE_ARRAY(Creature*,monsters,monsters_ctrl,MAX_MONSTERS+2)
DECLARE_ARRAY(Bonus*,bonuses,bonuses_ctrl,MAX_BONUSES);
DECLARE_ARRAY(Bubble*,qbubbles,qbubbles_ctrl,MAX_QBUBS);
DECLARE_ARRAY(Bubble*,sbubbles,sbubbles_ctrl,MAX_SBUBS);
DECLARE_ARRAY(SymbolBubble*,symbubs,symbubs_ctrl,MAX_SYMBUBS);
DECLARE_ARRAY(Teleport*,teleports,teleports_ctrl,MAX_TPORTS);
DECLARE_ARRAY(Teleport*,ftports,ftports_ctrl,MAX_FTPORTS);

DropList     *drops;
ScoreList    *score_labels;
int          arr_i = 0;
Player       *player1, *player2;
short        monstercnt;
Properties   properties;
int          gravitation;

int          vanish;      // tohle je nejsp pznak, e hr se teleportoval. Mlo by zajistit jet 2 vykreslen obrazovky, kdy u tam nen
								// 0 hra bezi, 1 hraci nebo level mizi, probiha fadeout, 2 fadeout skoncil, jdeme dal
//int			 vanish_full;

Fader fader;

// --- options ---
BYTE           startlives;
bool           s_drops;
bool           s_catchy;
BYTE           s_darken;
DWORD          passcount = 0, 
globalpasscount = 0;

// --- technicke detaily ---
char           *backname;
char           filnam[20];
Message        message;
bool           spadla_klec;

// pocitani casu kvuli rychlosti hry a FPS
DWORD          time, oldtime, deltat, oldtime2, starttime;
int            step_global;
DWORD          fps, fpsavg;
Message        fpsmsg;

#ifdef MURRAYDEBUG
Message        murraygmsg;
Message        murraybmsg;
#endif

// --- cas ---
MainTimer      timer;

// --- herni priznaky ---
bool           exitgame;
BYTE           system_frozen;
BYTE           freeze;
DWORD          lastscore1, lastscore2;
char           levelname[20] = "nolevel",*nextlvls;
char           usedname;
Timer          frozen;        // poitadlo trvn zmrazen potvor
BYTE           diedyoung = 0; // ma se ukazovat a zapisovat do hiscore?
char           s_name[4][32];
BYTE           s_key[4][4];
char           s_password[32];
BYTE           s_vol;
BYTE           s_sfx;
bool           s_test;
bool           s_testsymbol;
bool           s_testholy;
bool           s_holy;
bool           s_report;
bool				s_keyhint;
bool           s_changepass;
bool           s_reverse_stereo;
char           s_leveldesc[MAX_TEXTS][30];
bool           ruby;
bool           enteredpass;
bool				keyhint;

#ifdef FILEDEBUG
FILE *fw;
#endif

//
// Globalni promenne - "lokalni"
//
static Bublifuk *bublifux[MAX_BUBLIFUX];
static int fuqcount;
static int fuq;
//static RECT rPlayfield = { PLAYFIELD_MIN_X,PLAYFIELD_MIN_Y,PLAYFIELD_MAX_X, PLAYFIELD_MAX_Y };
static DWORD desc_x = 175;

static RECT energy0cel_rect = {20,0,24,4};
static RECT energy1cel_rect = {0,0,4,4};
static RECT energy2cel_rect = {4,0,8,4};
static RECT rFTport = { 0,0,40,40 } ;


//=========================================================================
// inicializace systemu
//=========================================================================
Game::Game(void)
{
   int i;

   map = NULL;
   windmap = NULL;
   UFOcnt = 0;
   nextlvls = new char[128];

   srand(GetTickCount());
   
   exitsys = false;
   exitgame = false;
   system_frozen = 0;
   freeze = 0;
   frozen.options(7500,0,30,true,false);	// 7500 / 30 ... jeden dilek = 0.5 sec
   backname = new char[30];
   if (backname == NULL)
      throw new BubException("Game::Game: cannot allocate background!");
   
   for(i=0; i<MAX_TEXTS; i++)
      s_leveldesc[i][0] = '\x0';

   drops = new DropList();
    score_labels = new ScoreList(fonts[2]);

    vbGameField = NULL;
    
    HRESULT hr;
    if SUCCEEDED(hr = dx8.lpd3dDevice->CreateVertexBuffer(4*sizeof(BVERTEX),0 ,
        (D3DFVF_BVERTEX), D3DPOOL_MANAGED ,&vbGameField))
    {
        BVERTEX *tempvert;
        vbGameField->Lock(0,4*sizeof(BVERTEX),(BYTE **)&tempvert,0);
        
        tempvert->x = 0;
        tempvert->y = (float)dx8.CoordY(440);
        tempvert->z = 0;
        tempvert->rhw = 1;
        tempvert->color = 0xffff0000;
        tempvert->tu1 = 0;
        tempvert->tv1 = 1;
        tempvert++;
        
        tempvert->x = 0;
        tempvert->y = (float)dx8.CoordY(40);
        tempvert->z = 0;
        tempvert->rhw = 1;
        tempvert->color = 0xffff0000;
        tempvert->tu1 = 0;
        tempvert->tv1 = 0;
        tempvert++;
        
        tempvert->x = (float)dx8.sizex;
        tempvert->y = (float)dx8.CoordY(440);
        tempvert->z = 0;
        tempvert->rhw = 1;
        tempvert->color = 0xffff0000;
        tempvert->tu1 = 1;
        tempvert->tv1 = 1;
        tempvert++;
        
        tempvert->x = (float)dx8.sizex;
        tempvert->y = (float)dx8.CoordY(40);
        tempvert->z = 0;
        tempvert->rhw = 1;
        tempvert->color = 0xffff0000;
        tempvert->tu1 = 1;
        tempvert->tv1 = 0;
        tempvert++;
        
        vbGameField->Unlock();
    }

    if (dx8.wide) 
     {
         scoresize = dx8.tilesize;
         scoreposy = dx8.sizey - dx8.tilesize;
     }
    else 
     {
         scoresize = dx8.tilesize + 12;
         scoreposy = dx8.sizey - dx8.tilesize - scoresize / 2 + 1;
         desc_x = dx8.CoordX(desc_x);
     }

}

//-------------------------------------------------------------------------
// nahrava data pro hru
//-------------------------------------------------------------------------
void Game::load()
{
}


//==========================================================================
//    Zahajeni hry, nastaveni prostredi
//==========================================================================
void Game::StartGame()
{
   startlives = DEF_LIVES;
   enteredpass = true;
   if (strlen(s_password)>11)
      s_password[11]=0;
   if (*s_password=='/')
   {
      usedname=2;
      strcpy(levelname,s_password+1);
      enteredpass = false;
   }
   else
   {
      usedname=0;
      strupr(s_password);
      decode(s_password,levelname,&startlives);
   }
   if (!(*levelname))
   {
      strcpy(s_password, "START");
      strcpy(levelname,"START");
	   startlives = DEF_LIVES;
   }
   
   exitgame = false;
   player1 = new Player(properties.member[ID_PLAYER1], MASK_GREEN);
   player1->SetKeys(s_key[0][0],s_key[0][1],s_key[0][2],s_key[0][3]);
   player1->sheet.name = s_name[0];  
   player1->sheet.colormask = player1->colour;  
   player1->gravity = DFT_GRAVITY;
   player1->dropcolor = DROP_GREEN;
	if (!dx8.wide)
	{
		// pro 4:3 klasick souadnice
		player1->symbuf.x = 200;
		player1->symbuf.size = 20;
   }
	else
	{
		// pro wide u pesn souadnice
		player1->symbuf.size = dx8.tilesize / 2;
		player1->symbuf.x = (dx8.tilesize * 5);
		player1->symbuf.y = dx8.sizey - (dx8.tilesize * 3) / 4;
	}

   player2 = new Player(properties.member[ID_PLAYER2], MASK_BLUE);
   player2->SetKeys(s_key[1][0],s_key[1][1],s_key[1][2],s_key[1][3]);
   player2->sheet.name = s_name[1];  
   player2->sheet.colormask = player2->colour;  
   player2->gravity = DFT_GRAVITY;
   player2->dropcolor = DROP_BLUE;
	if (!dx8.wide)
	{
		// pro 4:3 klasick souadnice
	   player2->symbuf.x = 360;
		player2->symbuf.size = 20;
	}
	else
	{
		// pro wide u pesn souadnice
		player2->symbuf.size = dx8.tilesize / 2;
		player2->symbuf.x = dx8.sizex - (dx8.tilesize * 7);
		player2->symbuf.y = dx8.sizey - (dx8.tilesize * 3) / 4;

	}

   player1->sheet.lives = startlives;
   //player1->sheet.AddLives(startlives); //*** testovani startlives
	player1->sheet.UpdateView();
   
   if (s_testholy)
   {
      player1->state |= IMMORTAL;
      player2->state |= IMMORTAL;
   }   

#ifdef MURRAYDEBUG
   strcpy(murrayg_msg,"MG:");
   strcpy(murrayb_msg,"MB:");
#endif
}

//==========================================================================
//    Nahrani a inicializace levelu
//==========================================================================
int Game::LoadLevel(void)
{
   FILE *fr;
   char s[40];
   char mapname[24];
   char wndname[24];
   char path[10]="levels\\";
   int id,x,y,tox,toy;
   int j,count;
   Monster *pom;
   Teleport *pomt;
   Bonus * pomb;
   
   DEBUG_MESSAGE("LoadLevel:");
   
   for (j=0;j<MAX_BUBLIFUX;j++)
      bublifux[j] = NULL;
   
   DEBUG_MESSAGE("b");
   
   // nejsou nahodou prohozene klavesy?
   if (player1->dik_left != s_key[0][0])
   {
      player1->SetKeys(s_key[0][0],s_key[0][1],s_key[0][2],s_key[0][3]);
      player2->SetKeys(s_key[1][0],s_key[1][1],s_key[1][2],s_key[1][3]);
   }
   
   DEBUG_MESSAGE("k");
   
   //---------------------------------------------- otevreni souboru s levelem
   //bud je dobre heslo, nebo jde do start
   do
   {
      strcpy(s,path);
      strcat(s,levelname);
      strcat(s,".lvl");
      fr = fopen(s,"rt");
      if (fr == NULL)
      {
         strcpy(s,levelname);
         strcat(s,".lvl");
         strcpy(exc_string,s);
         fr = fakeopen("data\\levels.dir",s,"rt");
      }
      if (fr == NULL)
      {
			// jmeno levelu ziskane z hesla bylo k nicemu
         if (!usedname)
         {
				// takze zkusime to jeste jednou od levelu start
            player1->sheet.lives = DEF_LIVES;
				player1->sheet.UpdateView();
            strcpy(levelname,"START");
            usedname++;
         }
         else
         {
				// zase nic, tak smula...
            levelname[0] = '\x0';
            return 0;
         }
      }
   } 
      
   while (fr==NULL && usedname<2);
   usedname = 2; //jistota pro dalsi cyklus
   // tak co? klaplo otevreni souboru?
   if (fr == NULL)
   {
      diedyoung = 0;
      throw new BubException("loadlevel");
   }
   //- ctu z LVL -------------------------------------------------------------
   fscanf(fr,"%s",s);
   if (strcmp(s,"LVL"))
   {
      fclose(fr);
      throw new BubException("loadlevel");
   }

   DEBUG_MESSAGE("1");
   
   //---------------------------------------------------- nacteni jmena pozadi
   fscanf(fr,"%s",s);
   strcpy(backname,s);
   strcat(backname,".r24");
   
   DEBUG_MESSAGE("B");

   
   //------------------------------------------------------------ nacteni mapy
   fscanf(fr,"%s",s);
   s[8] = 0;
   strcpy(mapname,path);
   strcat(mapname,s);
   strcat(mapname,".emb");
   map = load_map(mapname);
   if (map==NULL)
   {
      fclose(fr);
      sprintf(exc_string,"loadlevel: load(%s) failed!",mapname);
      throw new BubException(exc_string);
   }

   DEBUG_MESSAGE("M");
   
   //----------------------------------------------------- nacteni vetrne mapy
   fscanf(fr,"%s",s);
   s[8] = 0;
   strcpy(wndname,path);
   strcat(wndname,s);
   strcat(wndname,".wnd");
   windmap = load_wndmap(wndname);
   if (windmap==NULL)
   {
      fclose(fr);
      sprintf(exc_string,"loadlevel: load(%s) failed!",wndname);
      throw new BubException(exc_string);
   }
   fscanf(fr,"%s",s);

   DEBUG_MESSAGE("W");
   
   //--------------------------------------------------------- nacteni playeru
   fscanf(fr,"%s",s);
   fscanf(fr,"%d %d %d",&id,&x,&y);
   
   ARRAY_ADD(monsters,monsters_ctrl,player1);
   
    // V. 2004 - predelano na metodu
   player1->Place(x,y);
    //
   
   fscanf(fr,"%s",s);
   fscanf(fr,"%d %d %d",&id,&x,&y);
   
   ARRAY_ADD(monsters,monsters_ctrl,player2);

    // V. 2004 - predelano na metodu
   player2->Place(x,y);
    //
   
   DEBUG_MESSAGE("P");

   //--------------------------------------------------------- nacteni monster
   fscanf(fr,"%s",s);
   fscanf(fr,"%d",&count);
   int turnpos = 0;
   monstercnt = count;
   if (count>0)
   {
      for(j=0;j<count;j++)
      {
         fscanf(fr,"%s",s);
         fscanf(fr,"%d %d %d",&id,&x,&y);
         x *= MAP_CELX;
         y = y * MAP_CELY + PLAYFIELD_TOP;       
         pom = NULL;
         if (id>=40 && id < 48)
         {
            monstercnt--;
            pomb = new Bonus(x,y,properties.member[id]);
            pomb->type = BONUS;
            pomb->action = 0;
            pomb->movex = 0;
            pomb->movey = 0;
            
            if (ARRAY_FULL(bonuses_ctrl))
            {
               delete pomb;
               pomb = NULL;
            }
            else
            {
               if (pomb != NULL)
                  ARRAY_ADD(bonuses,bonuses_ctrl,pomb);
            }
         }
         else
         {
            switch (id) 
            {
            case 4:
               pom = new Zomb(x,y,properties.member[id]);
               break;
            case 5:
               pom = new Nebulus(x,y,properties.member[id]);
               break;
            case 6:
               pom = new Butterfly2(x,y,properties.member[id]);
					pom->jumpNext(j%6); // aby nezacinali mavat stejne
               break;
            case 7:
               pom = new Butterfly(x,y,properties.member[id]);
					pom->jumpNext(j%6); // aby nezacinali mavat stejne
               break;
            case 8:
               pom = new Kachna(x,y,properties.member[id]);
               break;
            case 9:
               pom = new Butterfly3(x,y,properties.member[id]);
					pom->jumpNext(j%6); // aby nezacinali mavat stejne
               break;
            case 10:
               if (!turnpos) 
                  turnpos = countturnpos(map);
               pom = new RedDragon(x,y,properties.member[id],turnpos);
               break;
            case 11:
               pom = new YellowDragon(x,y,properties.member[id]);
               break;
            case 12:
               pom = new Bunny(x,y,properties.member[12]);
               break;
            case 13:
               pom = new Zomb(x,y,properties.member[13]);
               break;            
            }
            if (ARRAY_FULL(monsters_ctrl))
            {
               delete pom;
               pom = NULL;
            }
            else
            {
               if (pom != NULL)
                  ARRAY_ADD(monsters,monsters_ctrl,pom);
            }
         }
      }
   }

   DEBUG_MESSAGE("M");
     
   //------------------------------------------------------- nacteni bublifuku
   
   fscanf(fr,"%s",s);
   fscanf(fr,"%d",&count);
   J while(j<count)
   {
      fscanf(fr,"%s",s);
      fscanf(fr,"%d %d ",&x,&y);
      x *= MAP_CELX;
      y = y * MAP_CELY + PLAYFIELD_TOP;
      if (j<MAX_BUBLIFUX)
      {
         bublifux[j] = new Bublifuk(x,y,properties.member[ID_BFUK]);
      }
      j++;
   }
   fuqcount = count;
   if (fuqcount > MAX_BUBLIFUX)
      fuqcount = MAX_BUBLIFUX;

   DEBUG_MESSAGE("B");
   
   //------------------------------------------------------- nacteni teleportu
   fscanf(fr,"%s",s);
   fscanf(fr,"%d",&count);
   if (count>0)
   {
      for(j=0;j<count;j++)
      {
         fscanf(fr,"%s",s);
         fscanf(fr,"%d %d %d %d",&x,&y,&tox,&toy);
         x *= MAP_CELX;
         y = y*MAP_CELY + PLAYFIELD_TOP;
         pomt = new Teleport(x,y,properties.member[ID_TPORT]);
         pomt->destx = tox * MAP_CELX;
         pomt->desty = toy * MAP_CELY + PLAYFIELD_TOP;
         if (ARRAY_FULL(teleports_ctrl))
         {
            delete pomt;
            pomt = NULL;
         }
         else
         {
            if (pomt != NULL)
               ARRAY_ADD(teleports,teleports_ctrl,pomt);
         }
      }
   }
   DEBUG_MESSAGE("T");
      
   //------------------------------------------- nacteni zaverecnych teleportu
   fscanf(fr,"%s",s);
   fscanf(fr,"%s",s);
   strcpy(nextlvls,s);
   fscanf(fr,"%d",&count);
   if (count>0)
   {
      for(j=0;j<count;j++)
      {
         fscanf(fr,"%s",s);
         fscanf(fr,"%d %d",&x,&y);
         fscanf(fr,"%s",s);
         strcpy(nextlvls+(j+1)*9,s);
         x *= MAP_CELX;
         y = y*MAP_CELY + PLAYFIELD_TOP;          
         pomt = new Teleport(x,y,properties.member[ID_FTPORT]);
         pomt->type = FTPORT;
         pomt->destx = j+1;
         if (ARRAY_FULL(ftports_ctrl))
         {
            delete pomt;
            pomt = NULL;
         }
         else
         {
            if (pomt != NULL)
               ARRAY_ADD(ftports,ftports_ctrl,pomt);
         }
      }
   }
   DEBUG_MESSAGE("F");
      
   //-------------------------------------------------------------- level info
   fscanf(fr,"%s",s);    // vata nebo "#>>>hints" "#>>>pokec"
   hint = 0;
   //if (s[4]=="h") hint = 1; // je to hint
    if (strncmp(s,"#>>>h",5) == 0) 
        hint = 1; // je to hint
   char tclr;
   fscanf(fr,"%d %d",&tclr,&count); // barva a pocet
   if (count>0)
   {
      for(j=0;j<MAX_TEXTS;j++)
         s_leveldesc[j][0] = '\x0';
      for(j=0;j<count;j++)
      {
         fscanf(fr,"%s",s);//vata
         fscanf(fr,"%s",s);//x
         fscanf(fr,"%s",s);//y
         fgets(s,10,fr); //sezere enter
         fgets(s,30,fr); //fscanf(fr,"%s",s);//hura, text!
         if (*s) s[strlen(s)-1]=0; //odseknu crlf na konci
         if (j >= MAX_TEXTS)
            throw new BubException("Level with 2much texts");
         strcpy(s_leveldesc[j],s);
      }
   }
   DEBUG_MESSAGE("I");

   //--------------------------------------------------------------- gravitace
   fscanf(fr,"%s",s);    // vata
   j=fscanf(fr,"%d",&gravitation);
   if (j!=0 && j!=EOF)
   {
      for (j=0; j<monsters_ctrl.count; j++)
         ARRAY_AT(monsters,j)->gravity = gravitation * 2;
   }
   else 
   {
      gravitation = DFT_GRAVITY;
   }
    player1->gravityLow = gravitation * 2;
    player1->gravityHigh = gravitation * 4;
    player2->gravityLow = gravitation * 2;
    player2->gravityHigh = gravitation * 4;
   //--------------------------------------------------------------- timelimit
   fscanf(fr,"%s",s);    // vata timelimit
   j = fscanf(fr,"%d",&x); // x zneuvm jako temp
   if (j==0) 
      x = DFT_TIMELIMIT;
   timer.Init();
   timer.Set(x); // x
   //------------------------------------------------------------------- kanec
   fscanf(fr,"%s",s);    // vata magic
   j=fscanf(fr,"%d",&magictime);
   if (j==0) magictime = 0;
   magictime = magictime * 1500;
   //------------------------------------------------------------------- kanec
   fclose(fr);
   DEBUG_MESSAGE(".Done\n");
   return 1;
}

//-------------------------------------------------------------------------
// start levelu
//-------------------------------------------------------------------------
void Game::startLevel()
{
   DEBUG_MESSAGE("startLevel...");
   if (!LoadLevel())
      return;
    
    // pripravim si pozad
    textureManager->Load(&gfxback, backname,"data\\back.dir");
    
    timer.gfxback = gfxback; // mno, elegance sama... =]
    timer.gfxred = timer10_gfx;
    timer.gfxhourglass = hourglass_gfx;

    hurryup.Init(timealert_gfx);
    
    // textura
    backgfx.top = 40;
    backgfx.left = 0;
    backgfx.right = (textureManager->GetHeader(gfxback))->dwWidth;
    backgfx.bottom = (textureManager->GetHeader(gfxback))->dwHeight - 40;
    // obrazovka
   backscreen.left = 0;
   backscreen.top =  dx8.CoordY(40); // 40 - 40 * dx8.wide
   backscreen.right = dx8.sizex;
   backscreen.bottom = dx8.CoordY(440); // dx8.sizey - 40 * dx8.wide;
    
    // pripraveni bonusu a casomiry
   frozen.set(0);
   ruby = (monstercnt > 0);
   fuq = 0;
   to_fuq = 0;
   vanish = 0;
    
   // priprava vypisu hesla
    if (enteredpass)
   {
  //      strcpy(levelname,s_password);
        strcpy(txtpass,s_password);
      enteredpass=false;
   }
   else
   {
      encode(txtpass,levelname,&player1->sheet.lives);
        strcpy(levelname,txtpass);
      //tady muzu zmenit i heslo menu
      if ((s_changepass || player1->sheet.lives>=DEF_LIVES) && *s_password!='/')
      {
         strcpy(s_password,txtpass);
      }
   }

   // preprocesing cisla a jmena levelu
    if (dx8.wide)
    {
        // vechno bude dohromady
        strcpy(txtname,s_leveldesc[0]);
        strcat(txtname," (");
        strcat(txtname,txtpass);
        strcat(txtname,")");
    }
    else
    {
        char * desc = s_leveldesc[0]+1;
        while (*desc!='.' && (desc-s_leveldesc[0])<4) desc++;
        if (*desc=='.')
        { // je tam nejake cislo, tak ho odrizneme a vypiseme zvlast
            *desc = 0;
            strcpy(txtnum,s_leveldesc[0]);
            desc++; if (*desc == ' ') desc++;
            strcpy(txtname,desc);
        }
        else
        {  // cislo nikde - jenom nazev 
            *txtnum = 0;
            strcpy(txtname,s_leveldesc[0]);
        }
    }

    
    // doba zobrazeni kecu z interscreenu
    interscreen = 4000; //  * ruby // aby jen v nebonusovch
    interscreen_alpha = 0xff000000; // * ruby;
    // pokud v levelu neni hint, tak nic nebude
    if (!hint) interscreen_alpha = 0;
    
	fader.Set(4);

    kbd.lastScanReset();
    
   DEBUG_MESSAGE("StartLevel.Done.\n");
}

      
//-------------------------------------------------------------------------
// posledni pripravy pred startem...
//-------------------------------------------------------------------------
void Game::start()
{
   //DDSCAPS2 ddsCaps2;

   DEBUG_MESSAGE("Game::start()");

   magiccount = 0;
   //  message.duration = 0;

   DEBUG_MESSAGE(" 1");
   
   DEBUG_MESSAGE("2");

   player1->Resurrection();
   player2->Resurrection();
   DEBUG_MESSAGE("4");
   
   time = 0;
   
   sound_device->Play(14);
   time = GetTickCount();
   exitgame = 0;
   spadla_klec = false;
   last_alert = -9999; // kvuli siren v bonusovych levelech
   panpos = 240;
   oldtime = time;
   oldtime2 = time;
//   timecurrent = 0;
   starttime = time;
   step_global = 0;
   fpsmsg.Options(5,40+20*dx8.wide,ALIGN_LEFT);
    fpsmsg.size = 20;
   DEBUG_MESSAGE("5");
#ifdef MURRAYDEBUG
   murraygmsg.Options(10,56);
   murraybmsg.Options(630,56);
#endif
   DEBUG_MESSAGE("6");
   passcount = 0;
   globalpasscount = 0;
   DEBUG_MESSAGE(".Done.\n");

   kbd.clearAllKeys();

}

//----------------------------------------------------------------------------
// Paint() : hlavn vykreslovac smyka
//----------------------------------------------------------------------------
void Game::Paint()
{
   int i;
    //RECT temprect;
    
   if( dx8.lpd3dDevice == NULL) return;
   
   HRESULT hr;
   if( FAILED( hr = dx8.lpd3dDevice->TestCooperativeLevel() ) )
   {
      if( D3DERR_DEVICELOST == hr ) return;
      if( D3DERR_DEVICENOTRESET == hr ) dx8.Reset();
      return;
   }
   dx8.lpd3dDevice->BeginScene();
    
    // hern st pozad 
    // pokud se ztmavuje, pripravim si nejdv colormask
	 DWORD tc = s_darken * 32;
	 if (tc > 255) tc = 255;
    D3DCOLOR  backmask = 0xff000000 | tc<<16 | tc<<8 | tc;
    // posledni level ma vyjimku
    if (!stricmp(backname,"kanec.r24")) backmask = 0xffffffff; 
    
    // pozad
   dx8.BltSprite(&backscreen,gfxback,&backgfx,0,backmask);
    
    // stny pajdulk a objekt
    // bonusy
    I while(i<bonuses_ctrl.count)
        ARRAY_AT(bonuses,i++)->PaintShadow();
    // potfurky
    I while(i<monsters_ctrl.count)
        ARRAY_AT(monsters,i++)->PaintShadow();
    
    // kostky
   draw_map2(map,tiles_gfx);
    
    // teleporty
    I while(i<teleports_ctrl.count)
        ARRAY_AT(teleports,i++)->Paint();
    // bonusy
    I while(i<bonuses_ctrl.count)
        ARRAY_AT(bonuses,i++)->Paint();
    // potfurky
    I while(i<monsters_ctrl.count)
        ARRAY_AT(monsters,i++)->Paint();
    // kreslime rychle bubliny
    I while(i<qbubbles_ctrl.count)
        ARRAY_AT(qbubbles,i++)->Paint();
    // kreslime pomale bubliny
    I while(i<sbubbles_ctrl.count)
		 ARRAY_AT(sbubbles,i++)->Paint();
    // kreslime symbolove bubliny
    I while(i<symbubs_ctrl.count)
		 ARRAY_AT(symbubs,i++)->Paint();
    // kreslime bublifuky
    I while(i < fuqcount)
        bublifux[i++]->Paint();
    // kreslime UFOny
    I while(i<UFOcnt)
        UFOs[i++]->Paint();
    // kreslime bonbony =)
    I while(i<drops->count)
        drops->list[i++]->Paint();
    // a scorelabels
    score_labels->Paint();
    
    // kresleni hodin - hurry up!
    hurryup.Paint();
    
    RECT r = backgfx;
    RECT s = backscreen;
    if (!dx8.wide)
    {
        // horni lista
        r.top = 0;
        r.bottom = 40;
        s.top = 0;
        s.bottom = dx8.CoordY(40);
        dx8.BltSprite(&s,gfxback,&r,0);
        
        // dolni lista
        r.top = 440;
        r.bottom = 480;
        s.top = dx8.CoordY(440);
        s.bottom = dx8.CoordY(480);
        dx8.BltSprite(&s,gfxback,&r,0);
    }
    
    // hlavika levelu
    if (dx8.wide)
    {
        // vsechno v jednom
        fonts[1]->Print(8,8,txtname,0xffffffff, ALIGN_LEFT, 255, 24); // osa y timeru je 20
    }
    else
    {
        // slo a jmno levelu
        if (*txtnum != 0) fonts[1]->Print(desc_x - 10,4,txtnum,0xffff8080, ALIGN_RIGHT, 255, dx8.tilesize - 4);
        fonts[1]->Print(desc_x,4,txtname,0xffffffff, ALIGN_LEFT, 255, dx8.tilesize - 4);
        
        // heslo
        // if (*s_password!='/') //*** proste aby se ukazovalo jen kdyz se hraje bez cheatu a podobn
        fonts[1]->Print(desc_x,dx8.tilesize,txtpass,0xffffffff, ALIGN_LEFT, 255, dx8.tilesize - 4); //,ALIGN_CENTER
    }
    
    // score
    fonts[2]->Print(4,scoreposy,player1->sheet.strscore,player1->colour,ALIGN_LEFT,255,scoresize);
    fonts[2]->Print(dx8.sizex-4,scoreposy,player2->sheet.strscore,player2->colour,ALIGN_RIGHT,255,scoresize);
    
    // lives
    fonts[2]->Print(dx8.centerx,scoreposy,player1->sheet.strlives,MASK_RED,ALIGN_CENTER,255,scoresize);
    
    // statistiky a kraviny
    player1->symbuf.Paint();
    player2->symbuf.Paint();
    
    // asomra
    timer.Paint();
    
    // pokud je readalert, musime zrudnout!
    if (timer.IsAlert())
    {
        //*** tohle cele by se vlastne mozna mohlo zahrnout pod MainTimer
        // spocitam si pruhlednost redalertu
        DWORD red_alert_alfa = ((5000-timer.exacttime)/2)%200;
        if (red_alert_alfa > 100) red_alert_alfa = 200 - red_alert_alfa;
        red_alert_alfa = red_alert_alfa << 24;
        
        // pokus s vertexy
        BVERTEX *tempvert;
        vbGameField->Lock(0,4*sizeof(BVERTEX),(BYTE **)&tempvert,0);
        tempvert[0].color = 0x00ff0000|((red_alert_alfa>>3)&0xff000000);
        tempvert[1].color = 0x00800000|red_alert_alfa;
        tempvert[2].color = 0x00ff0000|((red_alert_alfa>>1)&0xff000000);
        tempvert[3].color = 0x00800000|red_alert_alfa; //pravy horni
                                                                      /*
                                                                      tempvert[0].color = 0x80800000;
                                                                      tempvert[1].color = 0x80800000;
                                                                      tempvert[2].color = 0x80800000;
                                                                      tempvert[3].color = 0x80800000;
        */
        vbGameField->Unlock();
        
        dx8.lpd3dDevice->SetStreamSource(0,vbGameField,sizeof(BVERTEX));
        dx8.lpd3dDevice->SetVertexShader( (D3DFVF_BVERTEX) );
        dx8.lpd3dDevice->SetTexture(0,NULL);
        
        // zapne podporu pruhlednosti
        dx8.lpd3dDevice->SetRenderState(D3DRS_ALPHABLENDENABLE , TRUE);
        
        // aby to delalo linearni prechod mezi puvodni a novou barvou
        dx8.lpd3dDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
        dx8.lpd3dDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_DESTCOLOR); //D3DBLEND_INVSRCCOLOR, INVSRCALPHA je klasika
        
        // vykreslim obdelnik
        dx8.lpd3dDevice->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 );
    }

	 // fadeout pro spadla klec
	 /*
	 if (exitgame) // puvodne vanish, ale byl problem s nulou
	 {
		 DWORD vanish_alpha  = (vanish_full - vanish) * 255 / vanish_full;
		 vanish_alpha = vanish_alpha << 24;
		 dx8.BltSprite(&backscreen,gfxback,&backgfx,0,vanish_alpha);
	 }
	 */
    
    // na zatku levelu se chvli zobrazuj vodn kecy
    if (interscreen_alpha)
    {
        int linecount = 0;
        while ((s_leveldesc[linecount+2][0] != '\x0') && (linecount < (MAX_TEXTS - 2))) linecount++;
        int hinthalfx = dx8.tilesize * 4;
        int hinthalfy = ((dx8.tilesize) * (linecount + 1)) / 2;
        
        // tmav obdlnk pod text
        s.top = dx8.centery - hinthalfy;
        s.bottom = dx8.centery + hinthalfy;
        s.left = dx8.centerx - hinthalfx;
        s.right = dx8.centerx + hinthalfx;
        dx8.BltSprite(&s,gfxback,&r,0, 0xff000000 & (interscreen_alpha /4) * 3);

        // - levelname
        //fonts[1]->Print(dx8.centerx,150,s_leveldesc[0], 0x00ffffff | interscreen_alpha, ALIGN_CENTER, 255, 40);
        // - heslo
        //fonts[1]->Print(dx8.centerx,210+25,levelname, 0x00ffffff | interscreen_alpha, ALIGN_CENTER, 255, 40);
        // - pokec
        for(i=0; i < linecount; i++)
            fonts[1]->Print(dx8.centerx, s.top + dx8.tilesize / 2 + i * dx8.tilesize, s_leveldesc[i+2], 0x00ffffff | interscreen_alpha, ALIGN_CENTER, 255, dx8.tilesize - 8);
    }
    else
      // nic mi nepek, tak mu vypsat normln message
      message.Paint();
    
    // Vykresleni kontrolnch messages
    fpsmsg.Paint();
#ifdef MURRAYDEBUG
    murraygmsg.Set(murrayg_msg);
    murraybmsg.Set(murrayb_msg);
    murraygmsg.Paint();
    murraybmsg.Paint();
#endif      

	 //fader.Update();
    fader.Paint(&backscreen,gfxback,&backgfx);

   dx8.lpd3dDevice->EndScene();
   dx8.lpd3dDevice->Present( NULL, NULL, NULL, NULL );
}


//==========================================================================
// jeden prubeh hlavni smycky
//==========================================================================
void Game::update(void)
{
    if (gfxback==NULL) return; //*** pracovni finta

   int i,j,k;

   if (!system_frozen)
   {
		Paint();
	}

	//------------------------------------------------------- klavesnice
	kbd.getState();
	
	//------------------------------------------------------ spadla klec
	if (spadla_klec)
	{
		/*
		// je po vem, u jenom ekme na klvesu
		BYTE key;
		if ((key = kbd.LastScan()) != 0 
			&& key != DIK_LMENU && key != DIK_RMENU && key != DIK_TAB)
		{
			kbd.clearKey(key);
			kbd.filter_lastscan = true;
			kbd.lastASCIIReset();
			kbd.lastScanReset();
			app->stateChange();
			return;
		}
		*/
		app->stateChange();
		return;
	}

   //-------------------------------------------------- help

    // zmna stavu pauzy podle pozadavku freeze
   system_frozen ^= freeze;
   freeze = 0;
       
   //testovaci figliky / debugovani /cheaty
   if (s_testsymbol)
   {
      Player *player;
      //skladani kouzel ze symbolu
      for (j=0; j<8; j++)     //projedou se klavesy F1 az F8
      {
         if (KEYDOWN(kbd.diKeys,DIK_F1+j))
         {
            kbd.clearKey(DIK_F1+j);
            if (j<4) 
               player=player1;
            else 
               player=player2;
            if (!(player->state & NOCREDIT))
            { //musim testnout, jestli je drak ve hre
               k = j & 3;
               player->symbuf.Add((BYTE)k);
               player->symbuf.Realize(player);
            }
         }
      }
      if (KEYDOWN(kbd.diKeys,DIK_F10))
      {
         I while (i < sbubbles_ctrl.count)
         {
            ARRAY_AT(sbubbles,i)->Blow(NULL);
            i++;
         }
      }
   }
    // Esc
   if (system_frozen > 0 && KEYDOWN(kbd.diKeys,DIK_ESCAPE))
   {
      sound_device->Play(14);
      system_frozen = 0;
      kbd.clearKey(DIK_ESCAPE);
      time = GetTickCount();
      oldtime = time;
      oldtime2 = time;
      starttime = time - starttime;        // 1: st = y - st 0: st = z-(y-st) = st+z-y
   }
    // pauze
   if (!(system_frozen & ~(SF_PAUSED)) && (KEYDOWN(kbd.diKeys,DIK_P) || KEYDOWN(kbd.diKeys,DIK_PAUSE)))
   {
      sound_device->Play(14);
      freeze = SF_PAUSED; // nastavim pozadavek o zmenu stavu pauzy
      if (!(system_frozen & SF_PAUSED))
      {
			// a zapnme pauzovac hlen, Dave
			strcpy(s_leveldesc[2],"Pauza");
			*s_leveldesc[3] = 0;
			interscreen = 4000; 
			interscreen_alpha = 0xff000000; 
      }
		else
		{
			// ...nebo by se cedule mla vypnout
			interscreen = 0;
		}
      kbd.clearKey(DIK_P);
      kbd.clearKey(DIK_PAUSE);
      time = GetTickCount();
      oldtime = time;
      oldtime2 = time;
      starttime = time - starttime;        // 1: st = y - st 0: st = z-(y-st) = st+z-y
   }

   //------------------------------------------------------------------ FLIP

   if (system_frozen)
   {
      return;
   }

   //------------------------------------------------------------ screenshot
   if (KEYDOWN(kbd.diKeys,DIK_F9) || KEYDOWN(kbd.diKeys,DIK_SYSRQ))
   {
      kbd.clearKey(DIK_F9);
      kbd.clearKey(DIK_SYSRQ);
      sound_device->Play(14);
      dx8.Screenshot();
      message.Set("Screenshot sestelen");
   }

   //----------------------------------------------------------------- CLEAR
   
   //------------------------------------------------------------------ MISC
   if (KEYDOWN(kbd.diKeys,DIK_ESCAPE))
   {
      sound_device->Play(14);
      exitgame=true;
      diedyoung=0;
      app->stateChange(REASON_NOTOPPERS);
      kbd.clearKey(DIK_ESCAPE);
      return;
   }
       
   if (freeze)
      return;

   //------------------------------------------------------------------ TIME
   passcount++;
   globalpasscount++;
   time = GetTickCount();
   if (s_test)
   {
      deltat = time-oldtime;
      fps = 0;
      if (deltat > 1000)
      {
         fps = (passcount * 10000) / deltat;
         fpsavg = globalpasscount * 10000 / (time-starttime);
         sprintf(pom_string,"FPS:%d.%d A:%d.%d",fps/10,fps%10,fpsavg/10,fpsavg%10);
         fpsmsg.Set(pom_string);
         oldtime = time;
         passcount = 0;
      }
   }
   deltat = time - oldtime2;
   oldtime2 = time;
   int game_steps;
   if (deltat > 1000)
      deltat = 20;
   game_steps = (int)(deltat / GAMESTEP_T);

	/*
   if (vanish > 0) 
	{
		vanish -= game_steps;
		if (vanish < 0) vanish = 0;
	}
	*/
	fader.Update(game_steps);
	if (vanish && fader.current<0) 
		vanish = 2;


    //*** tohle bych pak pesunul pod timer.Update
#define ALERT_INTERVAL 990
   if (timer.IsAlert() && (step_global - last_alert) > ALERT_INTERVAL)
   {
        // sirena
      sound_device->Play(21,panpos);
      last_alert = step_global;
      panpos = 640-panpos;
   }
   
   //------------------------------------------------------------------ AKCE
   Creature *pom_cr;
   Teleport *pom_t;
   Bonus *pom_bo;
   UFO *pom_ufo;
   Bubble *pom_b;
   SymbolBubble *pom_sb;
   int r1;

   // --- Ubhn asu ---
   timer.Update(game_steps, !(player1->state & NOTTAKEN) + !(player2->state & NOTTAKEN));
    if (!(timer.alert)) 
    {
        // pokud nen alert, je treba kontrolovat ppn
        hurryup.Update(timer.exacttime);
    }
   
   if (!(player1->state & (INACTIVE)))
      player1->KeyReflex();
   if (!(player2->state & (INACTIVE)))
      player2->KeyReflex();

   // samobublive bublifuky
   if (magictime)
   {
      magiccount += game_steps;
      if (magiccount>magictime)
      {
         magiccount = 0;
         to_fuq++;
      }
    }

   //############################################################
   // Logicka smycka - start
   //############################################################
   for (int step_local=0; step_local < game_steps; step_local++)
   {
      step_global++;
      message.Tick();
        // score_labels->Move(); //to je i o kus dal..?!

		// pocitani interscreenu
		if (interscreen_alpha > 0)
		{
			if (interscreen > 0) 
			{
				if (!(player1->state & NOTTAKEN) || !(player2->state & NOTTAKEN)) interscreen = 0;
				else interscreen--;
			}
			else interscreen_alpha -= 0x01000000;
		}

      //-------------------------------------------------- animace + pohyb
      //------------------------------------------- bublifuky
      I while(i < fuqcount)
      {
         bublifux[i]->Action();
         if ((step_global % bublifux[i]->fTgs) == 0)
         {
            bublifux[i]->jumpNext();
         }
         i++;
      }
      
      //---------------------------------------------- hrac 1
      if ((step_global % player1->fTgs) == 0 && !(player1->state & INBUBBLE)) 
         player1->jumpNext();
      
      if (!(player1->state & (INACTIVE)))
      {
			// je ve hre, tak se hbe a reaguje
         player1->stateReflex();
         player1->Move();
         player1->MapReflex();
      }
      else
      {

			// rozplyvani mrtvoly
         if (player1->state & DEAD) player1->zoom++;

         if (player1->frames.chainid == CHAIN_DYING && player1->frames.looped)
         {
				// prv zhebnul
				player1->Resurrection();

            if (!player1->sheet.lives)
            {               
					// a uz nejsou rezervn ivoty
					player1->state |= DEAD;
					//ARRAY_REMOVE(monsters,monsters_ctrl,player1);
					if (player2->state & DEAD && !vanish)
               {
						// druh hr je taky tuh, take konec
						GameOver();
                  break;
               }
            }
         }
      }
      //---------------------------------------------- hrac 2
      if ((step_global % player2->fTgs) == 0 && !(player2->state & INBUBBLE)) 
         player2->jumpNext();
      
      if (!(player2->state & (INACTIVE)))
      {
         player2->stateReflex();
         player2->Move();
         player2->MapReflex();
      }
      else
      {
			// rozplyvani mrtvoly
         if (player2->state & DEAD) player2->zoom++;

         if (player2->frames.chainid == CHAIN_DYING && player2->frames.looped)
         {
				// prv zhebnul
				player2->Resurrection();

            if (!player1->sheet.lives)
            {
					// a uz nejsou rezervn ivoty
					player2->state |= DEAD;
					//ARRAY_REMOVE(monsters,monsters_ctrl,player2);
               if (player1->state & DEAD && !vanish)
               {
						// druh hr je taky tuh, take konec
						GameOver();
                  break;
               }
            }
         }
      }
      
      //-------------------------------------------- potfurky
      I while(i<monsters_ctrl.count)
      {
         pom_cr = ARRAY_AT(monsters,i);
			if (pom_cr->type == MONSTER)
			{
				
				if (frozen.timecurrent == 0)	
					// pokud nejsou zmrzle, tak se hybou
				{
               if ((step_global % pom_cr->fTgs) == 0)
               {
                  pom_cr->jumpNext();
               }
               pom_cr->KeyReflex();
               pom_cr->Move();
               pom_cr->MapReflex();
				}
			}
			
         i++;
      }
      //-----------------------------------------------bonusy
      I while(i<bonuses_ctrl.count)
      {
         pom_bo = ARRAY_AT(bonuses,i);
         if (pom_bo->counter == BONUS_WARNING)
         {
            sound_device->Play(20);
         }
         if (pom_bo->counter == BONUS_LIFE)
         {
            ARRAY_REMOVE_AT_AND_DELETE(bonuses,bonuses_ctrl,i);
            continue;
         }
         
         if ((step_global % pom_bo->fTgs) == 0) 
            pom_bo->jumpNext();
         pom_bo->Move();
         pom_bo->MapReflex();
         i++;
      }
      
      //----------------------------------------------- ufoni
#ifdef MURRAYDEBUG
      strcpy(murrayg_msg,"MG:");
      strcpy(murrayb_msg,"MB:");
#endif
      I while(i<UFOcnt)
      {
         pom_ufo = UFOs[i];
         if ((step_global % pom_ufo->fTgs) == 0) 
            pom_ufo->jumpNext();
         r1 = pom_ufo->Move();
         if (r1 == OUT_OF_BOUNDS) 
         {
            delete pom_ufo;
            --UFOcnt;
            UFOs[i] = UFOs[UFOcnt];
            --i;
         }
         ++i;
      }
      
      //--------------------------------------------- bubliny
      // rychle
      I while(i < qbubbles_ctrl.count)
      {
         pom_b = ARRAY_AT(qbubbles,i);
         if ((step_global % pom_b->fTgs) == 0)
            pom_b->jumpNext();
         pom_b->Move();
         if (pom_b->IsSlow())
         {
            ARRAY_REMOVE_AT(qbubbles,qbubbles_ctrl,i);
            if (ARRAY_FULL(sbubbles_ctrl))
            {
               delete pom_b;
            }
            else
            {
               ARRAY_ADD(sbubbles,sbubbles_ctrl,pom_b);
               //samopraskaci bubliny
               if (pom_b->selfblowing)
               {
                  pom_b->counter = BUB_DOMINATED;
                  pom_b->sender = pom_b->whose;
               }
            }
            i--;
         }
         i++;
      }
      // pomale
      I while(i < sbubbles_ctrl.count)
      {
         pom_b = ARRAY_AT(sbubbles,i);
         if ((step_global % pom_b->fTgs) == 0) 
            pom_b->jumpNext();
         r1 = pom_b->Move();
         if (r1 & BUB_BLOWSTART)
         {
            to_fuq += pom_b->Blow(NULL);
         }
         if (r1 & BUB_BLOWEND)
         {
            ARRAY_REMOVE_AT_AND_DELETE(sbubbles,sbubbles_ctrl,i);
            i--;
         }
         i++;
      }
      // symbolove
      I while(i < symbubs_ctrl.count)
      {
         pom_sb = ARRAY_AT(symbubs,i);
         if ((step_global % pom_sb->fTgs) == 0)
            pom_sb->jumpNext();
         r1 = pom_sb->Move();
         if (r1 & BUB_BLOWSTART)
         {
            pom_sb->Blow(NULL);
         }
         if (r1 & BUB_BLOWEND)
         {
            ARRAY_REMOVE_AT_AND_DELETE(symbubs,symbubs_ctrl,i);
            i--;
         }
         i++;
      }
      
      //--------------------------------------------teleporty
      I while(i<teleports_ctrl.count)
      {
         pom_t = ARRAY_AT(teleports,i++);
         if ((step_global % pom_t->fTgs) == 0)
         {
            pom_t->jumpNext();
         }
      }         
      
      //-----------------------------------------------dropsy
      if (drops->count) 
         drops->Move();

        score_labels->Move();
      
      //----------------------------------------------------------- kolize
      // playeri vs. mostra
      I while(i<monsters_ctrl.count)
      {
         if (!(player1->state & RESISTANT))
            player1->CollideWith(ARRAY_AT(monsters,i));
         if (!(player2->state & RESISTANT))
            player2->CollideWith(ARRAY_AT(monsters,i));
         i++;
      }
      // playeri vs. ufa
      I while(i<UFOcnt)
      {
         if (!(player1->state & UFO_RESISTANT))
         {
            UFOs[i]->CollideWith(player1);
         }
         if (!(player2->state & UFO_RESISTANT))
         {
            UFOs[i]->CollideWith(player2);
         }
         i++;
      }
      
      // teleporty vs.others
      I while(i<teleports_ctrl.count)
      {
         J while(j<monsters_ctrl.count)
         {
            if(ARRAY_AT(teleports,i)->CollideWith(ARRAY_AT(monsters,j)))
               ARRAY_AT(teleports,i)->Transport(ARRAY_AT(monsters,j));
            j++;
         }
         i++;
      }
      
      // bubliny vs. others
      // nejprve symbolove, jestli je player neprasknul
      I while(i < symbubs_ctrl.count)
      {
         pom_sb = ARRAY_AT(symbubs,i);
         if (player1->action & SPMA_JUMP && !(player1->state & NOSCORING))
         {
            if(pom_sb->CollideWith(player1) > 0)
            {
               pom_sb->Blow(player1);
               i++;
               continue;
            }
         }
         if (player2->action & SPMA_JUMP && !(player2->state & NOSCORING))
         {
            if(pom_sb->CollideWith(player2) > 0)
            {
               pom_sb->Blow(player2);
            }
         }
         i++;
      }
      // pak ty rychlejsi, ze by jako neco chytly
      I while(i<qbubbles_ctrl.count)
      {
         J while(j<monsters_ctrl.count)
         {
            pom_b = ARRAY_AT(qbubbles,i);
            pom_cr = ARRAY_AT(monsters,j);
            if(pom_b->CollideWith(pom_cr) > 0)
            {
               if (pom_cr->type == PLAYER &&
                  (((Player *)pom_cr)->state & DEAD))
               {
                  j++;
                  continue;
               }
               sound_device->Play(5);
               pom_b->Catch(pom_cr);
               ARRAY_REMOVE_AT(monsters,monsters_ctrl,j);
               break;
            }
            j++;
         }
         i++;
      }
      // a jiz testime praskani pomalejsich z nas
      I while(i < sbubbles_ctrl.count)
      {
         pom_b = ARRAY_AT(sbubbles,i);
         if (player1->action & SPMA_JUMP && !(player1->state & NOSCORING))
         {
            if(pom_b->CollideWith(player1) > 0)
            {
               to_fuq += pom_b->Blow(player1);
               i++;
               continue;
            }
         }
         if (player2->action & SPMA_JUMP && !(player2->state & NOSCORING))
         {
            if(pom_b->CollideWith(player2) > 0)
            {
               to_fuq += pom_b->Blow(player2);
            }
         }
         i++;
      }
      // a bubliny mezi sebou
      i = (step_global & 3) * BUB_UNIT;
      k = i + BUB_UNIT;
      if (i > MAX_SBUBS)               // tak to jsou symbolive bubliny
      {
         I while(i < symbubs_ctrl.count)
         {
            j = i+1;
            while(j < symbubs_ctrl.count) 
            {
               ARRAY_AT(symbubs,i)->CollideWith(ARRAY_AT(symbubs,j));
               j++;
            }
            i++;
         } 
      }
      else
      {
         while(i < sbubbles_ctrl.count && i<k) 
         {
            j = i+1;
            while(j < sbubbles_ctrl.count) 
            {
               ARRAY_AT(sbubbles,i)->CollideWith(ARRAY_AT(sbubbles,j));
               j++;
            }
            J while(j < symbubs_ctrl.count) 
            {
               ARRAY_AT(sbubbles,i)->CollideWith(ARRAY_AT(symbubs,j));
               j++;
            }
            i++;
         }
      }
      // playeri vs. bonusy
      I while(i<bonuses_ctrl.count)
      {
         if (!(player1->state & NOSCORING)
            && player1->CollideWith(ARRAY_AT(bonuses,i))
            || !(player2->state & NOSCORING)
            && player2->CollideWith(ARRAY_AT(bonuses,i)))
         {
            sound_device->Play(1);
         }
         i++;
      }
      // a bublifuky
      while(to_fuq)
      {
         if (fuqcount > 0)
         {
            fuq++;
            if (fuq == fuqcount) fuq = 0;
            bublifux[fuq]->to_fuq++;
         }
         to_fuq--;
      }
      player1->symbuf.UpdateFlash();
      player2->symbuf.UpdateFlash();
   }
       
   //############################################################
   // Logicka smycka - konec
   //############################################################

   // vhodne misto pro snizeni platnosti bonusu
   player1->CheckState(game_steps);
   player2->CheckState(game_steps);
   frozen.decrease(game_steps);

   //-------------------------------------------------- finalni akce
   // vybeh murrayho
   if ((monstercnt > 0) && (timer.IsZero()))
   {
      message.Set("Vybh Murray!");
      sound_device->Play(28); //uvitaci chechot!
      ruby = false;
          
      timer.Set(15);
      timer.murray = TRUE;

      if (UFOcnt<MAX_UFOS && !(player1->state & NOCREDIT))
      {
         UFOs[UFOcnt++] = new Murray(310,230, properties.member[ID_MURRAYG],player1);
      }
      if (UFOcnt<MAX_UFOS && !(player2->state & NOCREDIT))
      {
         UFOs[UFOcnt++] = new Murray(310,230, properties.member[ID_MURRAYB],player2);
      }
   }
    // dosly potvory
   if (!monstercnt)
   {
      // zapnuti endportu
      I while(ftports_ctrl.count>0)
      {
         Teleport *pom_ft = ARRAY_AT(ftports,0);
         if (ARRAY_FULL(teleports_ctrl))
         {
            delete pom_ft;
         }
         else
         {
            ARRAY_ADD(teleports,teleports_ctrl,pom_ft);
         }
         ARRAY_REMOVE_AT(ftports,ftports_ctrl,0);
         i++;
      }

      // likvidace vsech UFOs
      for (I i<UFOcnt; i++)
      {
         UFOs[i]->Melt();
      }

      // maze se normalni cas, prechazime na redalertovy
      message.Set("rove vyitna!");
      timer.SetAlert();
		hurryup.alpha = 0; // pokud se zrovna zobrazovaly hodiny, tak ted uz je to nezadouci

        // potvory nejsou a uz nebudou
      monstercnt = -1;

        // zaslouzi si rubn?
      if (ruby)
      {
         pom_bo = new Bonus(295,40,properties.member[ID_RUBY]);
         pom_bo->movex = 0;
         pom_bo->movey = 0;
         if (ARRAY_FULL(bonuses_ctrl))
         {
            delete pom_bo;
         }
         else
         {
            ARRAY_ADD(bonuses,bonuses_ctrl,pom_bo);
         }
      }
   }
   
   if ((monstercnt == -1) && (timer.IsZero()) && (vanish == 0))
	//if ((monstercnt == -1) && (timer.IsZero()) && !fader.direction && fader.current>=0)
   {
        // doly potvory i as, take nastavujeme pznak konce levelu
      strcpy(levelname,nextlvls);
      sound_device->Play(11);
      exitgame = true;
		fader.Set(-4);
		vanish = 1;
   }

	 if (exitgame && vanish == 2 && !spadla_klec)
	 //if (exitgame && !fader.direction && !spadla_klec)
	 {
		 // dohrali jsme... co ted?
 
		 // pokud zijou, vraci zivoty do banku
		 if (!(player1->state & NOCREDIT))
		 {
			 player1->sheet.lives++;	// nepouzivat AddLives, protoze to dela veci navic
		 }
		 if (!(player2->state & NOCREDIT))
		 {
			 player1->sheet.lives++;	// nepouzivat AddLives, protoze to dela veci navic
		 }
		 player1->sheet.UpdateView();

		 // skoncilo to porazkou
		 if (levelname[0] == '%')
		 {
			 spadla_klec = true; 
			 sound_device->Play(22);
			 toppers->clearNew();
			 if (!(s_testholy || s_testsymbol))
			 {
				 toppers->Ins(player1->sheet.name,player1->sheet.score,player1->colour);
				 toppers->Ins(player2->sheet.name,player2->sheet.score,player2->colour);
			 }
			 kbd.filter_lastscan = false;
			 kbd.lastASCIIReset();
			 kbd.lastScanReset();
		 }
		 // skoncilo to vitezstvm
		 else if (levelname[0] == '@')
		 {
			 toppers->clearNew();
			 if (!(s_testholy || s_testsymbol))
			 {
				 toppers->Ins(player1->sheet.name,player1->sheet.score,player1->colour);
				 toppers->Ins(player2->sheet.name,player2->sheet.score,player2->colour);
			 }
			 app->stateChange(REASON_THEEND);
		 }
		 // nebo jedeme dl!
		 else
		 {
			 app->stateChange(REASON_NEXTLEVEL);
		 }
		 return;
	 }
}


//-------------------------------------------------------------------------
// Spadla klec - priprava na odchod ze hry
//-------------------------------------------------------------------------
void Game::GameOver()
{
	// vsichni jsou mrtvi, Dave!
	exitgame = 1;
	levelname[0] = '%';
	levelname[1] = 0;
	
	//***pokus
	/*
	vanish_full = VANISH_FADE_TIME; // tohle by mohlo zajistit prodlevu a jeste 60 vykresleni
	vanish = vanish_full; 
	*/
	vanish = 1; 
	fader.Set(-1);

	// zapnuti info cedule
	strcpy(s_leveldesc[2],"Spadla klec!");
	*s_leveldesc[3] = 0;
	interscreen = 0xffffffff;
	interscreen_alpha = 0xff000000; 
}
      
//-------------------------------------------------------------------------
// uvedeni hry do provozuschopneho stavu pri ztraceni surfaces
//-------------------------------------------------------------------------
void Game::restore()
{
   score_labels->RemoveAll();

#ifdef MURRAYDEBUG
   murraygmsg.Hide();
   murraybmsg.Hide();
#endif
   time = GetTickCount();
   oldtime = time;
   oldtime2 = time;
}

//-------------------------------------------------------------------------
// cinnost pri prechodu aplikace do jineho stavu -> menu, konec, ...
//-------------------------------------------------------------------------
void Game::stop()
{
   score_labels->RemoveAll();
   DoneLevel();
   fpsmsg.Hide();
   message.Hide();
    textureManager->Remove(gfxback);
    //
#ifdef MURRAYDEBUG
   murraygmsg.Hide();
   murraybmsg.Hide();
#endif
}


//==========================================================================
//    Deinicializace levelu
//==========================================================================
void Game::DoneLevel()
{
   int i;
   
   // musi byt pred array_1.RemoveAll, protoze vola notify sveho monstra
   I while (i < UFOcnt) 
   {
      delete(UFOs[i]);
      UFOs[i] = NULL;
      ++i;
   }
   UFOcnt = 0;

   ARRAY_REMOVE(monsters,monsters_ctrl,player1);
   ARRAY_REMOVE(monsters,monsters_ctrl,player2);
   
   ARRAY_REMOVE_ALL(monsters,monsters_ctrl);
   ARRAY_REMOVE_ALL(bonuses,bonuses_ctrl);
   ARRAY_REMOVE_ALL(qbubbles,qbubbles_ctrl);
   ARRAY_REMOVE_ALL(sbubbles,sbubbles_ctrl);
   ARRAY_REMOVE_ALL(symbubs,symbubs_ctrl);
   ARRAY_REMOVE_ALL(teleports,teleports_ctrl);
   ARRAY_REMOVE_ALL(ftports,ftports_ctrl);
   drops->RemoveAll();
   score_labels->RemoveAll();
   I while (i<fuqcount)
   {
      delete(bublifux[i]);
      bublifux[i++] = NULL;
   }
   
   if (map != NULL) delete [] map;
   map = NULL;
   if (windmap != NULL) delete [] windmap;
   windmap = NULL;
}

//==========================================================================
//    Deinicializace hry
//==========================================================================
void Game::DoneGame()
{
   SAFE_DELETE(player1);
   SAFE_DELETE(player2);
}

//==========================================================================
//    Destruktor - deinicializace systemu
//==========================================================================
Game::~Game()
{
    if (vbGameField!=NULL) vbGameField->Release();

   if (nextlvls) 
   {
      delete [] nextlvls;
      nextlvls = NULL;
   }

   if (backname)
   {
      delete [] backname;
      backname = NULL;
   }

    textureManager->Remove(drops->gfx);
    SAFE_DELETE(drops);
    SAFE_DELETE(score_labels);
   
#ifdef FILEDEBUG
   fclose(fw);
#endif
}
