#ifndef GAME_H_BUBWINY
#define GAME_H_BUBWINY

#include "consts.h"
#include "array2.h"
#include "types8.h"
#include "utils.h"
#include "obj_hurry.h"
#include "obj_message.h"
#include "obj_timer.h"
#include "property.h"
#include "sprites.h"
#include "gs_gamestage.h"
#include "drops.h"
#include "score.h"
#include "obj_fader.h"

//  #define FILEDEBUG

#define I i=0;
#define J j=0;

DECLARE_ARRAY_EXTERN(Creature*,monsters,monsters_ctrl,MAX_MONSTERS+2)
DECLARE_ARRAY_EXTERN(Bonus*,bonuses,bonuses_ctrl,MAX_BONUSES);
DECLARE_ARRAY_EXTERN(Bubble*,qbubbles,qbubbles_ctrl,MAX_QBUBS);
DECLARE_ARRAY_EXTERN(Bubble*,sbubbles,sbubbles_ctrl,MAX_SBUBS);
DECLARE_ARRAY_EXTERN(SymbolBubble*,symbubs,symbubs_ctrl,MAX_SYMBUBS);
DECLARE_ARRAY_EXTERN(Teleport*,teleports,teleports_ctrl,MAX_TPORTS);
DECLARE_ARRAY_EXTERN(Teleport*,ftports,ftports_ctrl,MAX_FTPORTS);

extern DropList      *drops;
extern ScoreList     *score_labels;
extern Map           map;
extern WindMap       windmap;
extern Player        *player1, *player2;
extern Texture       tiles_gfx;
extern Texture       keys_gfx;
extern Texture       sym_bubgfx;
extern Texture       timealert_gfx; // hurryup hodiny
extern Texture       timer10_gfx;	// red alert timebar
extern Texture       hourglass_gfx;	// ikona hodin
extern Texture       duration_gfx;   // ukazatele trvn bonus nad hlavou
extern Message       message;
extern char          levelname[20], *nextlvls;
extern bool          exitgame;
extern short         monstercnt;
extern BYTE          startlives;
extern DWORD         time;
extern bool          enteredpass;
extern bool          s_drops;
extern BYTE          s_darken;
extern bool          s_catchy;
extern int           gravitation;
extern Timer         frozen;
extern MainTimer     timer;
//extern WORD        timesecond;
//extern BYTE        timercolor;
extern Properties    properties;
extern char          *backname;
extern char          filnam[20];
extern int           vanish;
//extern int				vanish_full;
extern Fader fader;
   
extern char          s_name[4][32];
extern BYTE          s_key[4][4];
extern char          s_password[32];
extern BYTE          s_vol;
extern BYTE          s_sfx;
extern bool          s_test;
extern bool          s_testsymbol;
extern bool          s_testholy;
extern bool          s_holy;
extern bool          s_report;
extern bool				s_keyhint;
extern bool          s_changepass;
extern bool          s_sound;
extern bool          s_reverse_stereo;
extern char          s_leveldesc[MAX_TEXTS][30];
extern bool          enteredpass;

#ifdef FILEDEBUG
#include <stdio.h>
extern FILE *fw;
#endif

class Game : public GameStage {
	
public:
   int magictime;
   int magiccount;
   int panpos;
   int last_alert;
   int to_fuq;           //kolik symbolu ma vyplivnout
	int hint;				// je v levelu hint?
	DWORD interscreen;
	DWORD interscreen_alpha;
	Hurry hurryup;
	
   //settings a 'systemove' promenne
   bool exitsys;
	Texture gfxback;
	
	// pomocne 
	RECT backgfx;           // RECT pro vykreslovani textury pozadi
	RECT backscreen;        // RECT na obrazovce
	IDirect3DVertexBuffer8* vbGameField;
	// pro vypis
	char txtnum[5];			// cislo levelu
	char txtname[48];			// jmeno levelu
	char txtpass[16];			// heslo do levelu

	int scoreposy;				// pozice, kde se vykresluje score
	int scoresize;				// vka score
	
   Game();
   virtual ~Game ();
	
   virtual void load();
   virtual void start();
   virtual void update();
   virtual void stop();
   virtual void restore();
	
   void startLevel();
   void StartGame();
   int LoadLevel();
   void DoneLevel();
   void DoneGame();
	void Paint();
	void GameOver();
};

#endif