/*
 *--------------------------------------------------------------------
 *
 * Menu
 *
 * Usek hry - menu
 *
 * verze   1.1.1 - 09.10.2004
 * autori  Vojvo - Gunny
 *
 *--------------------------------------------------------------------
 * zmeny
   1.1.1	 / drobne zmeny kolem zobrazovani cheatu
   1.1	 / pridana explicitni dealokace gfx pri ukoncovani menu
 * 1.0.1  - snaha o prvni plnou verzi
 * 0.99.5 - zmena roku v copyrightu
 * 0.99.4 - upravy kvuli AVIPlayeru
 * 0.99.1 - demoverze
 * 0.10.3 - nastaveni hlasitosti
 * 0.10.2 / autori zlute 
 *        - screenshot
 *        - stav klaves se cte primo v update
 * 0.9.8 / darken
 * 0.9.7 - heslo
 * 0.9.5 - toppers
 * 0.9.3 - scrollujici menu
 * 0.8.2 - pridany dalsi funkce menu
 * 0.8.1 - pridana funkcionalita jednoducheho menu
 * 0.7.1 - prvni verze
 *--------------------------------------------------------------------
 */

#include <stdio.h>
#include "consts.h"
#include "types8.h"
#include "utils.h"
#include "pass.h"
#include "exceptions.h"
#include "dx8graph.h"
#include "tex8manager.h"
#include "wsound.h"
#include "application.h"
#include "gs_game.h"
#include "gs_menu.h"

#define MAINMENU_ITEMS     10
#define SCROLLSTEP         4
#define SCROLLSPEEDSTATIC  12000
#define SCROLLSPEEDDYNAMIC 12
#define SCROLLSPEEDMAX     120000

int menu_x[MAINMENU_ITEMS] = 
{ 320, 620,  20, 620,  20 };
int menu_y[MAINMENU_ITEMS] = 
{ 260,  20, 500, 500,  20 };


void ToppersPgUp()
{
	if (toppers->offs == 0) 
		toppers->offs = TOP_MAXTOP - TOP_DISPLAY;
	else if (toppers->offs < TOP_DISPLAY) 
		toppers->offs = 0;
	else
	{
		toppers->offs -= (TOP_DISPLAY - 1);
		while (toppers->offs < 0) 
			toppers->offs += TOP_MAXTOP;
	}
}

void ToppersPgDown()
{
	if (toppers->offs == TOP_MAXTOP - TOP_DISPLAY) 
		toppers->offs = 0;
	else if (toppers->offs > TOP_MAXTOP - 2*TOP_DISPLAY) 
		toppers->offs = TOP_MAXTOP - TOP_DISPLAY; 
	else
	{
		toppers->offs += (TOP_DISPLAY - 1);
		while (toppers->offs > TOP_MAXTOP - TOP_DISPLAY) 
			toppers->offs -= TOP_MAXTOP;
	}
}

void StartToppers()
{
	toppers->offs = 0;
//   app->menu->startToppers();
}

void StopToppers()
{
//   app->menu->stopToppers();
}

void Volume(BYTE b)
{
   if (sound_device != NULL)
      if (b == 0)
         sound_device->SetVolume(-10000);
      else
         sound_device->SetVolume(((int)b)*200-2000);
}

void Darken(BYTE b)
{
	// nedlejte nic, pokud k tomu nemte vn dvod =)
}

void CheckValidKeys()
{
   BYTE keys[8], key_c;
   int current, i;
   bool valid = true, validkeys[8];
   
   current = 0;
   for(i=0;i<8;i++)
      validkeys[i] = true;
   
   while (current < 8)
   {
      key_c =  s_key[current/4][current%4];
      for(i=0; i < current; i++)
      {
         if (keys[i] == key_c)
         {
            validkeys[i] = false;
            validkeys[current] = false;
            valid = false;
         }
      }
      keys[current++] = key_c;
   }

   for(i=0;i<8;i++)
      app->menu->keymenu.item[i+1]->invalid = !validkeys[i];

   if (valid)
   {
      ((MenuLineSwitch2 *)app->menu->keymenu.item[9])->setOption1();
      app->menu-> keymenu.item[9]->invalid = false;
      app->menu->keymenu.item[10]->active = 1;
   }
   else
   {
      ((MenuLineSwitch2 *)app->menu->keymenu.item[9])->setOption2();
      app->menu-> keymenu.item[9]->invalid = true;
      app->menu->keymenu.item[10]->active = 0;
      if (app->menu->keymenu.selected == 10)
      {
         app->menu->keymenu.selected = 1;
         app->menu->keymenu.item[10]->isSelected = 0;
      }
   }
}

//-------------------------------------------------------------------------
// konstruktor
//-------------------------------------------------------------------------
Menu::Menu()   
{
   exitmenu = 0;
   exitsys = 0;
	gfxback = NULL;
	gfxtitle = NULL;
	gfximg = NULL;
	gfximgnext = NULL;
	gfxdragons = NULL;
	gfxpeople = NULL;
	gfxking = NULL;
	gfxsetup = NULL;
	gfxhelp = NULL;
	gfxvictory = NULL;
	alpha = 0;
	alphagrad = 0;
	//crossfade = 1;
	imgfrom.left = 0;
	imgfrom.right = 511;
	imgfrom.top = 0;
	imgfrom.bottom = 383;
	posx = dx8.centerx;

	imgto.left = posx - (long)(imgfrom.right/2 * dx8.mcoefx);
	imgto.right = posx + (long)(imgfrom.right/2 * dx8.mcoefx);
	imgto.top = dx8.centery - (long)((imgfrom.bottom/2 - 30) * dx8.mcoefy);
	imgto.bottom = dx8.centery + (long)((imgfrom.bottom/2 + 30) * dx8.mcoefy);
	movex = 6;
	accx = 0;
}

//-------------------------------------------------------------------------
// inicializuje veci potrebne pro spousteni
//-------------------------------------------------------------------------
void Menu::load()
{
   int i = 0;
   int xpos = dx8.centerx;
	int ypos = (int) (80 * dx8.mcoefy);
	int step = (int)(32 * dx8.mcoefy);

   // hlavni menu
   i = 0;
	mainmenu.item[i++]=new MenuLine(xpos,ypos+i*step," Eriador 2013 (1.55)",0,fonts[0],MASK_RED,MASK_RED);
   mainmenu.item[i++]=new MenuLineSwitch(xpos,ypos+i*step,"Start",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&exitmenu);
   mainmenu.item[i++]=new MenuLineString(xpos,ypos+i*step,"Heslo: ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,s_password,11);
   mainmenu.item[i++]=new MenuLineString(xpos,ypos+i*step,"Hr 1: ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,s_name[0],11);
   mainmenu.item[i++]=new MenuLineString(xpos,ypos+i*step,"Hr 2: ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,s_name[1],11);
   mainmenu.item[i++]=new MenuLineSubmenuProc(xpos,ypos+i*step,"Rekordy",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&toppermenu,StartToppers);
   mainmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Npovda",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&helpmenu);
   mainmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Autoi",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&creditmenu);
   mainmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Nastaven",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&optionmenu); 
   mainmenu.item[i++]=new MenuLineSwitch(xpos,ypos+i*step,"Konec",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&exitsys);
   mainmenu.lines = i; 
   mainmenu.selected = 1;
   mainmenu.item[mainmenu.selected]->isSelected = 1;


   // hlavni menu
   i = 0;
   optionmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"Nastaven",0,fonts[0],MASK_RED,MASK_RED);
   optionmenu.item[i++]=new MenuLineSwitch2(xpos,ypos+i*step,"Bublina chyt draka ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&s_catchy,"zepedu","vdy");
   optionmenu.item[i++]=new MenuLineSwitch2(xpos,ypos+i*step,"Kapiky ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&s_drops,"nevznikaj","jsou vude!");
   optionmenu.item[i++]=new MenuLineSwitch2(xpos,ypos+i*step,"Heslo mnit ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&s_changepass,"se vemi ivoty","vdy");
   optionmenu.item[i++]=new MenuSlider(xpos,ypos+i*step,"Svtlost pozad ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,8,&s_darken,Darken);
   optionmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Nastaven zvuku",!sound_device->werror,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&soundmenu);
   optionmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Nastaven klves",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&keymenu);
   optionmenu.item[i++]=new MenuLineSwitch2(xpos,ypos+i*step,"Klvesy ve he ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&s_keyhint,"nezobrazovat","zobrazovat");
   optionmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Zptky",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&mainmenu);
   optionmenu.lines = i;
   optionmenu.selected = i-1;
   optionmenu.item[optionmenu.selected]->isSelected=1;
   optionmenu.upper=&mainmenu;
   
   // zvuk
   i = 0;
	soundmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"Nastaven zvuku",0,fonts[0],MASK_RED,MASK_RED);
   soundmenu.item[i++]=new MenuLineSwitch2(xpos,ypos+i*step,"Stereo ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&(sound_device->reverse_stereo),"normln","obrcen");
   soundmenu.item[i++]=new MenuSlider(xpos,ypos+i*step,"Hlasitost ",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,10,&s_vol,Volume);
   soundmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Zptky",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&optionmenu);
   soundmenu.lines = i;
   soundmenu.selected = i-1;
   soundmenu.item[soundmenu.selected]->isSelected=1;
   soundmenu.upper=&optionmenu;
   
	// Autoi
   i = 0;
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"Autoi",0,fonts[0],MASK_RED,MASK_RED);
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Programovn: Vojvo-Gunny-Rongi",0,fonts[0]);
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Grafika: Gunny-Grumpfh-Nalim",0,fonts[0]);
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Zvuky: Gunny-Nalim-Lucky",0,fonts[0]);
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Design level: Eriador",0,fonts[0]);
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Organizace level: Lumi",0,fonts[0]);
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Beta testy: Dave-Lenka-Fajmi",0,fonts[0]);
   creditmenu.item[i++]=new MenuLine(xpos,ypos+i*step, " Eriador 1996-2013",0,fonts[0]);
   creditmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Zptky",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&mainmenu);
   creditmenu.lines = i;
   creditmenu.selected = i-1;
   creditmenu.item[creditmenu.selected]->isSelected=1;
   creditmenu.upper=&mainmenu;
   
   // help
   i = 0;
	helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"O co jde",0,fonts[0],MASK_RED,MASK_RED);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Cl hry je naprosto netradin",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "- zlikvidovat potvrky. =)",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Hri ovldaj drky plivajc",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step, "speciln bubliny, kter jsou",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"schopn potvrky polapit.",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"Pak u sta jen bublinu rozbt a",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"potvrka je zlikvidovan. Pokud ji",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"vak hr vas nerozbije, potvrka",0,fonts[0]);
   helpmenu.item[i++]=new MenuLine(xpos,ypos+i*step,"se uvoln a utee.",0,fonts[0]);
   helpmenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Dle",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&help2menu);
   helpmenu.lines = i;
   helpmenu.selected = i-1;
   helpmenu.item[helpmenu.selected]->isSelected=1;
   helpmenu.upper=&mainmenu;

   i = 0;
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step,"Bonusy",0,fonts[0],MASK_RED,MASK_RED);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step, "Pi rozbit obsazen bubliny z n",0,fonts[0]);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step, "vypadne njak ovoce na zub a na",0,fonts[0]);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step, "body a navc se objev speciln",0,fonts[0]);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step, "magick bubliny. Jejich sbrnm",0,fonts[0]);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step,"je mon sestavit kouzelnou",0,fonts[0]);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step,"formuli a nco (ne)uitenho si",0,fonts[0]);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step,"vykouzlit.",0,fonts[0]);
   help2menu.item[i++]=new MenuLine(xpos,ypos+i*step,"Kouzla si zkuste sami!",0,fonts[0]);
   help2menu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Zptky",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&mainmenu);
   help2menu.lines = i;
   help2menu.selected = i-1;
   help2menu.item[help2menu.selected]->isSelected=1;
   help2menu.upper=&mainmenu;

	// Klvesy
   i = 0;
   keymenu.item[i++]=new MenuLine(xpos,ypos+i*step,"Nastaven klves",0,fonts[0],MASK_RED,MASK_RED);
   keymenu.item[i++]=new MenuLineKey(xpos-100,ypos+i*step, "Doleva: ",1,fonts[0],MASK_GREEN&MASK_MENUALPHA,MASK_GREEN,(char*)&(s_key[0][0]));
   keymenu.item[i++]=new MenuLineKey(xpos-100,ypos+i*step, "Doprava: ",1,fonts[0],MASK_GREEN&MASK_MENUALPHA,MASK_GREEN,(char*)&(s_key[0][1]));
   keymenu.item[i++]=new MenuLineKey(xpos-100,ypos+i*step, "Vskok: ",1,fonts[0],MASK_GREEN&MASK_MENUALPHA,MASK_GREEN,(char*)&(s_key[0][2]));
   keymenu.item[i++]=new MenuLineKey(xpos-100,ypos+i*step, "Plivn: ",1,fonts[0],MASK_GREEN&MASK_MENUALPHA,MASK_GREEN,(char*)&(s_key[0][3]));
   keymenu.item[i++]=new MenuLineKey(xpos+100,ypos+i*step,"Doleva: ",1,fonts[0],MASK_BLUE&MASK_MENUALPHA,MASK_BLUE,(char*)&(s_key[1][0]));
   keymenu.item[i++]=new MenuLineKey(xpos+100,ypos+i*step,"Doprava: ",1,fonts[0],MASK_BLUE&MASK_MENUALPHA,MASK_BLUE,(char*)&(s_key[1][1]));
   keymenu.item[i++]=new MenuLineKey(xpos+100,ypos+i*step,"Vskok: ",1,fonts[0],MASK_BLUE&MASK_MENUALPHA,MASK_BLUE,(char*)&(s_key[1][2]));
   keymenu.item[i++]=new MenuLineKey(xpos+100,ypos+i*step,"Plivn: ",1,fonts[0],MASK_BLUE&MASK_MENUALPHA,MASK_BLUE,(char*)&(s_key[1][3]));
   keymenu.item[i++]=new MenuLineSwitch2(xpos,ypos+i*step,"Klvesy jsou ",0,fonts[0],MASK_MENUALPHA,MASK_WHITE,&s_catchy,"v podku","patn!");
   keymenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Zptky",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&optionmenu);
   keymenu.onUpdate = CheckValidKeys;
   keymenu.lines = i;
   keymenu.selected = i-1;
   keymenu.item[keymenu.selected]->isSelected=1;
   keymenu.upper=&optionmenu;  

	// Hiscore
   i = 0;
   toppermenu.item[i++] = new MenuLine(xpos,ypos+i*step,"Nejlep draci",0,fonts[0],MASK_RED,MASK_RED);
	toppermenu.item[i++] = new MenuLineToppers(xpos,ypos+i*step,step,0,fonts[0],MASK_MENUALPHA,MASK_WHITE,toppers);
   toppermenu.item[i++] = new MenuLineSubmenuProc(xpos-dx8.tilesize*2,ypos+9*step,"^",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&toppermenu,ToppersPgUp);
   toppermenu.item[i++] = new MenuLineSubmenuProc(xpos,ypos+9*step,"Zptky",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&mainmenu,StopToppers);
   toppermenu.item[i++] = new MenuLineSubmenuProc(xpos+dx8.tilesize*2,ypos+9*step,"v",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&toppermenu,ToppersPgDown);
   toppermenu.lines = i;
   toppermenu.selected = i-2;
   toppermenu.item[toppermenu.selected]->isSelected=1;
   toppermenu.upper=&mainmenu;  

   // victory
   i = 0;
   victorymenu.item[i++]=new MenuLine(xpos,ypos+i*step,"Vtzstv!",0,fonts[0],MASK_RED,MASK_RED);
   victorymenu.item[i++]=new MenuLine(xpos,ypos+i*step, "To je ve, ptel! ;)",0,fonts[0]);
   victorymenu.item[i++]=new MenuLine(xpos,ypos+i*step, "Dohrli jste celou hru",0,fonts[0]);
   victorymenu.item[i++]=new MenuLine(xpos,ypos+i*step, "a vc u toho pro vs nemme.",0,fonts[0]);
   victorymenu.item[i++]=new MenuLineSubmenu(xpos,ypos+i*step,"Blahopejeme!",1,fonts[0],MASK_MENUALPHA,MASK_WHITE,&menu,&toppermenu);
   victorymenu.lines = i;
   victorymenu.selected = i-1;
   victorymenu.item[victorymenu.selected]->isSelected = 1;
   victorymenu.upper=&toppermenu;

   menu = &mainmenu;
}

//-------------------------------------------------------------------------
// inicializuje vypis hi-scores
//-------------------------------------------------------------------------
void Menu::startToppers()
{
	/*
   DEBUG_MESSAGE("Menu::startToppers()\n");
	
   if (toppers == NULL)
      return;
//   ((MenuLineToppers *)(toppermenu.item[2]))->start();
   DEBUG_MESSAGE("Menu::startToppers()\n");
	*/
}

//-------------------------------------------------------------------------
// deinicializuje vypis hi-scores
//-------------------------------------------------------------------------
void Menu::stopToppers()
{
	/*
   DEBUG_MESSAGE("Menu::stopToppers()\n");
   if (toppers == NULL)
      return;
//   ((MenuLineToppers *)(toppermenu.item[2]))->stop();
   DEBUG_MESSAGE("Menu::stopToppers()\n");
	*/
}

//-------------------------------------------------------------------------
// zahajuje cinnost
//-------------------------------------------------------------------------
void Menu::start()
{
   int xpos = dx8.centerx;

   static bool firsttime = true;
   exitmenu = 0;
	
	textureManager->Load(&gfxtitle,"menu-title.r24","data\\menu.dir");
	rhtitle = textureManager->GetHeader(gfxtitle);
	textureManager->Load(&gfxback,"menu-texture.r24","data\\menu.dir"); //isky.r24, menu2cut.r24, empty.r24
	rhback = textureManager->GetHeader(gfxback);
	
	// muze byt nutne aktualizovat vypis hesla
	MenuLineString * tempitem = (MenuLineString *) mainmenu.item[2];
	tempitem->Refresh();

	textureManager->Load(&gfxdragons,"menu-dragons.r24","data\\menu.dir");
	textureManager->Load(&gfxpeople,"menu-people.r24","data\\menu.dir");
	textureManager->Load(&gfxking,"menu-king.r24","data\\menu.dir");
	textureManager->Load(&gfxsetup,"menu-setup.r24","data\\menu.dir");
	textureManager->Load(&gfxhelp,"menu-help.r24","data\\menu.dir");
	textureManager->Load(&gfxvictory,"menu-win.r24","data\\menu.dir");

	// nastaveni podkladovho obrazku a fade-inu
	gfximgnext = gfxdragons;
	if (menu == &victorymenu) gfximgnext = gfxvictory; // tohle je mon zbyten, ale pro sicher =)
	if (menu == &toppermenu) gfximgnext = gfxking;
	gfximg = gfximgnext;
	alpha = 0;
	alphagrad = 4;

   if (firsttime)
   {
      sound_device->Play(30);
      firsttime = false;
   }
   kbd.filter_lastscan = false;
   kbd.lastScanReset();
   kbd.lastASCIIReset();
   this->oldtime = GetTickCount();
}

//-------------------------------------------------------------------------
// pravidelna cinnost pri kazdem pruchodu hlavni smyckou programu
//-------------------------------------------------------------------------
void Menu::update()
{
   // klavesnice
   kbd.getState();

   if (menu->onUpdate != NULL)
      menu->onUpdate();

   if (KEYDOWN(kbd.diKeys,DIK_ESCAPE))
   {
      if (menu != &keymenu || keymenu.item[10]->active != 0)
      {
         if (menu == &mainmenu)
            exitsys = 1;
         else
            menu=menu->upper;
      }
      kbd.clearKey(DIK_ESCAPE);
   }
   if (s_test && menu==&mainmenu && KEYDOWN(kbd.diKeys,DIK_F11))
   {
      kbd.clearKey(DIK_F11);
      s_testsymbol = !s_testsymbol;
      strcpy(mainmenu.item[0]->text,"Test: xx");
      if (s_testsymbol)
			mainmenu.item[0]->text[6] = 'S';
      if (s_testholy)
			mainmenu.item[0]->text[7] = 'N';
   }
   if (s_test && menu==&mainmenu && KEYDOWN(kbd.diKeys,DIK_F12))
   {
      kbd.clearKey(DIK_F12);
      s_testholy = !s_testholy;
      strcpy(mainmenu.item[0]->text,"Test: xx");
      if (s_testsymbol)
			mainmenu.item[0]->text[6] = 'S';
      if (s_testholy)
			mainmenu.item[0]->text[7] = 'N';
   }         

   if (exitsys)
   {
      app->stateChange(REASON_EXIT);
      return;
   }

   if (exitmenu)
   {
      app->stateChange();
      return;
   }

	// pohyb obrazku
   DWORD deltatime;

   deltatime = GetTickCount() - this->oldtime;
   if (deltatime > 50)
   {
      this->oldtime = GetTickCount();
		
		// posuneme
		if (posx > dx8.centerx) movex --;
		else movex ++;
		posx += movex;
		
		/*
		imgto.left = posx-256;
		imgto.right = posx+255;
		*/
		imgto.left = posx - (imgfrom.right/2 * dx8.mcoefx);
		imgto.right = posx + (imgfrom.right/2 * dx8.mcoefx);

		
		// delame nejaky prechod?
		if (alphagrad != 0)
		{
			// takze se nejak upravi pruhlednost
			alpha += alphagrad;
			if (alpha >= 0x30) 
			{
				alpha = 0x30;
				alphagrad = 0;
			} 
			else if (alpha <=0)
			{
				alphagrad = 4;
				gfximg = gfximgnext;
				gfximgnext = NULL;
			}
		}
   }


	      
   //--------------------------------------------------------- paint
   HRESULT hr;
   if( FAILED( hr = dx8.lpd3dDevice->TestCooperativeLevel() ) )
   {
      if( D3DERR_DEVICELOST == hr ) return;
      if( D3DERR_DEVICENOTRESET == hr ) dx8.Reset();
      return;
   }
   // je teba njak zat kreslit, e jo...
   dx8.lpd3dDevice->BeginScene();
   
	// pozadi
	// nov se skld jako dladice
	RECT rfrom, rto;
	for (int j=0; j<=(dx8.sizey/(rhback->dwHeight)); j++)
	{
		for (int i=0; i<=(dx8.sizex/(rhback->dwWidth)); i++)
		{
			rto.top = j * rhback->dwHeight;
			rto.left = i * rhback->dwWidth;
			rto.bottom = (j+1) * rhback->dwHeight - 1;
			rto.right = (i+1) * rhback->dwWidth - 1;
			dx8.BltSprite(&rto,gfxback,NULL,0);
		}
	}	

	// titulek
	rfrom.top = 0;
	rfrom.bottom = rhtitle->dwHeight; 
	rfrom.left = 0; 
	rfrom.right = rhtitle->dwWidth;
	
	rto.top = (40 - rhtitle->dwHeight / 4) * dx8.mcoefy; // zmensuju na polovinu
	rto.bottom = (40 + rhtitle->dwHeight / 4) * dx8.mcoefy; 
	rto.left = dx8.centerx - (rhtitle->dwWidth / 4 + 15) * dx8.mcoefx; 
	rto.right = dx8.centerx + (rhtitle->dwWidth / 4 + 15) * dx8.mcoefx; 
	dx8.BltSprite(&rto,gfxtitle,&rfrom,0, MASK_ALPHA50);
	
		// promenlivy ilustracni obrazek
	dx8.BltSprite(&imgto,gfximg,&imgfrom,0,0x00ffffff | (alpha<<24) /*|(oldtime&0x7f)<<24*/);

	//fonts[1]->Print(10,10," *0129");
	menu->Paint();

   // dokresleno
   dx8.lpd3dDevice->EndScene();

   if (KEYDOWN(kbd.diKeys,DIK_F9) || KEYDOWN(kbd.diKeys,DIK_SYSRQ))
   {
      kbd.clearKey(DIK_F9);
      kbd.clearKey(DIK_SYSRQ);
	   kbd.lastScanReset();
      sound_device->Play(14);
		dx8.Screenshot();
   }

   // Present the backbuffer contents to the display
   dx8.lpd3dDevice->Present( NULL, NULL, NULL, NULL );

   //---------------------------------------------------------- akce
   menu->KeyReflex();
	// zmena obrazku podle menu
   if (menu == &mainmenu)
   {
		gfximgnext = gfxdragons;
   }
   else if (menu == &toppermenu)
   {
		gfximgnext = gfxking;
   }
   else if (menu == &helpmenu || menu == &help2menu)
   {
		gfximgnext = gfxhelp;
   }
   else if (menu == &creditmenu)
   {
		gfximgnext = gfxpeople;
   }
   else if (menu == &optionmenu || menu == &keymenu)
   {
		gfximgnext = gfxsetup;
   }
   else if (menu == &victorymenu)
   {
		gfximgnext = gfxvictory;
   }

	// mel by se zmenit obrazek?
	if (gfximg != gfximgnext)
	{
		alphagrad = -4;
	}
	
}

//-------------------------------------------------------------------------
// obnoveni po surface lost
//-------------------------------------------------------------------------
void Menu::restore()
{
	/*
   if (menu == &toppermenu)
   {
      ((MenuLineToppers *)(toppermenu.item[2]))->start();
   }
	*/
   time = GetTickCount();
   oldtime = time;

	gfximgnext = gfxdragons;
	if (menu == &victorymenu) gfximgnext = gfxvictory; // tohle je mon zbyten, ale pro sicher =)
	if (menu == &toppermenu) gfximgnext = gfxking;
	gfximg = gfximgnext;
	alpha = 0;
	alphagrad = 4;
}

//-------------------------------------------------------------------------
// cinnost pri zastaveni zobrazovani objektu
//-------------------------------------------------------------------------
void Menu::stop()
{
   textureManager->Remove(gfxvictory, true);
   textureManager->Remove(gfxhelp, true);
   textureManager->Remove(gfxsetup, true);
   textureManager->Remove(gfxking, true);
   textureManager->Remove(gfxdragons, true);
   textureManager->Remove(gfxpeople, true);
   textureManager->Remove(gfxback, true);
   textureManager->Remove(gfxtitle, true);
	//
   kbd.filter_lastscan = true;
}

