/*
 *--------------------------------------------------------------------
 *
 * Keyboard
 *
 * Objekt reprezentujici klavesnici. Implementace pres DirectInput
 *
 * verze   0.0.2 - 10.06.1999
 * autori  Rory
 *
 *--------------------------------------------------------------------
 */

#ifndef KEYBOARD_H_42
#define KEYBOARD_H_42

//#include "dxconsts.h"
#define DIRECTINPUT_VERSION   0x0700

#include <dinput.h>
#include "types8.h"
#include "cbuffer.h"


#define LAST_SIZE    10

#define KEYDOWN(name,key) (name[key] & 0x80)

DECLARE_CBUFFER_EXTERN(BYTE,lastASCII,lastASCII_in,lastASCII_out,lastASCII_size,LAST_SIZE)
DECLARE_CBUFFER_EXTERN(BYTE,lastScan,lastScan_in,lastScan_out,lastScan_size,LAST_SIZE)

extern BYTE ASCIINames[], ShiftNames[], AsKey[];


class Keyboard {
	LPDIRECTINPUT lpDI;
	LPDIRECTINPUTDEVICE lpDIKeyboard;
   BYTE * lastScanSet;
   int lastScanSet_size;
	int shiftState;

public:
   bool filter_lastscan;
	BYTE diKeys[256];
   BYTE cleared[256];

   Keyboard();

	void init(HINSTANCE hInst, HWND hWnd);
	void acquire();
   void clearKey(BYTE key);
   void clearAllKeys();
   void lastASCIIReset();
   void lastScanReset();
   BYTE LastASCII();
   BYTE LastScan();
   void setLastScanSet(BYTE *set, int size);
	void unacquire();
	void getState();
	void done();

   ~Keyboard();
};

extern HRESULT diResult;
extern Keyboard kbd;

#endif

