/*
  MenuObject8
  by Gunny & Vojvo (kind of)
      
  Jednotliv poloky menu.
  Vykreslovn, reakce na klvesy a podobn...

  stav:
   na hrubo pekopan

  todo:
   + otestovat v praxi

  28.10. 2002 / upraveno pro DX8 (bez warning, ale netestovno)
  14. 3. 2001 / ocesano o toppers (pro Boovieho2)
        
-------------------------------------------------------------------------*/

#include <stdio.h> 
#include <string.h>

#include "dx8graph.h"
#include "exceptions.h"
#include "font8.h"
//#include "globals.h"
#include "keyboard.h"
#include "menuobject8.h"
#include "tex8Manager.h"
#include "utils.h"

//#include "topper.h"
#include "wsound.h"


#define MENU_CURSORNORMAL    '|'
#define MENU_CURSORBLINK     'I'
#define MENU_CURSORNONE      ' '

BYTE menu_key;
bool ignore_menu = false;

//-------------------------------------------------------------------------
// konstruktor
//-------------------------------------------------------------------------
MenuObject::~MenuObject(void)
{
   for (int i=0; i<lines; i++) 
   {
      delete(item[i]);
      item[i] = NULL;
   }
   lines = 0;
}

//-------------------------------------------------------------------------
// reakce na klavesy
//-------------------------------------------------------------------------
void MenuObject::KeyReflex()
{ 
   menu_key = kbd.LastScan();
   if (menu_key == 0)
      return;
   
   if (ignore_menu)
   {
      item[selected]->KeyReflex();
      return;
   }
   
   //if ((menu_key == DIK_UP) || (menu_key == DIK_LEFT))
	if (menu_key == DIK_UP)
   {
      kbd.lastASCIIReset();
      item[selected]->isSelected=0;
      /*
      if (item[selected]->cursor)
         item[selected]->changed = 1;
         */
      sound_device->Play(13);
      do
      {
         selected--;
         if (selected<0) selected=lines-1;
      } 
      while (!(item[selected]->active));
      item[selected]->isSelected=1;
   }
   //if ((menu_key == DIK_DOWN) || (menu_key == DIK_RIGHT))
   if (menu_key == DIK_DOWN)
   {
      kbd.lastASCIIReset();
      item[selected]->isSelected=0;
      /*if (item[selected]->cursor)
         item[selected]->changed = 1;
         */
      sound_device->Play(13);
      do
      {   
         selected++;
         if (selected>=lines) selected=0;
      } while (!(item[selected]->active));
      item[selected]->isSelected=1;
   }
   //
   if (menu_key == DIK_HOME)
   {
      kbd.lastASCIIReset();
      item[selected]->isSelected=0;
      /*
      if (item[selected]->cursor)
         item[selected]->changed = 1;
         */
      sound_device->Play(13);
      selected=0;
      while (!(item[selected]->active))
      {
         selected++;
         if (selected>=lines) selected=0;
      }
      item[selected]->isSelected=1;
   }
   if (menu_key == DIK_END)
   {
      kbd.lastASCIIReset();
      item[selected]->isSelected=0;
      /*
      if (item[selected]->cursor)
         item[selected]->changed = 1;
         */
      sound_device->Play(13);
      selected=lines-1;
      while (!(item[selected]->active))
      {
         selected--;
         if (selected<0) selected=lines-1;
      }
      item[selected]->isSelected=1;
   }
   item[selected]->KeyReflex();
}

//-------------------------------------------------------------------------
// vykresleni menu
//-------------------------------------------------------------------------
void MenuObject::Paint()
{
   for (int i=0; i<lines; i++) 
      item[i]->Paint();
}

//========================================================================
//-------------------------------------------------------------------------
// MenuLine - radek menu
//-------------------------------------------------------------------------
//========================================================================

//-------------------------------------------------------------------------
// konstruktor
//-------------------------------------------------------------------------
MenuLine::MenuLine(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca)
{
   x=ix;
   y=iy;
   strcpy(text,txt);
   active=a;
   fnt = f;
   color = c;
   colora = ca;
   isSelected=0;
   len=strlen(text);
   /*
   r.left = 0;
   r.right = 640;
   r.top = iy;
   r.bottom = iy + max(fnt->height,fnt->height);
   */
   //changed=0;
   cursor = 0;
   invalid = false;
}

//-------------------------------------------------------------------------
// reakce na stisk klavesy
//-------------------------------------------------------------------------
void MenuLine::KeyReflex()
{
}

//-------------------------------------------------------------------------
// vykresleni radky menu
//-------------------------------------------------------------------------
void MenuLine::Paint()
{
   //Font8 *f;
   DWORD col;
   if (isSelected) 
      col = colora;
   else if (invalid)
      col = 0xffff0000; // chyba! cervena!
   else
      col = color;
   //putStringCentered(x,y,dest,text,*f);
   //f->puts_c(x,y,dest,text);
   //fnt->Print(x,y,text,col); //*** ? pohoda?
   fnt->Print(x,y,text,col,ALIGN_CENTER, 255, (int)(24 * dx8.mcoefy)); //,ALIGN_CENTER

}

//=========================================================================
//-------------------------------------------------------------------------
// Menu Line String - radka menu - text
//-------------------------------------------------------------------------
//=========================================================================
MenuLineString::MenuLineString(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, char *v, int ml)
                               : MenuLine(ix,iy,txt,a,f,c,ca)
{
   var=v;
   strcpy(label,txt);
   maxlen = ml;
	Refresh();
   /*
   r.left = 0;
   r.right = 640;
   r.top = iy;
   r.bottom = iy + max(fnt1->height,fnt2->height);
   */
   cursor = 1;
   pulse = 0;
}

void MenuLineString::Refresh()
{
   strcpy(text,label);   
   strcat(text,var);
   len = strlen(text);
}

void MenuLineString::Paint()
{
   if (isSelected)
   {
      pulse++;
      if (pulse>12)
      {
         pulse = 0;
         text[len] = MENU_CURSORNORMAL;
      }
      else if (pulse>8) 
      {
         text[len] = MENU_CURSORBLINK;
      }
   }
   else
      text[len] = MENU_CURSORNONE;
   text[len+1] = 0;
   MenuLine::Paint();
}

void MenuLineString::KeyReflex()
{
   BYTE key;
   key = kbd.LastASCII();
   if (key != 0)
   {
      int varlen=strlen(var);
      if (key >= 32)
      {
         if (varlen<maxlen)
         {
            var[varlen] = key;
            var[varlen+1]=0;
            sound_device->Play(17);
         }
         else 
         {
            sound_device->Play(18);
         }
      }
      if (key == 8 && varlen>0)
      {
         var[varlen-1]=0;
         sound_device->Play(15);
      }
      strcpy(text,label);
      strcat(text,var);
      len = strlen(text);
      text[len] = MENU_CURSORNORMAL;
      text[len+1] = '\x0';
      //changed=1;
   }
}

//---------------------------------------------------------------------------

MenuLineSwitch::MenuLineSwitch(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, char *v)
                               : MenuLine(ix,iy,txt,a,f,c,ca)
{
   var=v;
}

void MenuLineSwitch::KeyReflex()
{
   BYTE key;
   key = kbd.LastASCII();
   if ((key == 13) || (key == 32))
   {
      *var=!(*var);
      sound_device->Play(14);
   }
}

//---------------------------------------------------------------------------

MenuLineSwitch2::MenuLineSwitch2(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, bool *v, char *o1, char *o2)
                                 : MenuLine(ix,iy,txt,a,f,c,ca)
{
   varb = v;
   strcpy(label,txt);
   strcpy(option1,o1);
   strcpy(option2,o2);
   if (*varb) 
      strcat(text,option2);
   else 
      strcat(text,option1);
   len=strlen(text);
}

void MenuLineSwitch2::KeyReflex()
{
   BYTE key = kbd.LastASCII();
   if ((key == 13) || (key == 32))
   {
      *varb=!(*varb);
      sound_device->Play(14);
      strcpy(text,label);
      if (*varb) 
         strcat(text,option2);
      else 
         strcat(text,option1);
      len = strlen(text);
      //changed=1;
   }
}

void MenuLineSwitch2::setOption1()
{
   strcpy(text,label);
   strcat(text,option1);
   len = strlen(text);
   //changed=1;
}

void MenuLineSwitch2::setOption2()
{
   strcpy(text,label);
   strcat(text,option2);
   len = strlen(text);
   //changed=1;
}

//---------------------------------------------------------------------------

MenuLineSwitchProc::MenuLineSwitchProc(int ix, int iy, char *txt, int a, 
                                       Font8 *f, DWORD c, DWORD ca, char *v,
                                       char *o1, char *o2, void (*p)(char))
                                       : MenuLineSwitch(ix,iy,txt,a,f,c,ca,v)
{
   proc = p;
   strcpy(label,txt);
   strcpy(option1,o1);
   strcpy(option2,o2);
   if (*var) 
      strcat(text,option2);
   else 
      strcat(text,option1);
   len=strlen(text);
}

void MenuLineSwitchProc::KeyReflex()
{
   BYTE key = kbd.LastASCII();
   if ((key == 13) || (key == 32))
   {
      *var=!(*var);
      sound_device->Play(14);
      strcpy(text,label);
      if (*var) 
         strcat(text,option2);
      else 
         strcat(text,option1);
      len = strlen(text);
      //changed=1;
      proc(*var);
   }
   /*
   if (changed)
      proc(*var);
      */
}

//---------------------------------------------------------------------------

MenuLineSubmenu::MenuLineSubmenu(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, MenuObject **v, MenuObject *nv)
                                 : MenuLine(ix,iy,txt,a,f,c,ca)
{
   var = v;
   newvar = nv;
}

void MenuLineSubmenu::KeyReflex()
{
   if ((menu_key == DIK_RETURN) || (menu_key == DIK_NUMPADENTER) || (menu_key == DIK_SPACE))
   {
      kbd.lastASCIIReset();
      kbd.lastScanReset();
      sound_device->Play(14);
      *var=newvar;
   }
}

//---------------------------------------------------------------------------

MenuLineSubmenuProc::MenuLineSubmenuProc(int ix, int iy, char *txt,
                                         int a, Font8 *f, DWORD c, DWORD ca, MenuObject **v, MenuObject *nv,
                                         void (*p)(void))
                                         : MenuLine(ix,iy,txt,a,f,c,ca)
{
   var=v;
   newvar=nv;
   proc=p;
}

void MenuLineSubmenuProc :: KeyReflex()
{
   if ((menu_key == DIK_RETURN) || (menu_key == DIK_NUMPADENTER) || (menu_key == DIK_SPACE))
   {
      kbd.lastASCIIReset();
      kbd.lastScanReset();
      sound_device->Play(14);
      *var=newvar;
      proc();
   }
}

//---------------------------------------------------------------------------

MenuSlider::MenuSlider(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca,
                       int m, BYTE *v, void (*p)(BYTE))
                       : MenuLine(ix,iy,txt,a,f,c,ca)
{
   strcpy(label,txt);
   int sl=strlen(label);
   max=m;
   var=v;
   for (int i=0;i<*var;i++) text[sl+i]='='; //=, 
   text[sl+i]=0;
   len=strlen(text);
   proc=p;
}

void MenuSlider :: KeyReflex()
{
   if (menu_key == DIK_LEFT)
   {
      if (*var>0)
      {
         sound_device->Play(16);
         (*var)--;
         proc(*var);
         text[--len]=0;
         //changed=1;
      }
      else 
      {
         sound_device->Play(14);
      }
   }
   if (menu_key == DIK_RIGHT)
   {
      if (*var<max)
      {
         sound_device->Play(16);
         (*var)++;
         proc(*var);
         text[len]='='; //''
         text[++len]=0;
         //changed=1;
      }
      else 
      {
         sound_device->Play(14);
      }
   }
}

//---------------------------------------------------------------------------
MenuLineKey::MenuLineKey(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca,
                         char *v)
                         : MenuLineSwitch(ix,iy,txt,a,f,c,ca,v)
{
   strcpy(label,txt);
   MakeLabel();
   expect=0;
   len=strlen(text);
}

void MenuLineKey::MakeLabel()
{
   char *wrk;
   strcpy(text,label);
   wrk=text+strlen(text);
   *wrk='<'; wrk++;
   *wrk=AsKey[*((BYTE*)var)]; wrk++;
   *wrk='>'; wrk++;
   *wrk=0;
}

void MenuLineKey :: KeyReflex()
{
   if (expect && menu_key!=0 && (menu_key<DIK_F1 || menu_key>DIK_F10)
      && menu_key!=DIK_TAB && menu_key!=DIK_F11 && menu_key!=DIK_F12
      && menu_key!=DIK_ESCAPE)
   {
      int kk;
      expect=0;
      // nacteni vytouzene klavesy
      sound_device->Play(14);
      kk= menu_key;
      if (!kk)
      {
         sound_device->Play(8);
      }
      kbd.lastASCIIReset();
      kbd.lastScanReset();
      *var=kk;
      //update stringu
      MakeLabel();
      //changed=1;
      len=strlen(text);  
      ignore_menu = false;
   }
   else
   {
	   if ((menu_key == DIK_RETURN) || (menu_key == DIK_NUMPADENTER) || (menu_key == DIK_SPACE))
      {
         //SoundDevice->Play(14);
         expect = 1;
         strcpy(text,label);
         strcat(text,"???");
         len = strlen(text);
         //changed = 1;
         kbd.lastASCIIReset();
         kbd.lastScanReset();
         ignore_menu = true;
      }
   }
}


//=========================================================================
//-------------------------------------------------------------------------
// Menu Line Toppers
//-------------------------------------------------------------------------
//=========================================================================

MenuLineToppers::MenuLineToppers(int ix, int iy, int s, int a, Font8 *f, DWORD c, DWORD ca, Toppers * t)
:MenuLine(ix,iy,"",a,f,c,ca)
{
	step = s;
	toppers = t;
}

void MenuLineToppers::Paint()
{
	if (!toppers) return;

	char temp[10];
	DWORD cmask;
	int position = TOP_MAXTOP - 1;
	int fontsize = (int)(24 * dx8.mcoefy);
	// pozice sloupecku
	/*
	int col1 = x-(int)(dx8.tilesize*5.5);
	int col2 = x-(int)(dx8.tilesize*4.5);
	int col3 = x+dx8.tilesize*4;
	*/
	int col1 = x-(int)(5.5 * 24 * dx8.mcoefy);
	int col2 = x-(int)(4.5 * 24 * dx8.mcoefy);
	int col3 = x+(int)(4 * 24 * dx8.mcoefy);

	// vypisujeme 8 poloek - obvykle prvnich 6 + 2 posledni vysledky
	for (int i=TOP_DISPLAY-1; i>=0; i--)
	{
		// co bychom tak meli vypsat?
		while ((position > i+toppers->offs) && !(toppers->data[position]->newone)) 
			position--;

		cmask = toppers->data[position]->colormask;
		// novi budou sytou barvou, ostatni pebiraj masku menu
		if (!toppers->data[position]->newone) cmask &= color;

		// tak piseme, co mame
		numtos(position+1,2,temp);
		fnt->Print(col1,y+i*step,temp,cmask,ALIGN_CENTER, 255, fontsize); //,ALIGN_CENTER
		fnt->Print(col2,y+i*step,toppers->data[position]->name,cmask,ALIGN_LEFT, 255, fontsize); //,ALIGN_CENTER
		numtos(toppers->data[position]->score,8,temp);
		fnt->Print(col3,y+i*step,temp,cmask,ALIGN_CENTER, 255, fontsize); //,ALIGN_CENTER

		//
		position--;
	}
}

