#ifndef MENUOBJECT_H_BALLERO
#define MENUOBJECT_H_BALLERO

#define MAXMENU	42

#include "font8.h"
#include "gs_gamestage.h"
#include "types8.h"
#include "topper.h"

class MenuLine {
public:
   int x,y;          //pocatecni pozice (nebo tak neco)
   int active;		   //jde na neho najet kurzorem?
   //int changed;		//nastavi se pri zmene (aby se smazal stary text) - asi zbytecne!
   char text[35];		//zakladni text pro menu
   Font8 *fnt;		   // pouzity font
   DWORD color;      // barva v klidu
   DWORD colora;	   // barva aktivniho radku
   char isSelected;	//bool, jestli je na nem kurzor
   bool invalid;     //je radek neplatny|nespravny?
   int  len;		   //uchovava puldelku v pixlech z min. vykresleni
   int  cursor;      //priznak kurzoru - pri opusteni je nutno smazat
   //RECT r;           //pracovni oblast pro mazani menuline
		
	MenuLine(int ix, int iy, char *txt, int a, Font8 *f, DWORD c = 0xa0ffffff, DWORD ca = 0xffffffff);
	virtual void KeyReflex();  //reakce na klavesy (hlavne enter =)
	virtual void Paint();      //vykresli radek
	virtual ~MenuLine() {};
};

class MenuObject
{
public:
   MenuLine *item[MAXMENU];   //pointry na jednotlive radky
   int lines;		            //pocet pouzitych radku
   int selected;		         //vybrany radek
   MenuObject *upper;	      //pod kterym menu jsme zanoreni (kam se vracet)
   void (*onUpdate)(void);    //akce, ktera se provadi pri kazdem obnoveni menu
	  
   void KeyReflex();	         //reakce na klavesy (kurzor, zbytek dela radek)
   void Paint();	            //vykresli menu
   MenuObject() 
   {
      lines = 0; 
      selected = 1; 
      upper = this; 
      onUpdate = NULL;
   }
   ~MenuObject();
};

//-dal jsou vydedene typy----------------------------------------------------

class MenuLineString : public MenuLine {
public:
   char label[32];      //pevna cast stringu
   char *var;           //pointer na string
   int  pulse;          //blikani kurzoru
   int  maxlen;         //maximalni nacitana delka
	
   MenuLineString(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca,
      char *v, int ml);
   virtual void Paint();      //vykresli radek
   virtual void KeyReflex();  //reakce na ASCII
	void Refresh();				// obnoven zobrazovanho textu, pokud se zmnila promnn
};

class MenuLineSwitch : public MenuLine {
public:
   char *var;		//pointer na switchovanou promennou
	
	MenuLineSwitch(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, char *v);
   virtual void KeyReflex();       //reakce na ASCII
};

class MenuLineSwitch2 : public MenuLine {
public:
   char label[32];		//pevna cast stringu
   char option1[16];		//popis 1
   char option2[16];		//popis 2
   bool *varb;          ////pointer na switchovanou promennou
	
	MenuLineSwitch2(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, 
      bool *v, char *o1, char *o2);
   virtual void KeyReflex();       //reakce na ASCII
   virtual void setOption1();
   virtual void setOption2();
};

class MenuLineSwitchProc : public MenuLineSwitch {
public:
   char label[32];		//pevna cast stringu
   char option1[16];		//popis 1
   char option2[16];		//popis 2
   void (*proc)(char);         //pointer na pointer funkce vyvolane pri zmene
	
   MenuLineSwitchProc(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, 
      char *v, char *o1, char *o2, void (*p)(char));
   virtual void KeyReflex();   //reakce na ASCII
};

class MenuLineSubmenu : public MenuLine {
public:
   MenuObject **var;    //pointer na pointer menu
   MenuObject *newvar;  //menu, ktere nastavi misto neho
	
   MenuLineSubmenu(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, 
      MenuObject **v, MenuObject *nv);
   virtual void KeyReflex();       //reakce na ASCII
};

class MenuLineSubmenuProc : public MenuLine {
public:
   MenuObject **var;          //pointer na pointer menu
	MenuObject *newvar;        //menu, ktere nastavi misto neho
	void (*proc)(void);  //pointer na pointer menu
	
   MenuLineSubmenuProc(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, 
      MenuObject **v, MenuObject *nv, void (*p)(void));
   virtual void KeyReflex();  //reakce na ASCII
};

class MenuSlider : public MenuLine {
public:
   char label[32];         //pevna cast stringu
   int max;                //maximalni hodnota slideru
   void (*proc)(BYTE);     //pointer na pointer menu
   BYTE *var;              //pointer na promennou
	
   MenuSlider(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, int m, 
      BYTE *v, void (*p)(BYTE));
   virtual void KeyReflex();  //reakce na ASCII
};

class MenuLineKey : public MenuLineSwitch {
public:
   char label[16];            //pevna cast stringu (nazev klavesy)
   char expect;
	
   MenuLineKey(int ix, int iy, char *txt, int a, Font8 *f, DWORD c, DWORD ca, char *v);
	void MakeLabel();          //vyrobi novou popisku
	virtual void KeyReflex();  //reakce na ASCII
};

class MenuLineToppers : public MenuLine {
public:
	Toppers * toppers;
	int step;
	/*
   static DWORD oldtime, scrollsteps;
   static bool stopped;
   Surface surf;
   RECT rWindow;
   int height;
   int lastStop;
   int lastSoundl;
   int lastSoundr;
	*/
   
   //MenuLineToppers(int ix, int iy, int wheight);
	MenuLineToppers(int ix, int iy, int s, int a, Font8 *f, DWORD c, DWORD ca, Toppers * t);

   /*
	static void InitSteps();
   static void ComputeSteps();
   void start();
   void stop();
	*/
   virtual void Paint();
};


#endif