//***************************************************************************
//          Hern objekt Fader - stmva a rozednva
//***************************************************************************
/*
  Written by : Gunny
  Language   : VisuC + DX8

objekt zajiuj fadein a fadeout

Obecn by to mlo fungovat tak, e stle b cyklus s paintem
Pokud probh fade, tak se hra nehbe (tj. nechod to pes update hern logiky), ale ve se mus pekreslovat

  2012-02-10 / prototyp

*/

#include "dx8graph.h"
#include "utils.h"
#include "obj_fader.h"

//-------------------------------------------------------------------------
// vykreslen aktulnho ztmaven obrazovky - nebo taky ne
// v tom ppad vrac 0
//-------------------------------------------------------------------------
int Fader::Paint(RECT *pDestRect, Texture pSrcTexture, RECT *pSrcRect)
{
	if (direction)
	{
		/*
      #ifdef CLASSIC_DEBUG
      OutputDebugString("Fader..");
		char ps[12] = "00000-";
		ps[4] += (current % 10);
		ps[3] += ((current / 10) % 10);
		ps[2] += ((current / 100 % 10));
		ps[1] += ((current / 1000 % 10));
      OutputDebugString(ps);
      OutputDebugString("\n");
      #endif      
		*/

		DWORD alpha  = (max - current) * 255 / max;
		alpha = alpha << 24;
		dx8.BltSprite(pDestRect, pSrcTexture, pSrcRect,0, alpha);
	}
	return direction;
}

//-------------------------------------------------------------------------
// aktualizuje prhlednost
//-------------------------------------------------------------------------
void Fader::Update(int steps)
{
	/*
	//*** debugovaci krize
	if (steps>50) steps = 50;
	if (steps<0) steps = 1;
	*/

	if (direction)
	{
		current += (direction * steps);
		if (current>max)
		{
			current = max+1;
			direction = 0;
		}
		else if (current<0)
		{
			current = -1;
			direction = 0;
		}
	}
}

//-------------------------------------------------------------------------
// zane nastavi fade (+ fadein, - fadeout)
//-------------------------------------------------------------------------
void Fader::Set(int dir)
{
	direction = dir;
	if (dir>=0) 	
		current = 0;
	else
		current = max;
}

