//***************************************************************************
//          Hern objekt Hurry - varovn doachzejcho asu
//***************************************************************************
/*
  Written by : Gunny
  Language   : VisuC + DX8

  2010-10-18 / prototyp
*/

#include "tex8manager.h"
#include "dx8graph.h"
#include "wsound.h"
#include "obj_hurry.h"

//-------------------------------------------------------------------------
// inicializace
//-------------------------------------------------------------------------
void Hurry::Init(Texture loadedgfx)
{
    // pointer na grafiku
    gfx = loadedgfx;
    
    // zdroj redbaru
    rectf.left = 0;
    rectf.right = 256;
    rectf.top = 0;
    rectf.bottom = 256;
    
    // cil se dopocitava az pred vykreslenim
    
    // nastavm si pvodn velikost
    halfsize = dx8.tilesize;
    alpha = 0;
    
    // as
    nextbeep = BEEP_INTERVAL * BEEP_TIMES;
}

//-------------------------------------------------------------------------
// update pod vlivem ubihajicho asu
//-------------------------------------------------------------------------
void Hurry::Update(int current_time)
{
    // pokud jsou vidt hodiny, je teba trochu fadovat a tak...
    if (alpha > 0)
    {
        int step = lasttime - current_time; // as kles, take je to zdnliv naopak
        halfsize += (step * dx8.coefy)/250; // jak rychle se bude zvtovat
        alpha -= (step / 30);
        if (alpha < 0) alpha = 0;
        if (alpha > 255) alpha = 0; // nejsem si jisty pretekanim
    }
    
    // nem se nhodou zrovna ppnout a ukzat hodiny?
    if (current_time <= nextbeep)
    {
        // ppme
		 if (nextbeep > 0)
			 // krtk pp
        sound_device->Play(26);
		 else
			 // dlouh pp
        sound_device->Play(27);
        // hodiny by mly bt vidt
        alpha = 255;
		  halfsize = dx8.tilesize;

        nextbeep -= BEEP_INTERVAL;
		  if (nextbeep < 0) nextbeep = BEEP_INTERVAL * BEEP_TIMES;
        lasttime = current_time;
		  //*** nejsem si jisty, co udela druhy pruchod...
    }
}

//-------------------------------------------------------------------------
// vykreslen ikony
//-------------------------------------------------------------------------
void Hurry::Paint()
{
    // jsou hodiny viditeln?
    if (alpha > 0)
    {
    // jak jsou velk?
    DWORD hsize = (DWORD)halfsize;
    rectt.left = dx8.centerx - hsize;
    rectt.right = dx8.centerx + hsize;
    rectt.top = dx8.centery - hsize;
    rectt.bottom = dx8.centery + hsize;
    // 
    dx8.BltSprite(&rectt,gfx,&rectf,0, (alpha << 24)|0x00ffffff );
    }
}
