/*****************************************************************************
//            Hern objekt "message" pro zobrazovn hlen ve he
//*****************************************************************************
//  Written by : Vojvo over Gunny                                              
//  Language   : VisuC + DX6.1                                                 

  2009-12-25 / colour
  2008-06-22 / align je voliteln parametr
				 / message miz do fadeoutu =)
  2008-06-20 / pekopno na font8
  0.99.3 - uprava na sektorove clearovani
  0.9.1 - odstraneno nadbytecne snizovani duration v Paintu
*/

#include <stdlib.h>
#include <string.h>
#include <ddraw.h>
#include "consts.h"
#include "tex8manager.h"
#include "types8.h"
#include "dx8graph.h"
#include "font8.h"
#include "obj_message.h"

//-------------------------------------------------------------------------
// konstruktor
//-------------------------------------------------------------------------
Message::Message()
{
   x = MSG_X;
   y = MSG_Y;
   duration = 0;
	text[0] = 0;
   fnt = fonts[0];
	align = ALIGN_CENTER;
	colour = 0xffffffff;
	size = 0;
}

//-------------------------------------------------------------------------
// nastaveni vlastnosti zobrazovani zprav
//-------------------------------------------------------------------------
void Message::Options(int nx, int ny, int nalign)
{
   x = nx;
   y = ny;
	align = nalign;
}

//-------------------------------------------------------------------------
// iniciuje zobrazeni nove zpravy
//-------------------------------------------------------------------------
void Message::Set(const char *what, DWORD col)
{
	strncpy(text,what,MSGMAX-1);
	text[MSGMAX-1] = 0;
	duration=MSG_DURATION;
	colour = col;
}

//-------------------------------------------------------------------------
// Snizeni counteru
//-------------------------------------------------------------------------
void Message::Tick()
{
   if (duration > 0)
   {
      duration --;
   }
   else
   {
      if (text[0] != 0)
      {
         text[0] = 0;
      }
   }
}


//-------------------------------------------------------------------------
// Vykresluje zpravu
//-------------------------------------------------------------------------
void Message::Paint()
{
   if (duration > 1)
   {
		int alfa = 255;
		if (duration<512) alfa = duration/2;
		fonts[0]->Print(dx8.CoordX(x),dx8.CoordY(y),text,(0x00ffffff&colour)|(alfa<<24),align, 255, size);
   }
}

//-------------------------------------------------------------------------
// Skryje zpravu
//-------------------------------------------------------------------------
void Message :: Hide()
{
   duration = 0;
}
