//***************************************************************************
//          Hern objekt MainTimer pro men a zobrazovn asu
//***************************************************************************
/*
  Written by : Gunny
  Language   : VisuC + DX8

  2010-10-10 / prototyp
*/

#include "tex8manager.h"
#include "dx8graph.h"
#include "obj_hurry.h"
#include "obj_timer.h"

//-------------------------------------------------------------------------
// inicializace
//-------------------------------------------------------------------------
void MainTimer::Init()
{
	// textury nakonec dost divoce nastavuju zvenku... =P
	
	// nastavim si ramecky
	// originln pozice samotnho baru je { 450,15,600,25 }
	
	// zdroj grafiky vetn ramecku
	rectframef.left = 447;
	rectframef.right = 603;
	rectframef.top = 12;
	rectframef.bottom = 28;
	
	// zdroj redbaru
	rectredf.left = 0;
	rectredf.right = 300;
	rectredf.top = 0;
	rectredf.bottom = 20;
	
	// cil ramecku na obrazovce (zavisi na rozliseni)
	rectframet = rectframef;
	if (!dx8.wide)
	{
		rectframet = dx8.Coord(rectframet); 
	}
	else
	{
		//*** jet uvidme
		rectframet.right = dx8.sizex - 50;
		rectframet.left = rectframet.right - rectframef.right + rectframef.left;
	}
	
	// cil redbaru na obrazovce (zavisi na rozliseni)
	rectredt.left = 450;
	rectredt.right = 600;
	rectredt.top = 15;
	rectredt.bottom = 25;
	if (!dx8.wide)
	{
		rectredt = dx8.Coord(rectredt); 
	}
	else
	{
		//*** jet uvidme
		rectredt.right = dx8.sizex - 53;
		rectredt.left = rectredt.right - 150;
	}
	
	// predpripravim si oddelnik pro ztmaveni
	rectpassed = rectredt;
	rectpassed.right = rectpassed.left;

	// ikona hodin
	rectglassf.left = 0;
	rectglassf.right = 40;
	rectglassf.top = 0;
	rectglassf.bottom = 40;

	rectglasst.left = dx8.sizex - 45;
	rectglasst.right = dx8.sizex - 5;
	rectglasst.top = 0;
	rectglasst.bottom = 40;
	
	// jak je teda dlouh cel timer?
	pixlen = rectredt.right - rectredt.left;
	//
	alert = 0;
}

//-------------------------------------------------------------------------
// nastav zadan as
//-------------------------------------------------------------------------
void MainTimer::Set(int value)
{
   fulltime = value * 1000;
   exacttime = fulltime;
    //
    alert = 0;
}

//-------------------------------------------------------------------------
// pechzme na redalert
//-------------------------------------------------------------------------
void MainTimer::SetAlert()
{
   fulltime = 5000;
   exacttime = fulltime;
    //
    alert = 1;
}

//-------------------------------------------------------------------------
// nastav zadan as
//-------------------------------------------------------------------------
void MainTimer::Add(int value)
{
   exacttime += value * 1000;
   if (exacttime > fulltime) exacttime = fulltime;
}


//-------------------------------------------------------------------------
// ubhn asu
//-------------------------------------------------------------------------
void MainTimer::Update(int game_steps, int active_players)
{
	if (exacttime <= 0) return;
	
	// ubihani casu podle stavu hry a hracu
	// cas bezi, pokud je nekdo ve hre nebo je alert
	if (active_players || alert) exacttime -= game_steps;
	
	// pokud neni alert, nenastavoval se cas kvli Murraymu a oba draci 
	// jsou ve hre, tak cas bezi rychleji
	// ... jo a jet vjimka na poslench 5 sec kvli ppn
	
	//*** !(player1->state & NOTTAKEN) = active player
	if ((!alert) && (active_players >= 2) && !murray && (exacttime > BEEP_INTERVAL * BEEP_TIMES))
	{
		exacttime -= game_steps;
	}
	
	/*
	// pip, pip, pip, peeeep
	if (!countdown && plnum == 2 && timer < 2*COUNTDOWN_TIME)
	nextcountdown = 2*COUNTDOWN_TIME;
	
	  if (!is_red_alert && (timer < nextcountdown))
	  {
	  nextcountdown = nextcountdown - COUNTDOWN_INTERVAL * plnum;
	  if (nextcountdown <= 0)
	  {
	  sound_device->Play(27);
	  }
	  else
	  {
	  timealert_dur = TA_DUR;
	  sound_device->Play(26);
	  }
	  timealert_fRect.left = 0;
	  timealert_fRect.right = TA_XSIZE;
	  timealert_fRect.top = 0;
	  timealert_fRect.bottom = TA_YSIZE;
	  countdown = true;
	  }
	*/
	
	// pokud je zporn, tak se vynuluje
	if (exacttime <= 0) 
	{
		exacttime = 0;
		/*
		nextcountdown = COUNTDOWN_TIME;
		countdown = false;
		*/
	}
}

//-------------------------------------------------------------------------
// vykreslen asomry
//-------------------------------------------------------------------------
void MainTimer::Paint()
{
	// pokud neni na liste, je treba vykreslit pozadi
	if (dx8.wide)
	{
		// vykreslime si puvodni timebar i s rameckem +1pix
		dx8.BltSprite(&rectframet,gfxback,&rectframef,0);
		// a jest hodiny
		dx8.BltSprite(&rectglasst,gfxhourglass,&rectglassf,0);
	}
	
	// pokud probiha redalert, musi byt vnitrek cerveny
	if (alert)
	{
		dx8.BltSprite(&rectredt,gfxred,&rectredf,0);
	}
	
	// zleva ho ztmavime o ubehly cas
	pixpassed = pixlen - ((pixlen * exacttime) / fulltime);
	rectpassed.right = rectpassed.left + pixpassed;
	dx8.BltSprite(&rectpassed,gfxback,&rectframef,0,0xc0000000); // ztmavime o 75%
}

//-------------------------------------------------------------------------
// vypisy stavu
//-------------------------------------------------------------------------
BOOL MainTimer::IsZero()
{
	return (exacttime == 0);
}

BOOL MainTimer::IsAlert()
{
	return alert;
}