/*
 *--------------------------------------------------------------------
 *
 * property
 *
 * nacitani a udrzovani properties pro jednotlive herni objekty
 *
 * verze   0.0.2 - 14.06.1999
 * autori  Gunny, Vojvo
 *
 *--------------------------------------------------------------------
 */

#ifndef PROPERTY_H_42
#define PROPERTY_H_42

#define MAX_ID  68
#define MAX_LINE 128

#include "framesv.h"
#include "types8.h"
#include "rfile32.h"

class Property
{
public:
   BYTE id;
   int xsize, ysize, rsize; // rozmery celu a jejich pocet v radku
   int xoff, yoff;          // ofset (u mensich spritu)
   int stablel, stabler;    // body stability
   int speed;               // ???
   int value1;              // bodova hodnota - ovoce, potwory
   int value2;              // bodova hodnota - ovoce, potwory
   int hitx,hity;           // meze pro detekce kolizi
	int margin;					 // vodorovn presah pro kolizi se zd
   Texture surf;            // surface s grafikou
   Texture bubsurf;         // surface s grafikou v bubline;
   RFileHeader *rh;         // hlavicka surface
   RFileHeader *rhb;        // hlavicka surface v bublinama
   Frames frames;           // framechainy
   DWORD fTgs;              // pocet ms na jeden frame animace
   
   Property();
   
   ~Property() 
   {
   }
};

class Properties
{
public:
   Property * member[MAX_ID];

   Properties();
   
   int load(char *filename);

   ~Properties();
   
};

#endif