/*
2008-06-21	opraven bug s dvojitm zavrnm, kter shazoval debug
*/

#include <windows.h>
#include "registry.h"

Registry::Registry(HKEY root)
{
   keyname = NULL;
   key = 0;
   rootKey = root;
   opened = false;
}


void Registry::open(const char *product,DWORD sam)
{
   if (keyname == NULL) 
      keyname = new char[128];
   lstrcpy(keyname,(LPCSTR)"Software\\Eriador\\");
   lstrcat(keyname,product);
   if (RegOpenKeyEx(rootKey,keyname,0,sam,&key) == ERROR_SUCCESS)
   {
      opened = true;
   }
}

void Registry::create(const char *product)
{
   if (keyname == NULL)
      keyname = new char[128];
   lstrcpy(keyname,"Software\\Eriador\\");
   lstrcat(keyname,product);
   DWORD dwDisposition;
   if (RegCreateKeyEx(rootKey,keyname,0,"",REG_OPTION_NON_VOLATILE,
      KEY_ALL_ACCESS,NULL,&key,&dwDisposition) == ERROR_SUCCESS)
   {
      opened = true;
   }
   opened = false;
}

void Registry::remove(const char *subkey)
{
   if (opened)
      close();
   RegDeleteKey(rootKey,subkey);
}

void Registry::close()
{
   RegFlushKey(key);
   RegCloseKey(key);
   RegCloseKey(rootKey);
	opened = false;
}

void Registry::readDWORD(const char *name, DWORD *dest)
{
   DWORD size = sizeof(DWORD);
   RegQueryValueEx(key,name,NULL,NULL,(BYTE *)dest,&size);
}

void Registry::readString(const char *name, char *dest, DWORD size)
{
   RegQueryValueEx(key,name,NULL,NULL,(BYTE *)dest,&size);
   dest[size] = '\x0';
}

void Registry::writeDWORD(const char *name, DWORD data)
{
   RegSetValueEx(key,name,0,REG_DWORD,(BYTE *)(&data),sizeof(DWORD));
}

void Registry::writeString(const char *name, const char *data)
{
   RegSetValueEx(key,name,0,REG_SZ,(BYTE *)data,strlen(data)+1);
}

Registry::~Registry()
{
   if (opened)
      close();
   if (keyname != NULL)
   {
      delete [] keyname;
      keyname = NULL;
   }
}