/*-------------------------------------------------------------------------
// RXX graphic format (R16, r24, (r32))
// Autori: - Vojvo, / Gunny
//-------------------------------------------------------------------------

  stav:
  * neumi nacitat R32 do surfacu 888! (to by ale ani nemelo nastavat)
  ? u r24 se ignoruje color_key (to by mela resit alfa, ne?)

  *** je treba otestovat load vech kombinaci R16..R32
  (R24 i alfa by melo byt)
  (R24 bez alfy (cili nactene do 565) se v nekterych blend modech divne vykresluje)
  (R16 by snad melo byt ok, ale te pouv natvrdo textury 1555, take pozor!)
    
  / changes:
  2008-06-22 / pro R16 pouv textury 1555 a nastavuje alfa bit
  2008-06-21 / oprava loadu komprimovanho R16 (pouvat ku textury)
  2008-06-20 / oprava loadu R16 (je tam zmatek ve znaen hloubky)
  12. 5.2002 / loadRfile si vybr vhodn formt textury
             nkolik bugfix u rastrovn
  25. 3.2002 / pidan Release surfacu po natn do textury
                   (jinak by nesedl poet referenc)
  11. 3.2002 / chybu natn alfa kanlu e bmp2R24 v1.01
                   pidno natn komprimovanho alfa kanlu
   7. 3.2002 / pidno natn nekomprimovanho alfa kanlu (zatm buguje)
                   opravena chyba s ponechnm libovolnho rozmru textury
                   (te u se zaokrouhluj na nejbli mocniny dvou)
   2. 1.2002 / pekopno loadovn
  21. 7.2001 / pidna byAlpha (ale nic se podle ne neridi)
  14. 7.2001 / vyhozeny fce saver16 a loadXBYTE (u nebudou poteba)
  17. 2.2001 / loadR24byte
  28. 1.2001 / opravena rastrovaci maska (o bit dolu) - klicovani je ok
  27. 1.2001 / v 16 bitech se r32 rastruje (ale zatim demoluje klicovani)
  17.07.2000 - prevod ze 16 bitu do 24/32 nastavuje i dolni 3 bity
               barvy podle hornich trech bitu
  16.07.2000 - nova polozka hlavicky Flags:BYTE priznaky
               bit 0 - fixed font | variable font
  29.06.2000 - nahravani nemusi vedet o tom, jde-li o r16 nebo r24
  28.06.2000 - nahravani do surface podle poctu bitu 
               (konec predpokladu 16-bitu)
             - R16Header nahrazen RFileHeaderem
  08.12.1999 - uprava loadovani struktur
  01.08.1999 - predelane exceptions
  31.07.1999 / opravena chyba pri dekompresi na 565
  25.07.1999 / mela by chodit dekomprese (netestovano) 
*/

#include <stdio.h>
#include "fakedir.h"
#include "dx8graph.h"
#include "exceptions.h"
#include "utils.h"
#include "rfile32.h"

const char RFILE_ID[4] = "RXX";
const char RFILE_OLDID[4] = "002";
const char RFILE_DAT[4] = "DAT";

void LoadRHeader(FILE *input,RFileHeader &header,RFileHeader *hdr);
void LoadR16(Surface _dest,FILE *_input,RFileHeader &_header,const char *_name);
void LoadR24(Surface _dest,FILE *_input,RFileHeader &_header,const char *_name);

// priprava =) 
// POZOR! Pot s tm, e je v souboru 5 zelenych bitu a e textura je 1555
#define PLACEPIXEL16 \
{ \
   WORD pixval; \
	WORD alfa = 0x8000; \
   if (that==COLOR_KEY555) alfa = 0; \
   pixval = (bGBitsLoaded) ? (that|alfa) : C555TO565(that); \
   *((WORD *)pos) = pixval; \
   pos += 2; \
   linepos++; \
   if ((DWORD)linepos >= _header.dwWidth) \
{ \
	linepos = 0; \
   linenum++; \
   pos = lpSurface + (lPitch * linenum); \
} \
   i++; \
} 
#define PLACEPIXEL24 \
{ \
   pos[0] = (BYTE)(((that & 0x001F) << 3)+((that & 0x001F) >> 2)); \
   pos[1] = (BYTE)(((that & 0x03E0) >> 2)+((that & 0x03E0) >> 7)); \
   pos[2] = (BYTE)(((that & 0x7C00) >> 7)+((that & 0x7C00) >> 12)); \
   pos += 3; \
   linepos++; \
   if ((DWORD)linepos >= _header.dwWidth) \
{ \
   linepos = 0; \
   linenum++; \
   pos = lpSurface + (lPitch * linenum); \
} \
   i++; \
} 
#define PLACEPIXEL32 \
{ \
   pos[0] = (BYTE)(((that & 0x001F) << 3)+((that & 0x001F) >> 2)); \
   pos[1] = (BYTE)(((that & 0x03E0) >> 2)+((that & 0x03E0) >> 7)); \
   pos[2] = (BYTE)(((that & 0x7C00) >> 7)+((that & 0x7C00) >> 12)); \
   pos[3] = 0; \
   pos += 4; \
   linepos++; \
   if ((DWORD)linepos >= _header.dwWidth) \
{ \
   linepos = 0; \
   linenum++; \
   pos = lpSurface + (lPitch * linenum); \
} \
   i++; \
}


//-------------------------------------------------------------------------
// vytvari surface, otvira soubor, cte hlavicku a vola proceduru pro 
// nacteni dat podle zjistene verze R souboru
// bpp je limit - pokud je 16, vytvori se textura 555, 565 nebo 4444

// chybi nastavovat i nahradni formaty
//-------------------------------------------------------------------------
Texture LoadRFile(const char *_name, const char *_fakename, 
                  RFileHeader *_hdr, int bpp_limit) 
{
   Texture tex;
   Surface surf;        // pouziva se pro primy pristup
   RFileHeader header;
   FILE *input;
   
   // open file
   input = fakeopen(_fakename,_name,"rb");
   if (input == NULL)
   {
      sprintf(exc_string,"LoadRFile: fakeopen(%s) selhal!",_name);
      throw new Exception(exc_string);
   }
   
   // nacteni hlavicky
   LoadRHeader(input,header,_hdr);
   
   // test spravnosti souboru
   if (strcmp(header.szId,RFILE_ID) && strcmp(header.szId,RFILE_OLDID))
   {
      fclose(input);
      sprintf(exc_string,"LoadRFile: %s nen R soubor!",_name);
      throw new Exception(exc_string);
   }
   if (strcmp(header.szStartData,RFILE_DAT))
   {
      fclose(input);
      sprintf(exc_string,"LoadRFile: %s - hlavika m patnou dlku!",_name);
      throw new Exception(exc_string);
   }
   
   // vytvoreni textury
   D3DFORMAT format = D3DFMT_UNKNOWN;
   // format 565 by mel byt dostupny, takze nema cenu se zabyvat 555

   //*** mon by se mohly nastavovat i njak dal nhradn formty
   /*
   R16 - 565 (555)
   R24 - 8888, 565 (555)
   R32 - 8888, 4444
   */
	// pozor! Depth v R16 je bu 5 nebo 6! (tj. 15 nebo 16 bit)
   if ((header.byDepth == 16) || (header.byDepth == 6) || (header.byDepth == 5))
   {
      // 16
      if (dx8.fmt_status[FMT_R5G6B5]) format = D3DFMT_A1R5G5B5; // potebuju alfu!
   }
   else
   {
      // 24 nebo 32
      if (bpp_limit >= 24)
      {
         // prepych! melo by jet 8888 (ale treba i815 to neumi)
         if (dx8.fmt_status[FMT_A8R8G8B8]) format = D3DFMT_A8R8G8B8;
         // pro jistotu rezerva...
         else if (header.byAlpha == 0)
         {
            // neni alfa - 565
            if (dx8.fmt_status[FMT_R5G6B5]) format = D3DFMT_R5G6B5;
         }
         else
         {
            // je s alfou - 4444
            if (dx8.fmt_status[FMT_A4R4G4B4]) format = D3DFMT_A4R4G4B4;
         }
      }
      else
      {
         // force16
         if (header.byAlpha == 0)
         {
            // neni alfa - 565
            if (dx8.fmt_status[FMT_R5G6B5]) format = D3DFMT_R5G6B5;
            //if (dx8.fmt_status[FMT_A4R4G4B4]) format = D3DFMT_A4R4G4B4;
         }
         else
         {
            // je s alfou - 4444
            if (dx8.fmt_status[FMT_A4R4G4B4]) format = D3DFMT_A4R4G4B4;
         }
      }
   }

   if (format == D3DFMT_UNKNOWN)
   {
      fclose(input);
      throw new DDException("LoadRFile: None available texture format!",ddResult);
   }

   // je treba nastavit rozmery textury (nejblizsi vetsi mocninu 2)
   DWORD p2width = powerof2(header.dwWidth);
   DWORD p2height = powerof2(header.dwHeight);
   ddResult = dx8.lpd3dDevice->CreateTexture(p2width, p2height, 1, 0, format, D3DPOOL_MANAGED, &tex);
   if (ddResult != D3D_OK)
   {
      fclose(input);
      throw new DDException("LoadRFile: CreateTexture() chyba!",ddResult);
   }

   // nastaveni color keye
   /*
   DDCOLORKEY ddCKey;
   ddCKey.dwColorSpaceLowValue = (DWORD) dd_dwColorKey;
   ddCKey.dwColorSpaceHighValue = (DWORD) dd_dwColorKey;
   ddResult = surf->SetColorKey(DDCKEY_SRCBLT,&ddCKey);
   if (ddResult != DD_OK)
   {
   fclose(input);
   throw new DDException("LoadRFile: SetColorKey() chyba!",ddResult);
   }
   */
   
   // sahnu si na surface
   ddResult = tex->GetSurfaceLevel(0, &surf);
   if (ddResult != D3D_OK)
   {
      fclose(input);
      throw new DDException("LoadRFile: GetSurfaceLevel() chyba!",ddResult);
   }
   
   // nahrani datove casti
   switch (header.byDepth)
   {
   case 5:
   case 6:
   case 15:
   case 16:
      LoadR16(surf,input,header,_name);
      break;
   case 24:
      LoadR24(surf,input,header,_name);
      break;
      /*
   default:
      LoadR24(surf,input,header,_name);
      */
   }

   // zlikviduju referenci zvysenou kvuli surfacu
   surf -> Release();

   return tex;
}

//-------------------------------------------------------------------------
// otvira soubor, cte hlavicku a vola proceduru pro nacteni dat podle 
// zjistene verze R souboru do jiz existujici surface

// OK?
//-------------------------------------------------------------------------
Texture ReLoadRFile(Texture _tex, const char *_name, const char *_fakename, 
                    RFileHeader *_hdr)
{
   RFileHeader header;
   Surface surf;
   FILE *input;
   
   // open file
   input = fakeopen(_fakename,_name,"rb");
   if (input == NULL)
   {
      sprintf(exc_string,"LoadRFile: fakeopen(%s) selhal!",_name);
      throw new Exception(exc_string);
   }
   
   // nacteni hlavicky
   LoadRHeader(input,header,_hdr);
   
   // test spravnosti souboru
   if (strcmp(header.szId,RFILE_ID) && strcmp(header.szId,RFILE_OLDID))
   {
      fclose(input);
      sprintf(exc_string,"ReLoadRFile: %s nen R soubor!",_name);
      throw new Exception(exc_string);
   }
   if (strcmp(header.szStartData,RFILE_DAT))
   {
      fclose(input);
      sprintf(exc_string,"ReLoadRFile: %s - hlavika m patnou dlku!",_name);
      throw new Exception(exc_string);
   }
   
   // sahnu si na surface
   ddResult = _tex->GetSurfaceLevel(0, &surf);
   if (ddResult != D3D_OK)
   {
      fclose(input);
      throw new DDException("LoadRFile: GetSurfaceLevel() chyba!",ddResult);
   }
   
   // nahrani datove casti
   switch (header.byDepth)
   {
   case 5:
   case 6:
   case 15:
   case 16:
      LoadR16(surf,input,header,_name);
      break;
   case 24:
      LoadR24(surf,input,header,_name);
      break;
   }
   return _tex;
}

//-------------------------------------------------------------------------
// nahrava hlavicku R souboru + kopiruje ji do pripadne kopie

// OK
//-------------------------------------------------------------------------
void LoadRHeader(FILE *input, RFileHeader &header, RFileHeader *hdr)
{
   // nacteni hlavicky
   fread(&(header.szId),sizeof(header.szId),1,input);
   fread(&(header.dwWidth),sizeof(DWORD),1,input);
   fread(&(header.dwHeight),sizeof(DWORD),1,input);
   fread(&(header.dwCelWidth),sizeof(DWORD),1,input);
   fread(&(header.dwCelHeight),sizeof(DWORD),1,input);
   fread(&(header.byCelRow),sizeof(BYTE),1,input);
   fread(&(header.byDepth),sizeof(BYTE),1,input);
   fread(&(header.byType),sizeof(BYTE),1,input);
   fread(&(header.byFontFirst),sizeof(BYTE),1,input);
   fread(&(header.byVersion),sizeof(BYTE),1,input);
   fread(&(header.byFlags),sizeof(BYTE),1,input);
   fread(&(header.byAlpha),sizeof(BYTE),1,input);
   fread(&(header.reserved),sizeof(BYTE),RHDR_RESERVED_CNT,input);
   fread(&(header.szStartData),sizeof(header.szStartData),1,input);
   
   if (hdr != NULL)
   {
      strcpy(hdr->szId,header.szId);
      hdr->dwWidth = header.dwWidth;
      hdr->dwHeight = header.dwHeight;
      hdr->dwCelWidth = header.dwCelWidth;
      hdr->dwCelHeight = header.dwCelHeight;
      hdr->byCelRow = header.byCelRow;
      hdr->byDepth = header.byDepth;
      hdr->byType = header.byType;
      hdr->byFontFirst = header.byFontFirst;
      hdr->byVersion = header.byVersion;
      hdr->byFlags = header.byFlags;
      hdr->byAlpha = header.byAlpha;
   }
}


//-------------------------------------------------------------------------
// nahrava data z otevreneho streamu R16 do surface, predpoklada se,
// ze cteci hlava je na pozici prvniho datoveho bajtu - za hlavickou

// chybi predelat na dx8
//-------------------------------------------------------------------------
void LoadR16(Surface _dest, FILE *_input, RFileHeader &_header, 
             const char *_name)
{
   D3DSURFACE_DESC d3dsd;
   D3DLOCKED_RECT locked;
   BYTE *lpSurface;
   long lPitch;
   bool bGBitsLoaded;	// priznak shody zelenych bit v souboru a v pameti
   DWORD dwWidth, dwHeight;
   DWORD bitCount;
   D3DFORMAT format;
   BYTE r16gb;
   BYTE byGBits = 6; // pocet zelenych bitu v texture v pameti
   
   // zamceni surface
   dx8.LockSurface(_dest, &locked, NULL, 0);
   lpSurface = (BYTE *)locked.pBits;
   lPitch = locked.Pitch;
   
   // zjisteni parametru surfacu
   _dest->GetDesc(&d3dsd);
   dwWidth = d3dsd.Width;
   dwHeight = d3dsd.Height;
   format = d3dsd.Format;
   if (format == D3DFMT_R8G8B8) bitCount = 24;
   else if (format == D3DFMT_A8R8G8B8) bitCount = 32;
   else if (format == D3DFMT_A1R5G5B5) 
   {
      bitCount = 16; //???
      byGBits = 5;
   }
   else if (format == D3DFMT_A4R4G4B4) bitCount = 12; // Co s tim???
   else if (format == D3DFMT_R5G6B5) bitCount = 16;
   
   
   // test velikosti surface
   if (dwWidth < _header.dwWidth || dwHeight < _header.dwHeight)
   {
      _dest->UnlockRect();
      fclose(_input);
      sprintf(exc_string,"LoadR16: %s m nesprvn rozmry!",_name);
      throw new Exception(exc_string);
   }
   
   // zjisteni souhlasu nactenych a skutecnych zelenych bitu
   r16gb = _header.byDepth;
   if (r16gb > 10)
      r16gb -= 10;
   if ((bitCount == 16) && (int)r16gb == byGBits)
      bGBitsLoaded = true;
   else
      bGBitsLoaded = false;
   
   // jak to vypada s formatem?
   if (_header.byType == 2)
   {
      // KOMPRIMOVANE!!!
      
      BYTE *pos = lpSurface;
      // tak ted ta dekomprese!
      int size = (_header.dwWidth)*(_header.dwHeight);
      
      // jedeme skrz
      BYTE wr;
      WORD last = 0;
      WORD that = 0;
      WORD dif;
      BYTE rep;
      //
      int dr,dg;
      int i = 0;
      long linepos = 0, linenum = 0;
      while (i<size)
      {
         // cteni ze souboru
         if (fread(&wr,1,1,_input)==1)
         {
            if (wr&0x80)
            {
               // specialni znak
               if (wr&0x3f)
               {
                  // je to relativni rozdil
                  dr = (wr&0x30);
                  dg = (wr&0x0c);
                  dif = (wr&0x03);
                  dif |= (dg<<3);
                  dif |= (dr<<6);
                  // kterym smerem se rozdil pocita?
                  if (wr&0x40)
                  {
                     // minus
                     that -= dif;
                  }
                  else
                  {
                     // plus
                     that += dif;
                  }
                  // zapis do surfacu
                  if (bitCount == 16)
                     PLACEPIXEL16
                     else if (bitCount == 24)
                     PLACEPIXEL24
                     else if (bitCount == 32)
                     PLACEPIXEL32
               }
               else
               {
                  // je to stejny pixel
                  // zapis do souboru
                  if (bitCount == 16)
                     PLACEPIXEL16
                     else if (bitCount == 24)
                     PLACEPIXEL24
                     else if (bitCount == 32)
                     PLACEPIXEL32
                     // je tam i nejake opakovani?
                     if (wr&0x40)
                     {
                        // opakuje se vicekrat
                        fread(&rep,1,1,_input); //(wr&0x3f);
                        // zapis do surfacu
                        if (bitCount == 16)
                        {
                           while (rep>0) 
                           {
                              PLACEPIXEL16
                              rep--;
                           }
                        }
                        else if (bitCount == 24)
                        {
                           while (rep>0) 
                           {
                              PLACEPIXEL24
                              rep--;
                           }
                        }
                        else if (bitCount == 32)
                        {
                           while (rep>0) 
                           {
                              PLACEPIXEL32
                              rep--;
                           }
                        }
                     }
               }
            }
            else
            {
               // proste pixel
               that = wr;
               that = (that << 8);
               fread(&wr,1,1,_input);
               that = (that | wr);
               // zapis do surfacu
               if (bitCount == 16)
                  PLACEPIXEL16
                  else if (bitCount == 24)
                  PLACEPIXEL24
                  else if (bitCount == 32)
                  PLACEPIXEL32
            }
         }
         else
         {
            // krizka - cosi nevyslo
            that = 0x007f;
            // zapis do surface
            if (bitCount == 16)
               PLACEPIXEL16
               else if (bitCount == 24)
               PLACEPIXEL24
               else if (bitCount == 32)
               PLACEPIXEL32
         }
      }
   }
   else
   {
      // NEKOMPRIMOVANE
      WORD value;
      BYTE *pos = lpSurface;
      WORD gM = (r16gb == 5) ? 0x03E0 : 0x07E0;
      WORD rM = (r16gb == 5) ? 0x7C00 : 0xF800;
      BYTE gShft = r16gb-3;
      BYTE rShft = r16gb+2;
      
      for(DWORD i = 0; i < _header.dwHeight; i++)
      {
         pos = lpSurface + i * lPitch;
         for (DWORD j = 0; j < _header.dwWidth; j++)
         {
            if (fread(&value,sizeof(WORD),1,_input) < 1)
            {
               _dest->UnlockRect();
               fclose(_input);
               sprintf(exc_string,"reLoadR16: chyba pi ten %s!",_name);
               throw new Exception(exc_string);               
            }
            if (bitCount == 16)
            {
               if (!bGBitsLoaded)
               {
                  if (byGBits == 5)
                     *((WORD *)(pos)) = C565TO555(value);
                  else
                     *((WORD *)(pos)) = C555TO565(value);
               }
               else
               {
						WORD alfa = 0x8000;
						if (value==COLOR_KEY555) alfa = 0;
                  *((WORD *)(pos)) = (value|alfa);
               }
               pos += 2;
            }
            else if (bitCount == 24)
            {
               pos[0] = (BYTE)(((value & 0x001F) << 3)+((value & 0x001F) >> 2)); \
                  pos[1] = (BYTE)(((value & gM) >> gShft)+((value & gM) >> (gShft+6))); \
                  pos[2] = (BYTE)(((value & rM) >> rShft)+((value & rM) >> (rShft+5))); \
                  pos += 3;
            }
            else if (bitCount == 32)
            {
               pos[0] = (BYTE)(((value & 0x001F) << 3)+((value & 0x001F) >> 2)); \
                  pos[1] = (BYTE)(((value & gM) >> gShft)+((value & gM) >> (gShft+6))); \
                  pos[2] = (BYTE)(((value & rM) >> rShft)+((value & rM) >> (rShft+5))); \
                  pos[3] = 0;
               pos += 4;
            }
         }
      }
   }
   _dest->UnlockRect();   
   fclose(_input);
}

//-------------------------------------------------------------------------
// nahrava data z otevreneho streamu R24 do surface, predpoklada se,
// ze cteci hlava je na pozici prvniho datoveho bajtu - za hlavickou

// chybi predelat na dx8 a alfa
//-------------------------------------------------------------------------
void LoadR24(Surface _dest, FILE *_input, RFileHeader &_header, 
             const char *_name)
{
   D3DSURFACE_DESC d3dsd;
   D3DLOCKED_RECT locked;
   BYTE *lpSurface;
   long pitch;
   DWORD dwWidth, dwHeight;         // rozmery z hlavicky
   DWORD x,y,width,height,offset;   // rozmery textury
   DWORD bitCount = 32;
   D3DFORMAT format;
   BYTE r,g,b, raster,graster;
   int counter;
   BYTE byGBits = 6;
   
   // predam rozmery z hlavicky
   dwWidth = _header.dwWidth;
   dwHeight = _header.dwHeight;
   
   // zjisteni parametru surfacu
   _dest->GetDesc(&d3dsd);
   width = d3dsd.Width;
   height = d3dsd.Height;
   format = d3dsd.Format;
   if (format == D3DFMT_R8G8B8) bitCount = 24;
   else if (format == D3DFMT_A8R8G8B8) bitCount = 32;
   else if (format == D3DFMT_A1R5G5B5) 
   { 
      bitCount = 15;
      byGBits = 5;
   }
   else if (format == D3DFMT_A4R4G4B4) bitCount = 12; // Co s tim???
   else if (format == D3DFMT_R5G6B5) bitCount = 16;
   
   // test velikosti surface
   if (width < dwWidth || height < dwHeight)
   {
      _dest->UnlockRect();
      fclose(_input);
      sprintf(exc_string,"LoadR24: Picture won't fit into texture!",_name);
      throw new Exception(exc_string);
   }
   
   /*
   if (dx8.d3ddm.bpp < 16)
   {
   fclose(_input);
   throw new Exception("LoadR24: Unsupported display mode");
   }
   */
   
   // zamceni surface
   dx8.LockSurface(_dest, &locked, NULL, 0);
   lpSurface = (BYTE *)locked.pBits;
   pitch = locked.Pitch;
   
   // jaky typ (komprese) souboru to je? 
   if (_header.byType > 0)
   {
      // --- komprimovane !!!
      counter = 0;
      BYTE d1, d2, d3;
      BYTE rr, gg, bb;
      BYTE off;
      BYTE dif, dif2;
      r = 0;
      g = 0;
      b = 0;
      
      y = 0;
      while (y < dwHeight)
      {
         offset = y*pitch;
         x =0;
         while (x < dwWidth)
         {
            // OutputDebugString(".\n");
            // jestli je neco v potadle, tak to jenom zopakuju a jdu dl
            if (counter>0)
            {
               counter--;
            }
            else
            {
               // jinak budu natat dal data
               fread(&d1,1,1,_input);
               
               // 8 bitove id
               if (d1==0x10)  // 0001000 RRRRRRRR GGGGGGGG BBBBBBBB
               {
                  // 4B barva
                  fread(&r,1,1,_input);
                  fread(&g,1,1,_input);
                  fread(&b,1,1,_input);
               }
               
               // 6 bitove id
               else if ((d1&0xfc)==0x0c) // 000011-- --------
               {
                  // 2B opakovani
                  fread(&d2,1,1,_input);
                  
                  counter = (d1&3);
                  counter <<= 8;
                  counter |= d2;
                  counter += 12;  //nebo 13?
               }
               else if ((d1&0xfc)==0x08) // 000010-- 
               {
                  // 1B opakovani (+9)
                  counter = (d1&3);
                  counter += 8;  //nebo 9?
               }
               
               // 5 bitove id
               else if ((d1&0xf8)==0x18) // 00011RGB
               {
                  // 3bitova barva
                  if (d1&4) r = 255;
                  else r = 0;
                  if (d1&2) g = 255;
                  else g = 0;
                  if (d1&1) b = 255;
                  else b = 0;
               }
               else if ((d1&0xf8)==0x10) // 00010RGB
               {
                  // 3bitova pulbarva
                  if (d1&4) r = 128;
                  else r = 0;
                  if (d1&2) g = 128;
                  else g = 0;
                  if (d1&1) b = 128;
                  else b = 0;
               }
               else if ((d1&0xf8)==0) // 00000---
               {
                  // 1B opakovani
                  counter = (d1&7);
                  //counter --;
               }
               
               // 3 bitove id
               else if ((d1&0xe0)==0x20) // 001rrrrr rrgggggg gbbbbbbb
               {
                  // 3B diference
                  fread(&d2,1,1,_input);
                  fread(&d3,1,1,_input);
                  off = 64;
                  
                  dif = (d1 & 0x1f);
                  dif <<= 2;
                  dif2 = (d2 & 0xc0);
                  dif2 >>=6;
                  dif |= dif2;
                  r += (dif - off);
                  
                  dif = (d2&0x3f);
                  dif <<= 1;
                  dif2 = (d3&0x80);
                  dif2 >>=7;
                  dif |= dif2;
                  g += (dif - off);
                  
                  dif = (d3&0x7f);
                  b += (dif - off);
               }
               
               // 2 bitove id
               else if ((d1&0xc0)==0x40)  // 01rrggbb
               {
                  // 1B diference
                  off = 1;
                  
                  dif = (d1&0x30);
                  dif >>= 4;
                  r += (dif - off);
                  
                  dif = (d1&0xc);
                  dif >>= 2;
                  g += (dif - off);
                  
                  dif = (d1&3);
                  b += (dif - off);
               }
               
               // 1 bitove id
               else if ((d1&128)==128) // 1rrrrrgg gggbbbbb
               {
                  // 2B diference
                  fread(&d2,1,1,_input);
                  off = 16;
                  
                  dif = (d1&0x7c);
                  dif >>= 2;
                  r += (dif - off);
                  
                  dif = (d1&3);
                  dif <<= 3;
                  dif2 = (d2&0xe0);
                  dif2 >>= 5;
                  dif |= dif2;
                  g += (dif - off);
                  
                  dif = (d2&0x1f);
                  b += (dif - off);
               }
               
               else OutputDebugString("x");
               
        }
        
        // experimenty
        //r = x;
        //g = y;
        //b = 0;
        // kadopdn zapu pixel (na sprvnou pozici a ve sprvn bitov hloubce)
        // (osetrene je 565, 4444, 888 a 8888)
        if (bitCount == 16)
        {
           // RASTROVN
           raster = 0;
           if ((y&1)==1) raster += 2;
           if (((x+y)&1)==1) raster += 4;
           // pro zelenou je treba raster vetvit
           if (byGBits == 6) graster = (raster >> 1);
           else graster = raster;
           if (raster <= (255-r)) rr = r + raster;
           else rr = 255;
           if (graster <= (255-g)) gg = g + graster;
           else gg = 255;
           if (raster <= (255-b)) bb = b + raster;
           else bb = 255;
           
           *(WORD *)(lpSurface+offset) = (WORD) 
              ((rr>>3) << (byGBits+5))+
              ((gg>>(8-byGBits)) << 5)+
              (bb >> 3);
           offset += 2;
        }
        else if (bitCount == 12)
        {
           // RASTROVN
           raster = 0;
           if ((y&1)==1) raster += 4;
           if (((x+y)&1)==1) raster += 8;
           if (raster <= (255-r)) rr = r + raster;
           else rr = 255;
           if (raster <= (255-g)) gg = g + raster;
           else gg = 255;
           if (raster <= (255-b)) bb = b + raster;
           else bb = 255;

           // AR GB
           *(WORD *)(lpSurface+offset) = (WORD) 
              ( 0xf000 | ((rr&0xf0)<<4) | (gg&0xf0) | ((bb&0xf0)>>4));
           offset += 2;
        }
        else if (bitCount == 24)
        {
           lpSurface[offset] = b;    //b
           lpSurface[offset+1] = g;  //g
           lpSurface[offset+2] = r;  //r
           offset += 3;
        }
        else
        {
           lpSurface[offset] = b;    //b
           lpSurface[offset+1] = g;  //g
           lpSurface[offset+2] = r;  //r
           lpSurface[offset+3] = 255;// alfu zatim na max
           offset += 4;
        }
        x++;
      }
      y++;
    }
  }
  else
  {
     // --- nekomprimovane
     for (y = 0; y < dwHeight; y++)
     {
        offset = y*pitch;
        for (x = 0; x < dwWidth; x++)
        {
           fread(&r,1,1,_input);
           fread(&g,1,1,_input);
           fread(&b,1,1,_input);
           if (bitCount == 16)
           {
              // RASTROVN
              raster = 0;
              if ((y&1)==1) raster += 2;
              if (((x+y)&1)==1) raster += 4;
              // pro zelenou je treba raster vetvit
              if (byGBits == 6) graster = (raster >> 1);
              else graster = raster;
              if (raster <= (255-r)) r+=raster;
              else r = 255;
              if (graster <= (255-g)) g+=graster;
              else g = 255;
              if (raster <= (255-b)) b+=raster;
              else b = 255;
              
              *(WORD *)(lpSurface+offset) = (WORD) 
                 ((r>>3) << (byGBits+5))+
                 ((g>>(8-byGBits)) << 5)+
                 (b >> 3);
              offset += 2;
           }
        else if (bitCount == 12)
        {
           // RASTROVN
           raster = 0;
           if ((y&1)==1) raster += 4;
           if (((x+y)&1)==1) raster += 8;
           if (raster <= (255-r)) r+=raster;
           else r = 255;
           if (graster <= (255-g)) g+=graster;
           else g = 255;
           if (raster <= (255-b)) b+=raster;
           else b = 255;

           // AR GB
           *(WORD *)(lpSurface+offset) = (WORD) 
              ( 0xf000 | ((r&0xf0)<<4) | (g&0xf0) | ((b&0xf0)>>4));
           offset += 2;
        }
           else if (bitCount == 24)
           {
              lpSurface[offset] = b;    //b
              lpSurface[offset+1] = g;  //g
              lpSurface[offset+2] = r;  //r
              offset += 3;
           }
           else
           {
              lpSurface[offset] = b;    //b
              lpSurface[offset+1] = g;  //g
              lpSurface[offset+2] = r;  //r
              lpSurface[offset+3] = 255;
              offset += 4;
           }
        }
     }
  }
  
  // ALFA KANAL!
  // ted prisla na radu starost o alfu
  if (_header.byAlpha>0 && _header.byAlpha<=2 && (bitCount == 12 || bitCount == 32)) 
  {
     // nactu si id ALF (jestli jsem na spravnem miste)
     fread(&r,1,1,_input);
     fread(&g,1,1,_input);
     fread(&b,1,1,_input);
     if (r != 'A' || g != 'L' || b != 'F')
     {
        _dest->UnlockRect();
        fclose(_input);
        sprintf(exc_string,"LoadR24: Can't read alfa channel!",_name);
        throw new Exception(exc_string);
     }
     
     // tak jo - alfa tam je, ale jaka?
     if (_header.byAlpha==1)
     {
        // nekomprimovana alfa, pohoda (totiz mela by byt)
        for (y = 0; y < dwHeight; y++)
           //for (y = 0; y < 10; y++)
        {
           //*** tady by to asi chtelo resit i pro teoreticky vyskyt jinych formatu
           if (bitCount == 12)
           {
              offset = y*pitch + 1;
           }
           else
           {
              offset = y*pitch + 3;
           }
           for (x = 0; x < dwWidth; x++)
           {
              // proste nactu bajt a ulozim ho jako alfu
              fread(&r,1,1,_input);
              if (bitCount == 12)
              {
                 (lpSurface[offset] &= 0xf)|= (r&0xf0);
                 offset += 2;
              }
              else
              {
                 lpSurface[offset] = r;
                 offset += 4;
              }
           }
        }
     }
     else
     {
        // komprimovana alfa, to bude tuzsi
        r = 0;    // hodnota alfy
        counter = 0;
        y = 0;
        while (y < dwHeight)
        {
           if (bitCount == 12)
           {
              offset = y*pitch + 1;
           }
           else
           {
              offset = y*pitch + 3;
           }
           x =0;
           while (x < dwWidth)
           {
              // je neco v pocitadle opakovani?
              if (counter>0)
              {
                 // takze alfa se nemeni
                 counter--;
              }
              else
              {
                 // ctu dalsi bajt ze souboru
                 fread(&g,1,1,_input);
                 
                 // tak co se nacetlo?
                 if (g == 1)
                 {
                    // je to ESC znacka! nejaky extra pripad!
                    fread(&b,1,1,_input);
                    if (b == 0)
                    {
                       // je to proste alfa 01
                       r = 1;
                    }
                    else
                    {
                       // je to pocet opakovani (+2, ale jedno se hned pouzije)
                       counter = b;
                       counter ++;
                    }
                 }
                 else
                 {
                    // je to jen nudna hodnota alfy =)
                    r = g;
                 }
              }

              // ulozim hodnotu alfy do surfacu
              if (bitCount == 12)
              {
                 (lpSurface[offset] &= 0xf)|= (r&0xf0);
                 offset += 2;
              }
              else
              {
                 lpSurface[offset] = r;
                 offset += 4;
              }
              x++;
           }
           y++;
        }
     }
  }
  
  // hotovo - takze balime
  _dest->UnlockRect();
  fclose(_input);
}

