//************************************************************************
//                            Bublifuk class                              
//************************************************************************
//  Written by : Vojvo, Gunny
//  Language   : VisuC6 + DX6.1
/* changes:
	2011-09-04 / opraveno vykreslovn HD grafiky
   2008-06-22 / vude jsou jen solibbubbles
   0.10.1 - zvuky stereo
*/

#include "utils.h"
#include "gs_game.h"
#include "dx8graph.h"
#include "wsound.h"
#include "sprites.h"

#define BUBBLING 128
#define NO_SYM   128

//---------------------------------------------------------------------------
Bublifuk::Bublifuk(int onx, int ony, Property *prop)
{
   gfx = prop->surf;
   state = 0;
   to_fuq = 0;
   fTgs = prop->fTgs;
   x = onx;
   y = ony;
   xsize = prop->xsize;
   ysize = prop->ysize;
   bubble = NULL;
}

//--------------------------------------------------------------------------
void Bublifuk::Paint()
{
	// vykreslovn se dl njakm hnusem =]
	// zd se, e bublifuk existuje pouze jako soust nov vytven symbolov bubliny
   if (state & BUBBLING)
      bubble->Paint();
}

//--------------------------------------------------------------------------
void Bublifuk::jumpNext()
{
   if (state & BUBBLING)
      bubble->jumpNext();
}

//--------------------------------------------------------------------------
void Bublifuk::Action()
{
   if (state & BUBBLING)
   {
		// bublina je hotov
      if (bubble->frames.looped)
      {
         bubble->frames.looped = false;
         state ^= BUBBLING;
         to_fuq--;

         if (ARRAY_FULL(symbubs_ctrl))
         {
            delete bubble;
         }
         else
         {
            ARRAY_ADD(symbubs,symbubs_ctrl,bubble);
            bubble->movex = FUQSTRENGTH_STATIC - random(FUQSTRENGTH_DYNAMIC);
            bubble->movey = FUQSTRENGTH_STATIC - random(FUQSTRENGTH_DYNAMIC);
            bubble->frames.setChain(CHAIN_STAND);
            bubble->mask = NULL; // ru se grafika bublifuku
         }
         bubble = NULL;
      }
   }
   else
   {
		// jest m pod za kol vyrobit njak bubliny
      // je co foukat a je co pit
      if (to_fuq > 0)
      {
         int ns = random(1000);
         if (ns > 900) ns = 3;
         if (ns > 700) ns = 2;
         if (ns > 400) ns = 1;
         if (ns > 3) ns = 0;
         bubble = new SymbolBubble(x,y,properties.member[ID_SOLIDBUBBLEW],ns);
         sound_device->Play(0,x+20);
         bubble->mask = gfx;	// nastavuje se grafika bublifuku
         bubble->frames.setDirection(DIR_L);
         bubble->direction = DIR_L;
         bubble->frames.setChain(CHAIN_RELEASE);
         state |= BUBBLING;
      }
   }
}
