/**************************************************************************
//                                Hiscore                                   
//*************************************************************************
// Written by : Gunny & Vojvo
// Language   : VisuC6 + DX6.1
// Version    : 1.0.1
// Last update: 14.4.2000
//*************************************************************************

   CHANGES:
	2010-10-25 / upraveno pro Bub15

	1.0.1 - snaha o prvni plnou verzi
	0.9.4 - prvni verze

*/

#include <stdio.h>
#include <string.h>
#include "utils.h"
#include "topper.h"

#define TOPFILE         "Toppers.hsc"

Toppers *toppers = NULL;

//=========================================================================
//-------------------------------------------------------------------------
//                                  Topper
//-------------------------------------------------------------------------
//=========================================================================

//-------------------------------------------------------------------------
// default konstruktor
//-------------------------------------------------------------------------
Topper::Topper()
{
   score= 42; // =)
   *name = 0;
   colormask = 0xffffffff;
   newone = false;
}

//-------------------------------------------------------------------------
// konstruktor s parametry
//-------------------------------------------------------------------------
Topper::Topper(char * n, long s, DWORD color)
{
   strcpy(name,n);
   score = s;
   colormask = color;
   newone = false;
}

//-------------------------------------------------------------------------
// destruktor
//-------------------------------------------------------------------------
Topper::~Topper()
{
}

//=========================================================================
//-------------------------------------------------------------------------
//                                 Toppers
//-------------------------------------------------------------------------
//=========================================================================
//-------------------------------------------------------------------------
// konstruktor
//-------------------------------------------------------------------------
Toppers::Toppers()
//vsechno vynuluje a vyNULLuje =)
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      //data[i] = NULL;
      data[i] = new Topper();
   }
	offs = 0;
}

//-------------------------------------------------------------------------
// destruktor
//-------------------------------------------------------------------------
Toppers::~Toppers()
//co je neNULLove, dealokuje
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      SAFE_DELETE(data[i]);
   }
}

//-------------------------------------------------------------------------
// vola se, kdyz neexistuje soubor 
//-------------------------------------------------------------------------
void Toppers::New()
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      strcpy(data[i]->name,"Eriador");
      data[i]->score = (TOP_MAXTOP-i)*500;
      data[i]->colormask = 0xffffffff; // lut 0xffffff00
   }
   strcat(data[0]->name," =)");
   data[0]->score = 100000L;
}

//-------------------------------------------------------------------------
//dvojzvratny xor kod =) 
//-------------------------------------------------------------------------
void cood(char * to, char * from)
{
   while (*from)
   {
      *to=(*from ^ 128);
      from++;
      to++;
   }
   *to=0;
}

//-------------------------------------------------------------------------
// clearuje priznak novych polozek toppers
//-------------------------------------------------------------------------
void Toppers::clearNew()
{
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      if (data[i]->newone)
      {
         data[i]->newone = false;
         //data[i]->colormask = 0xffffffff; // barvu bych mohl nechat
      }
   }
	offs = 0;
}

//-------------------------------------------------------------------------
// snazi se naloadit score ze souboru
//-------------------------------------------------------------------------
int Toppers::Load()
{
   FILE *hisc;
   char cod[TOP_NAMELEN];
   if ((hisc = fopen(TOPFILE, "rb")) == NULL)
      return 43;
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      fread(cod, TOP_NAMELEN, 1, hisc); //jmeno
      cood(data[i]->name,cod);
      if (!fread(&data[i]->score, 4, 1, hisc)) //score
      {//pokud neco neklaplo
         data[i]->score = TOP_MAXTOP-i;
         data[i]->colormask = 0xffffffff;
      }
     //data[i]->colormask = (0xff000000 | (i*101193)); //*** debug hack
   }
//data[1]->newone = true; //***debughack
   fclose(hisc);
   return 0;
}

//-------------------------------------------------------------------------
// ulozi do souboru
//-------------------------------------------------------------------------
int Toppers::Save()
{
   FILE *hisc;
   char cod[TOP_NAMELEN];
   if ((hisc = fopen(TOPFILE,"wb")) == NULL)
   {
      return 42;
   }
   for (int i=0; i<TOP_MAXTOP; i++)
   {
      cood(cod,data[i]->name);
      fwrite(cod, TOP_NAMELEN, 1, hisc); //jmeno
      fwrite(&data[i]->score, 4, 1, hisc); //score
   }
   fclose(hisc);
   return 0;
}

//-------------------------------------------------------------------------
// snazi se zaradit zadany vykon do tabulky
//-------------------------------------------------------------------------
int Toppers::Ins(char *name, long score, DWORD color)
{
   Topper * tp;
   int i = TOP_MAXTOP - 1;
   int res=0;
   if (data[i]->score<=score)
   {
      data[i]->score = score;
      data[i]->colormask = color;
      data[i]->newone = true;
      strcpy(data[i]->name,name);
      while ((i>0) && (data[i]->score > data[i-1]->score))
      {
         res=1;
         tp=data[i];
         data[i]=data[i-1];
         data[i-1]=tp;
         i--;
      }
   }
   return res;
}

